#!/usr/bin/env python

from twisted.python import log as logging
from exceptions import *
from basics import *
from numpy.core.numerictypes import *
import numpy
from scipy.special import *
from numpy.oldnumeric.mlab import diff
from Mestimators import *
from sets import Set
import time
from VTKHelperFunctions import *
from FITS import *
from pgplot import *
from masks import *
import cPickle, getpass
#from TwistedHub import TwistedTask, EvalTask, HubDispatch, reactor, defer, AddManhole
#from TwistedHub import task, failure
from TwistedHub import *
from FunctionMarshal import *
from SimpleQueue import *
from multiprocessing import Process
from Wavelets import *
#from ReadSex import *
from DictionaryOps import *
import uuid
from numexpr import evaluate

from FourCLiftDB import *
from FourCLiftHelpers import *
from FourCLiftProcess import *
from FourCLiftWatcher import *

class RunThroughTargets:
    def __init__(self,DataDirs,nobjs,nfilt,DoFirst,DoSecond,mport=8022,hport=7022,tvport=7070,\
             first=0,second=0,flat=0,pupil=0,going=0,auto=0,darks=0,fclass=newfirm,nume=3,NP=0,\
             HUBS=[],maxrun=1,maxrun2=999):
        self.curdir = os.getcwd()
        self.HUBS = HUBS
        if HUBS: self.HUB = self.HUBS[0]
        else: self.HUB = None
        self.nobjs = nobjs
        self.nfilt = nfilt
        self.pupil = pupil
        self.maxrun = maxrun
        self.maxrun2 = maxrun2
        self.psets = {}
        self.hsets = {}
        self.datadirs = DataDirs
        if self.datadirs: self.pdatadir = self.datadirs[0]
        else: self.pdatadir = None
        self.fclass = fclass
        self.basedir = os.getcwd()+"/"
        self.targ = None
        self.darks = darks
        self.groups = {}
        self.going = going
        self.auto = auto
        self.okay = True
        self.flat = flat
        self.first = first
        self.second = second
        self.targs = [None]
        self.targdirs = {}
        self.DoFirst = DoFirst
        self.DoSecond = DoSecond
        self.Data1 = {}
        self.Data2 = {}
        self.status = {}
        self.already = {1:{},2:{}}
        self.Filters = {}
        self.nfiles = {}
        for ddir in self.datadirs: self.nfiles[ddir] = 0
        self.nume = nume
        self.left = []
        self.left1 = []
        self.left2 = []
        self.priorities = {None:0}
        self.watchers = {}
        self.NP = NP
        namespace = globals()
        namespace["Runner"] = self
        self.namespace = namespace
        self.tvport = tvport
        print "Opening ssh on",mport
        self.hport = hport
        self.manhole = AddManhole(getpass.getuser(),"",namespace,mport)
        twisted_import("FourCLiftProcess","*")

    def OffloadHub(self):
        machines = ["localhost"]
        print "Using nodes"
        print machines
        print self.hport
        self.offloadHUB = TwistedHub([],quiet=0,verb=0,clean=0,wait=1,norun=0,standalone=0,stayalive=1,\
             user=getpass.getuser(),listen=self.hport-22,sshport=self.hport,modules=[],fmodules=[],\
             machines=machines,nice=5, sleeptime=0.01,namespace=globals(),auth=0)

    @defer.inlineCallbacks
    def Offload(self,ttask):
        self.offloadHUB.append(ttask)
        def W():
            while not hasattr(ttask,"result"):
                 time.sleep(0.01)
                 yield
        co = task.cooperate(W())
        yield co.whenDone()
        raise StopIteration(task.result[3])

    def StartSite(self):
        LoadWatcher()
        self.site = appserver.NevowSite(FourCLiftMainPage(runner=self))
        self.application = service.Application("FourCLift TV")
        self.tvlisten = reactor.listenTCP(self.tvport,self.site)

    def RestartSite(self):
        d = defer.Deferred()
        if hasattr(self,"tvlisten"):
           d.addCallback(lambda result: self.tvlisten.stopListening())
        d.addCallback(lambda result: reactor.callFromThread(self.StartSite))
        d.callback(True)

    def Fire(self):
        self.running = 0
        self.running1 = 0
        self.running2 = 0
        self.perform = []
        self.perfdict = {}
        self.ntargs = 0
        self.rcall = 0
        self.leftr = {}
        self.leftr = {0:None,1:None,2:None}
        self.inleft = {0:0,1:0,2:0}
        self.rstart = time.time()
#        reactor.callLater(0.1,self.OffloadHub)
        reactor.callLater(0.1,self.StartSite)
        reactor.callLater(1.1,self.CollateCheck)
        reactor.callLater(1.1,self.Already)
        reactor.callLater(2.1,self.Run)

    def TickOne(self,watcher,f0,ifile,c):
        b = os.path.basename(f0).replace(".fits","c%d.jpg" % (c))
        j1 = "jpegs/"+b
        j = self.basedir+"/jpegs/"+b
        if self.fclass == "fourstar": f = f0.replace(".fits","c%d.fits" % (c))
        elif self.fclass == "newfirm": f
        print j1,os.getcwd()
        if os.path.exists(f):
           F = FITS(f)
           exptime = F["exptime"]
           if self.fclass == "newfirm":
              ncoadd = F["ncoadd"]
              if ncoadd == "N/A": ncoadd = 1
              F.goto(1+c)
           data = F.data()
           F.close()
           data = data[:2048,:2048]
           data = where(between(data,-1e24,1e24),data,0).astype(float32)
           os.makedirs(self.basedir+"/jpegs/")
           MakeThumbnail(data,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85,j=j)
#        reactor.callInThread(watcher.TickOneStep2,f,ifile,c,j1)
        reactor.callLater(0.1,watcher.TickOneStep2,f,ifile,c,j1)

    def CollateCheck(self):
        reactorStatus()
        if getattr(self,"collating",{}):
           print "Are we still collating?"
           print "I guess so!"
           reactor.callLater(10,self.CollateCheck)
           return
#        self.collateloop.stop()
        self.collating = {}
        zdirs = [datadir.replace("/"," ").strip().split(" ")[-1] for datadir in self.datadirs]
        for datadir in self.datadirs:
           self.collating[datadir] = True
           nfiles = len(os.listdir(datadir))
           if datadir not in self.nfiles: self.nfiles[datadir] = 0
           if nfiles == self.nfiles[datadir]:
              self.collating.pop(datadir)
        ds = {}
        if self.collating:
           def CollAll():
               for key in self.collating.keys():
                 d = self.CollateOne(key)
                 print key,d
                 yield d
           co = task.cooperate(CollAll())
           d = co.whenDone()
           d.addCallback(lambda result: self.Collate())
#           d.addCallback(lambda result: reactor.callLater(30,self.CollateCheck))
           d.addErrback(lambda reason: self.Problem(reason))
        reactor.callLater(10,self.CollateCheck)

#    @defer.inlineCallbacks
    def CollateOne(self,datadir):
        d = defer.Deferred()
        d.addCallback(lambda x: self.UpdateDir(datadir))
        d.addCallback(lambda x :self.CollateDir(datadir))
        d.addErrback(lambda reason: logging.err(reason))
        d.callback(True)
        return d
#        yield d

    @defer.inlineCallbacks
    def Collate(self,auto=-1):
        D1 = self.Data1.keys()
        D2 = self.Data2.keys()
        G1,M1,T1 = {},{},{}
        G2,M2,T2 = {},{},{}
        [G1.setdefault(d1,self.Data1[d1].ongoing) for d1 in D1]
        [M1.setdefault(d1,self.Data1[d1].mjd) for d1 in D1]
        [T1.setdefault(d1,self.Data1[d1].type) for d1 in D1]
        [G2.setdefault(d2,self.Data2[d2].ongoing) for d2 in D2]
        [M2.setdefault(d2,self.Data2[d2].mjd) for d2 in D2]
        [T2.setdefault(d2,self.Data2[d2].type) for d2 in D2]
        bc = yield BigCollate(self,self.auto,auto,self.targs,self.ntargs,\
                self.status,self.priorities,D1,G1,M1,T1,D2,G2,M2,T2)
        if bc:
           self.priorities,self.rpriorities = bc
           self.ntargs = len(self.priorities)
           if auto>-1: self.auto = auto

    @defer.inlineCallbacks
    def UpdateDir(self,datadir):
#        if datadir in self.collating: return
        zdir = datadir.replace("/"," ").strip().split(" ")[-1]
        nfiles = len(os.listdir(datadir))
        if nfiles == self.nfiles[datadir]:
           self.collating.pop(datadir)
        else:
           zodb = self.curdir+"/zodb/%sinfo.fs" % (zdir)
           if not os.path.exists(os.path.dirname(zodb)):
              print "Making",os.path.dirname(zodb)
              os.mkdir(os.path.dirname(zodb))
           self.nfiles[datadir] = nfiles
           if self.first or not os.path.exists(zodb):
              newfs = not os.path.exists(zodb)
              if newfs: print "Have to generate a ZODB for %d files." % (nfiles)
              d = UpdateZODB(datadir,zodb,newfs,verb=0,fclass=self.fclass)
              yield d
#              if newfs: print "Done generating the ZODB for %d files." % (nfiles)
#              PackZODB(zodb)

    @defer.inlineCallbacks
    def CollateDir(self,datadir):
        print datadir, self.collating
        if datadir in self.collating:
           self.nfiles[datadir] = len(os.listdir(datadir))
           zdir = datadir.replace("/"," ").strip().split(" ")[-1]
           zodb = self.curdir+"/zodb/%sinfo.fs" % (zdir)
           if not os.path.exists( self.curdir+"/zodb/"):
              os.mkdir(self.curdir+"/zodb/")
           storage = ZODB.FileStorage.FileStorage(zodb,read_only=False)
           zdb = ZODB.DB( storage)
           conn = zdb.open()
           dbroot = conn.root()
           plist = []
           print "Before CollateDB"
           yield CollateDB(dbroot,targ="",filt="",nume=self.nume,watching=True,fclass=self.fclass,read_only=False,plist=plist)
           print "After CollateDB"
           groups = copy.deepcopy(plist[0])
           targs = groups.keys()
           transaction.abort()
           conn.close()
           zdb.close()
           storage.close()
           targs = [targ for targ in targs if (groups[targ][0].type in ["flat","tflat","dark"]) or \
                (groups[targ][0].type in ["object"] and groups[targ][0].filter not in ["Dark"])]
           if datadir not in self.targdirs:
              self.targdirs[datadir] = {}
           [self.targdirs[datadir].setdefault(targ) for targ in targs]
           addtargs = []

           @defer.inlineCallbacks
           def GoTargs():
               def GoTargs2():
                   for targ in targs:
                       if targ not in self.targs and targ != "unknown":
                          filt = groups[targ][0].filter
                          uflat = groups[targ][0].type in ["flat","dark","tflat","dflat"]
                          if groups[targ][0].type in ["flat","tflat","dflat"]:
                             addit = True
                          elif groups[targ][0].type == "dark":
                             addit = True
                          elif 1 or filt in ["J","H","Ks"]:
                             addit = True
                          else:
                             addit = False
                          if self.nfilt and filt not in self.nfilt:
                             addit = False
                          if self.nobjs and not len([o for o in self.nobjs if o in targ]):
                             addit = False
                          if filt in ["undef"]: addit = False
                          if "flat" in targ and filt == "dark": addit = False
                          if addit:
                             uflat = "flat" in targ or "dark" in targ
                             t = groups[targ]
                             self.Filters[targ] = filt
                             self.Data1[targ] = self.DoFirst(datadir,targ,filt,uflat,groups[targ],None)
                             self.Data1[targ].mjd = groups[targ][0].mjd
                             self.Data1[targ].type = groups[targ][0].type
                             self.Data1[targ].dark = "dark" in targ
                             self.Data1[targ].paused = not self.going
                             self.Data1[targ].runner = self
                             jnos = Set([t.jno for t in groups[targ]])
                             if not self.Data1[targ].dark and "flat" not in targ and "_tmp" not in targ and len(jnos)>=25 and len(targ.split("_"))>=4:
                                s0 = targ.split("_")[-1]
                                s1 = targ.split("_")[-2]
                                s2 = targ.split("_")[-3]
                                s3 = "_".join(targ.split("_")[:-3])
#                                ftarg = "flat_%s_%s_%s_%s"%(s3,s0,s2,s1)
                                ftarg = "flat_obj%s_%s_%s_%s" % (s2,s1,s3,s0)
                                self.Data1[targ].makeflat = ftarg
                                if self.pupil and len(jnos)>=25:
                                   self.Data1[targ].makepupil = True
                             self.already[1][targ] = self.Data1[targ].Already(first=1,second=0)
                             self.Data1[targ].FirstPass()

                             self.Data2[targ] = self.DoSecond(datadir,targ,filt,uflat,groups[targ],None)
                             self.Data2[targ].mjd = groups[targ][0].mjd
                             self.Data2[targ].type = groups[targ][0].type
                             self.Data2[targ].dark = "dark" in targ
                             self.Data2[targ].paused = not self.going
                             self.Data2[targ].runner = self
                             self.already[2][targ] = self.Data2[targ].Already(first=0,second=1)
                             self.Data2[targ].SecondPass()

                             self.groups[targ] = groups[targ]
                             if targ not in self.priorities:
                                self.priorities[targ] = len(self.priorities)
                             addtargs.append(targ)
                       yield
               co = task.cooperate(GoTargs2())
               d = co.whenDone()
               yield d

           co = GoTargs()
           yield co

           if len(addtargs) and 0:
              print "New targets!"
              t = [0]
              [(t.append(t[-1]+1),sys.stdout.write("%4d %s\n" % (t[-1],targ))) for targ in addtargs if "dark" in targ]
              [(t.append(t[-1]+1),sys.stdout.write("%4d %s\n" % (t[-1],targ))) for targ in addtargs if "flat" in targ]
              [(t.append(t[-1]+1),sys.stdout.write("%4d %s\n" % (t[-1],targ))) for targ in addtargs if "dark" not in targ and "flat" not in targ]
           adddarks = []
           addflats = []
           addskies = []
           [adddarks.append(targ) for targ in addtargs if "dark" == targ[:4]]
           [addtargs.remove(targ) for targ in adddarks]
           [addflats.append(targ) for targ in addtargs if "flat" in targ]
           [addtargs.remove(targ) for targ in addflats]
           [addskies.append(targ) for targ in addtargs if "sky" in targ]
           [addtargs.remove(targ) for targ in addskies]
           if "unknown" in addtargs: addtargs.remove("unknown")
           self.targs += adddarks
           order = argsort([groups[targ][0].mjd for targ in addflats])
           self.targs += [addflats[o] for o in order]
           order = argsort([groups[targ][0].mjd for targ in addskies])
           self.targs += [addskies[o] for o in order]
           order = argsort([groups[targ][0].mjd for targ in addtargs])
           self.targs += [addtargs[o] for o in order]
           change = 0
           for targ in self.targs:
              if targ not in self.status:
                 if self.auto: self.status[targ] = True
                 else: self.status[targ] = False
#                 self.status[targ] = False
                 change = True
           self.collating.pop(datadir)

    def Problem(self,reason):
        logging.err(reason)

    def Left1(self,n=0):
        if n == 0:
           left = self.leftd0
           [self.left.remove(targ) for targ in self.left if targ not in left]
           [self.left.append(targ) for targ in left if targ not in self.left]
           jp = [(j,self.priorities[targ]) for j,targ in enumerate(self.left) if targ in self.priorities]
           if jp:
              j,p = transpose(jp)
              order = take(j,argsort(p))
              self.left = [self.left[j] for j in order]
           else:
              self.left = []

        if n in [1]:
           left1 = self.leftd1
           [self.left1.remove(targ) for targ in self.left1 if targ not in left1]
           [self.left1.append(targ) for targ in left1 if targ not in self.left1]
           jp = [(j,self.priorities[targ]) for j,targ in enumerate(self.left1) if targ in self.priorities and self.status.get(targ,False)]
           if jp:
              j,p = transpose(jp)
              order = take(j,argsort(p))
              vanilla = [o for o in self.left1 if not o or o+"_tmp" not in self.left1]
              self.left1 = [self.left1[j] for j in order if not self.left1[j] or not self.Data1[self.left1[j]].chain1.called]
           else:
              self.left1 = []

        if n in [2]:
           left2 = self.leftd2
           [self.left2.remove(targ) for targ in self.left2 if targ not in left2]
           [self.left2.append(targ) for targ in left2 if targ not in self.left2]
           jp = [(j,self.priorities[targ]) for j,targ in enumerate(self.left2) if targ in self.priorities and self.status.get(targ,False)]
           if jp:
              j,p = transpose(jp)
              order = take(j,argsort(p))
              self.left2 = [self.left2[j] for j in order if not self.left2[j] or not self.Data2[self.left2[j]].chain2.called]
           else:
              self.left2 = []

    def LeftA(self,n=0):
        self.inleft[n] += 1
#        def doterator():
        if 1:
            targs = self.priorities.keys()
            p = [self.priorities[targ] for targ in targs]
            targs = [targs[j] for j in argsort(p)]
            for targ in targs:
                 if targ:
                    nsub = getattr(self.Data1[targ].groups[0],"subgroups",0)
                    zdir = self.Data1[targ].zdir
                    lsub = len(map(os.path.basename,glob(self.basedir+"/Science/"+zdir+"/"+targ+"_tmp*/Shifts1_1.png")))
                    n0 = n == 0 and (not self.already[1][targ] or not self.already[2][targ])
                    n1 = n == 1 and not self.already[1][targ] and \
                               ("_tmp" in targ or ("_tmp" not in targ and nsub == lsub))
                    n2 = n == 2 and ("_tmp" not in targ and self.already[1][targ] and not self.already[2][targ])
#                    if n == 1 and targ in self.status and self.status[targ]=="True": print n,targ,n0,n1,n2, "_tmp" not in targ
                    if n0 or n1 or (n2 and "_tmp" not in targ):
                       getattr(self,"leftd"+str(n)).append(targ)
#                 yield None
#        return task.cooperate(doterator())
        return 1

    def DoneLeft(self,n):
        if n not in self.leftr or self.leftr[n] == None:
           reactor.callLater(1,self.DoneLeft,n)
           return
        self.Left1(n=n)
        self.leftr.pop(n)

    def Left(self,n=0):
        if n == 0:
           self.leftd0 = []
           c = self.LeftA(n=0)
           self.leftr[0] = c
           self.inleft[0] -= 1
        if n in [1]:
           self.leftd1 = []
           c = self.LeftA(n=1)
           self.leftr[1] = c
           self.inleft[1] -= 1
        if n in [2]:
           self.leftd2 = []
           c = self.LeftA(n=2)
           self.leftr[2] = c
           self.inleft[2] -= 1
        self.Left1(n=n)
        self.leftr.pop(n)

    def toggleGoing(self):
        self.going = not self.going
        for item in self.Data1:
            self.Data1[item].paused = not self.going
        for item in self.Data2:
            self.Data2[item].paused = not self.going

    def RunRun(self):
        print self.leftr
        r = time.time() - self.rstart
#        print "In RunRun! (%.3f)" % (r)
        if self.leftr != {}:
           reactor.callLater(1,self.RunRun)
           return
        reactor.callLater(1,self.Run)

    def Run(self):
        notNow = 0
        if len(self.HUBS)==1: self.nmax2 = self.maxrun-self.running1
        else: self.nmax2 = 1
#        print "In Run!"
#        print "In Run!"
#        print "In Run!"
        self.leftr = {0:None,1:None,2:None}
        self.inleft = {0:0,1:0,2:0}
        self.rcall += 1
        r = time.time() - self.rstart
#        print "In Run! (%.3f,%d,%.3f)" % (r,self.rcall,r/self.rcall)
        self.Left(0)
        self.Left(1)
        self.Left(2)

        n1 = len([o for o in self.left1 if o not in self.perform])
        n2 = len([o for o in self.left2 if o not in self.perform and o not in self.left1])
        og = [o for o in self.left1 if "dark" in o or "flat" in o]
        op = [o for o in self.perform if "dark" in o or "flat" in o]

#        if len(og)<self.maxrun and n2 and self.second and not n1: r2 = 1-self.running2
#        elif self.second and n2 and self.maxrun>1: r2 = 1
#        else: r2 = 0
#        if self.second and n2 and self.maxrun>1: r2 = 1
#        else: r2 = 0
        r2 = 0

        if self.going and self.running1 < (self.maxrun-r2-self.running2) and \
                self.first and len(self.left1) and \
                [o for o in self.left1 if o not in self.perform]:
           items = [item for item in self.left1 if self.status[item] and item not in self.perform]
           if op or og:
              ditems = [item for item in items if "dark" in item]
              fitems = [item for item in items if "flat" in item and \
                 ((hasattr(self.Data1[item],"btarg") and self.already[1][self.Data1[item].btarg]) or not hasattr(self.Data1[item],"btarg"))]
              items = ditems + fitems
#              print ditems
#              print fitems
#              print items
#              for item in fitems:
#                  print item
#                  atarg = getattr(self.Data1[item],"atarg",None)
#                  btarg = getattr(self.Data1[item],"btarg",None)
#                  print item, atarg, btarg,
#                  if atarg: print self.already[1][atarg],
#                  if btarg: print self.already[1][btarg],
#                  print
#              raw_input("wait")
#              os.exit(1)
           if items:
              item = self.Data1[items[0]]
              print "Used psets:",self.psets
              pset = [j for j in range(10) if j not in self.psets][0]
              if not self.HUBS or pset<=(len(self.HUBS)-1):
                 item.pset = pset
                 self.running += 1
                 self.running1 += 1
                 print "Using pset:",item.pset
                 self.psets[item.pset] = True
                 if len(self.HUBS):
                    self.AssignHub(item,first=1,second=0)
                    item.HUB = self.hsets[item.pset]
                 self.left1.remove(items[0])
                 self.perform.append(items[0])
                 self.perfdict[items[0]] = item
                 reactor.callLater(0.5,self.Spin,1,item)

        if len(self.HUBS) and len([o for o in self.left1 if o not in self.perform]): self.nmax2 = 1
        elif len(self.HUBS): self.nmax2 = self.maxrun-self.running1
        else: self.nmax2 = 1
        self.nmax2 = min([self.maxrun2,self.nmax2])

        if not len(og) and not len(op) and self.going and self.running2 < self.nmax2 and \
                self.second and len(self.left2) and \
                [o for o in self.left2 if o not in self.perform]:
           items = [item for item in self.left2 if self.status[item] and item not in self.perform]
           if items:
              item = self.Data2[items[0]]
              print "Used psets:",self.psets
              pset = [j for j in range(10) if j not in self.psets][0]
              if not self.HUBS or pset<=(len(self.HUBS)-1):
                 item.pset=pset
                 self.running += 1
                 self.running2 += 1
                 print "Using pset:",item.pset
                 self.psets[item.pset] = True
                 if len(self.HUBS):
                    self.AssignHub(item,first=0,second=1)
                    item.HUB = self.hsets[item.pset]
                 self.left2.remove(items[0])
                 self.perform.append(items[0])
                 self.perfdict[items[0]] = item
                 reactor.callLater(0.5,self.Spin,2,item)

        reactor.callLater(3,self.Run)
        return

    @defer.inlineCallbacks
    def Already1(self):
        def Go():
            for targ in self.Data1.keys():
                self.already[1][targ] = self.Data1[targ].Already(first=1,second=0)
                yield
        co = task.cooperate(Go())
        yield co.whenDone()

    @defer.inlineCallbacks
    def Already2(self):
        def Go():
           for targ in self.Data2.keys():
               self.already[2][targ] = self.Data2[targ].Already(first=0,second=1)
               yield
        co = task.cooperate(Go())
        yield co.whenDone()

    def Already(self):
        d = defer.Deferred()
        d.addCallback(lambda x: self.Already1())
        d.addCallback(lambda x: self.Already2())
        d.addCallback(lambda x: reactor.callLater(2,self.Already))
        threads.deferToThread(d.callback,True)
        return d
#        reactor.callLater(1,self.Already)

    def AssignHub(self,item,first,second):
        print "Assign hub....",
        if len(self.HUBS) > 1:
           for h in self.HUBS:
               if h not in self.hsets.values():
                    self.hsets[item.pset] = h
                    break
           print "Using hub",h
        elif len(self.HUBS) == 2 and first:
            self.hsets[item.pset] = self.HUBS[0]
        elif len(self.HUBS) == 2 and second:
            self.hsets[item.pset] = self.HUBS[1]
        elif len(self.HUBS) == 1:
            self.hsets[item.pset] = self.HUBS[0]
        print "Using hub",self.hsets[item.pset]

    def SetupHub(self,s,item):
        machines = [(":" not in machine and [machine,"1"] or machine.split(":")) for machine in self.HUB.split(",")]
        double = 1
        machines = [machine[0] for machine in machines for j in range(int(double*int(machine[1])))]
        print "Using nodes"
        print machines
        namespace = {}
        for g,v in globals().items():
           namespace[g] = v
        namespace["Runner"] = self
        item.HUB = TwistedHub([],quiet=0,verb=0,clean=0,wait=1,norun=0,standalone=0,stayalive=1,user=getpass.getuser(),\
             listen=9000+s,sshport=self.hport+s,modules=[],fmodules=[],machines=machines,nice=5,\
             sleeptime=0.01,namespace=namespace,auth=0)
        item.LHUB = "localhost:"+str(9000+s)

    @defer.inlineCallbacks
    def Spin(self,s,item):
        print "Check if we can spin for %d!" % (item.pset)
        if hasattr(item,"HUB") and (not item.HUB or "," not in item.HUB):
           print "Set up the data for pass %d for %d!" % (s,item.pset)
           if s == 1:
               item.FirstPass()
               chain = item.chain1
           elif s == 2:
               item.SecondPass()
               chain = item.chain2
           item.hport = self.hport + item.pset
           print "Start running through the data for pass %d!" % (item.pset)
#           bd = defer.Deferred()
#           bd.addCallback(lambda x: chain.callback(True))
#           threads.deferToThread(chain.callback,True)
           reactor.callLater(0.1,chain.callback,True)
           print chain
           yield chain
           print chain
#           d = self.RunItem(item,chain)
#           print d
#           yield d
           print "Done running through the data for pass %d!" % (item.pset)
           print chain
           self.running -= 1
           if s == 1: self.running1 -= 1
           elif s == 2: self.running2 -= 1
           self.perform.remove(item.targ)
           self.perfdict.pop(item.targ)
#           self.already[s][item.targ] = item[item.targ].Already(first=(s==1),second=(s==2))
           if item.pset in self.hsets:
              self.hsets.pop(item.pset)
           if item.pset in self.psets:
              self.psets.pop(item.pset)
        else:
           if not hasattr(item,"HUB") or not isinstance(item.HUB,TwistedHub):
              print "No hub yet for %d!" % (item.pset)
              time.sleep(1.0)
#              reactor.callInThread(self.SetupHub,item.pset,item)
              reactor.callLater(0.1,self.SetupHub,item.pset,item)
              print "Go back and check on hub for %d!" % (item.pset)
              time.sleep(1.0)
#              reactor.callInThread(self.Spin,s,item)
              reactor.callLater(0.1,self.Spin,s,item)
           elif hasattr(item.HUB,"TASKS") and len(item.HUB.TASKS) < len(item.HUB.machines) and not item.HUB.die:
              print "Cannot spin for %d yet!" % (item.pset)
              time.sleep(1.0)
#              reactor.callInThread(self.Spin,s,item)
              reactor.callLater(0.1,self.Spin,s,item)
           elif hasattr(item.HUB,"TASKS") and item.HUB.die:
              while item.HUB.TASKS:
                 time.sleep(1.0)
#                 reactor.callInThread(self.Spin,s,item)
#              else:
              print "Done terminating hub for pass %d for %d!" % (s,item.pset)
              self.perform.remove(item.targ)
              self.perfdict.pop(item.targ)
              if item.pset in self.hsets: self.hsets.pop(item.pset)
              if item.pset in self.psets: self.psets.pop(item.pset)
              item.HUB = self.HUB
              self.running -= 1
#              self.already[s][item.targ] = item[item.targ].Already(first=(s==1),second=(s==2))
              self.Left(s)
           elif hasattr(item.HUB,"TASKS") and len(item.HUB.TASKS) == len(item.HUB.machines) and not item.HUB.die:
              print "Set up the data for pass %d!" % (s)
              if s == 1: chain = item.FirstPass()
              elif s == 2: chain = item.SecondPass()
              item.hport = self.hport + item.pset
              print "Start running through the data for %s pass %d!" % (item.targ,s)
              yield chain
#              yield self.RunItem(item,chain)
              print "Done running through the data for %s pass %d!" % (item.targ,s)
              item.HUB.die=1
              time.sleep(1.0)
#              reactor.callInThread(self.Spin,s,item)
              reactor.callLater(0.1,self.Spin,s,item)
           else:
              time.sleep(1.0)
              print "Go back and spin."
#              reactor.callInThread(self.Spin,s,item)
              reactor.callLater(0.1,self.Spin,s,item)

    @defer.inlineCallbacks
    def Run1(self,item):
           print item.targ,item.pset
           d = threads.deferToThread(self.Spin,1,item)
           print item.targ,item.pset
           yield d
#           reactor.callInThread(self.Spin,1,item)

    @defer.inlineCallbacks
    def Run2(self,item):
           d = threads.deferToThread(self.Spin,2,item)
           yield d
#           reactor.callInThread(self.Spin,2,item)

    @defer.inlineCallbacks
    def RunItem(self,Item,Chain):
        if not Chain.called:
            d = threads.deferToThread(Chain.callback,True)
            yield Chain
#            if Chain.result is failure.Failure:
#               return -1
#        return 1

def BigCollate(runner,auto1,auto2,targs,ntargs,status,priorities,D1,G1,M1,T1,D2,G2,M2,T2):
    targs = targs
    if ntargs != len(targs) or auto1!=auto2:
       if auto2==-1: auto = auto1
       else: auto = auto2
       print "Reordering targets!"
       print "Number of new targets = ", len(targs)-ntargs
#       print len(targs)
       mlist = copy.copy(targs)
       slist = copy.copy(targs)
       plist = copy.copy(priorities)
       for targ in mlist:
          if targ and not ((targ in D1 and G1[targ]) or (targ in D2 and G2[targ])):
             plist.pop(targ)
             slist.remove(targ)
             priorities.pop(targ)
       tlist = {}
       for targ in mlist:
           if targ in D1: mjd = M1[targ]
           elif targ in D2: mjd = M2[targ]
           elif not targ: mjd = -999
#           print targ,mjd
           if mjd not in tlist: tlist[mjd] = []
           tlist[mjd].append(targ)
       [slist.append(o) for t in sort(tlist.keys()) for o in tlist[t] if o not in slist]
       tlist = []
       slist2 = []
       for targ in slist:
           if targ and targ[:3] == "obj":
              for targ2 in slist:
                  if targ2 and targ+"_tmp" in targ2:
                     tlist.append(targ2)
                     slist2.append(targ2)
           slist2.append(targ)
       slist = slist2
       if not plist:
          plist[None] = 0
       p = max(plist.values()) + 1
       print "starting priority",p
       for targ in slist:
          if targ not in plist:
             if (targ in D1 and T1[targ] == "dark") or (targ in D2 and T2[targ] == "dark"):
                 plist.setdefault(targ,p)
#                 print "DARK",targ,p
                 p += 1
       for targ in slist:
          if targ not in plist:
             if (targ in D1 and "flat" in targ and targ.split("_")[0][-1] == "B") or (targ in D2 and "flat" in targ and targ.split("_")[0][-1] == "B"):
                 plist.setdefault(targ,p)
                 p += 1
                 atarg = "%s%s_%s" % (targ.split("_")[0][:-1],"A",targ.split("_")[1])
#                 print targ,atarg
                 if atarg in slist:
                    runner.Data1[targ].atarg = atarg
#                    print "set atarg for",targ
#                 print targ,atarg,atarg in slist,runner.already[1][targ]
#                 print "FLAT",targ,p,atarg
                 if atarg in slist and atarg not in plist:
                    runner.Data1[atarg].btarg = targ
#                    print "set btarg for",atarg
                    plist.setdefault(atarg,p)
                    p += 1
       for targ in slist:
          if targ not in plist:
             if (targ in D1 and "flat" in targ and targ.split("_")[0][-1] == "A") or (targ in D2 and "flat" in targ and targ.split("_")[0][-1] == "A"):
                 btarg = "%s%s_%s" % (targ.split("_")[0][:-1],"B",targ.split("_")[1])
#                 print targ,btarg
                 if btarg in plist:
                    runner.Data1[targ].btarg = btarg
#                    print "set btarg for",targ
#                 print targ,btarg,btarg in plist,runner.already[1][btarg]
#                 if (btarg in plist and runner.already[1][btarg]) or btarg not in plist:
                 plist.setdefault(targ,p)
                 p += 1
#                 print "FLAT",targ,p
       for targ in slist:
          if targ not in plist:
             if (targ in D1 and "flat" in targ) or (targ in D2 and "flat" in targ):
                 plist.setdefault(targ,p)
#                 print "FLAT",targ,p
                 p += 1
       for targ in slist:
          if targ not in plist:
             if (targ in D1) or (targ in D2):
                 if targ[:3] == "obj" and ("sky"+targ[3:]) in slist:
                    plist.setdefault("sky"+targ[3:],p)
                    plist.setdefault(targ,p+1)
#                    print "OBJ,SKY",targ,p
                    p += 2
                 elif targ[:3] == "sky" and ("obj"+targ[3:]) in slist:
                    plist.setdefault(targ,p)
                    plist.setdefault("obj"+targ[3:],p+1)
#                    print "SKY,OBJ",targ,p
                    p += 2
                 else:
                    plist.setdefault(targ,p)
#                    print "OBJ",targ,p
                    p += 1
#       print len(slist),len(targs)
#       for targ in targs:
#           if targ not in slist: print targ
       for targ in slist:
           if targ not in priorities:
              priorities[targ] = plist[targ]
       rpriorities = {}
       [rpriorities.setdefault( priorities[targ], targ) for targ in targs]
       rk = rpriorities.keys()
       for p in argsort(rk):
           targ = rpriorities[rk[p]]
           if targ and status[targ]==False and auto: status[targ] = True
       ntargs = len(priorities)
       return priorities,rpriorities

def RunnerTable(R):
    k = R.rpriorities.keys()
    f = "%-50s %d %d %r"
    for i in argsort(k):
        targ = R.rpriorities[k[i]]
        if targ:
           print f % (targ,R.Data1[targ].current,R.Data2[targ].current,R.status[targ])

