
from FITS import *
from time import sleep
from numpy.oldnumeric import *
from numpy.core.numerictypes import *
import numpy
from string import *
from pgplot import *
from basics import *
from bisect import bisect
from Multipack import *
from numpy.oldnumeric.mlab import diff

def integrate(w, g, o, t, tu, w1, w2):
   if w[0] < w1 < w2 < w[-1]:
      xtck = splrep(w,arange(w.shape[0]),s=0,k=sk)
      x1,x2 = splev([w1,w2],xtck)
      tck = splrep(w,g,s=0,k=sk)
      f = splint(w1,w2,tck)/(w2-w1)
      r = power(o-t,2)
      stck = splrep(w,r,s=0,k=1)
      v = splint(w1,w2,stck)/(w2-w1)
      s = sqrt(v/(x2-x1))
      return f,s
   else:
      return 0.0,99.999


def Spandex(wave,spectrum,indgrid,tdata=None,odata=None):
    if tdata == None: tdata = spectrum
    if odata == None: odata = spectrum

    a1 = float(indgrid[3]); a2 = float(indgrid[4])
    b1 = float(indgrid[1]); b2 = float(indgrid[2])
    c1 = float(indgrid[5]); c2 = float(indgrid[6])
    ma = (a1+a2)/2; mb = (b1+b2)/2; mc = (c1+c2)/2

    fla, ela = integrate( wave, spectrum, odata, tdata, template, a1, a2)
    flc, elc = integrate( wave, spectrum, odata, tdata, template, c1, c2)

    continuum = fla*(mc-wave)/(mc-ma) + flc*(wave-ma)/(mc-ma)
    con1a = (fla+ela)*(mc-wave)/(mc-ma) + flc*(wave-ma)/(mc-ma)
    con1b = (fla-ela)*(mc-wave)/(mc-ma) + flc*(wave-ma)/(mc-ma)
    con2a = fla*(mc-wave)/(mc-ma) + (flc+elc)*(wave-ma)/(mc-ma)
    con2b = fla*(mc-wave)/(mc-ma) + (flc-elc)*(wave-ma)/(mc-ma)

    kern, ekern = integrate( wave, (spectrum/continuum), (odata/continuum), (tdata/continuum), template, b1, b2)
    k1a, ek1a= integrate( wave, (spectrum/con1a), (odata/con1a), (tdata/con1a), template, b1, b2)
    k1b, ek1b= integrate( wave, (spectrum/con1b), (odata/con1b), (tdata/con1b), template, b1, b2)
    k2a, ek2a= integrate( wave, (spectrum/con2a), (odata/con2a), (tdata/con2a), template, b1, b2)
    k2b, ek2b= integrate( wave, (spectrum/con2b), (odata/con2b), (tdata/con2b), template, b1, b2)

    if ekern == 99.999: bad = 1
    if ek1a == 99.999: bad = 1
    if ek1b == 99.999: bad = 1
    if ek2a == 99.999: bad = 1
    if ek2b == 99.999: bad = 1

    if bad:
       return -99.999,-9.999
    else:
       if type == "ew":
         value = (b2-b1)*(1-kern)
         ev1 = (k1a - k1b)/2
         ev2 = (k2a - k2b)/2
         err = (b2-b1)*sqrt(ev1**2+ev2**2+ekern**2)
       elif type == "mag":
         value = -2.5*log10(kern)
         ev1 = (k1a - k1b)/2
         ev2 = (k2a - k2b)/2
         err = 2.5*sqrt(ev1**2+ev2**2+ekern**2)/kern/2.303
       return value, err


