#!/usr/bin/env python

from twisted.python import log as logging
from exceptions import *
from basics import *
from numpy.core.numerictypes import *
import numpy
from scipy.special import *
from numpy.oldnumeric.mlab import diff
from Mestimators import *
from sets import Set
import time
from VTKHelperFunctions import *
from FITS import *
from pgplot import *
from masks import *
import cPickle, getpass
#from TwistedHub import TwistedTask, EvalTask, HubDispatch, reactor, defer, AddManhole
#from TwistedHub import task, failure
from TwistedHub import *
from FunctionMarshal import *
from SimpleQueue import *
from multiprocessing import Process
from Wavelets import *
#from ReadSex import *
from DictionaryOps import *
import uuid
import shutil
from numexpr import evaluate

from FourCLiftDB import *
from FourCLiftHelpers import *

IMPORTS = {}

FSFullWellGains = array([2.65,2.59,2.51,2.49])
FSLowNoiseGains = array([1.38,1.35,1.30,1.29])

JXY = {}
BADPD = {}
BADPN = {}
MASKD = {}
MASKN = {}
FLATD = {}
FLATN = {}
PUPLD = {}
PUPLN = {}
AREAD = {}
AREAD = {}
AREAN = {}
DARKD = {}
DARKN = {}
SKYFD = {}
SKYFN = {}
WDICT = {}

for p in range(10):
   BADPD[p] = {}
   BADPN[p] = {}
   MASKD[p] = {}
   MASKN[p] = {}
   FLATD[p] = {}
   FLATN[p] = {}
   PUPLD[p] = {}
   PUPLN[p] = {}
   AREAD[p] = {}
   AREAD[p] = {}
   AREAN[p] = {}
   DARKD[p] = {}
   DARKN[p] = {}
   SKYFD[p] = {}
   SKYFN[p] = {}
   WDICT[p] = {}

ZDBS = {}
STORAGES = {}

irdbfile = os.getenv("FourCLiftDB")
irtarget = os.getenv("FourCLiftTARG")
irfilter = os.getenv("FourCLiftFILTER")

def CopyFile(n1,n2,sky=0):
#    f1 = open(n1,"rb")
#    f2 = open(n2,"wb")
#    f2.write(f1.read())
#    f2.close()
#    f1.close()
    os.symlink(n1,n2)
    if 0 and sky and n2.split(".")[-1] == "fits":
       F = FITS(n2,readonly=0)
       F.modkey("xdiff1","N/A")
       F.modkey("ydiff1","N/A")
       F.modkey("mdiff1","N/A")
       F.modkey("lmatch1","N/A")
       F.close()

@defer.inlineCallbacks
def IRSetup( irdbfile,irtarg,irfilter,flat=False,fclass=newfirm,nume=3,FourCLiftDataset=[]):
   if flat and "flat" not in irtarg and "dome" not in irtarg and "dark" not in irfilter.lower() and "dark" not in irtarg: irtarget = "flat_"+irtarg
   else: irtarget = irtarg
   yield CollateDB(irdbfile,irtarg,irfilter,fclass=fclass,nume=nume,read_only=True,plist=FourCLiftDataset)
   print "TARGET=",irtarget
   if irtarget and os.path.basename(os.getcwd()) != irtarget:
      if "dark" in irtarget: irdir = "Darks/"
      elif "flat" in irtarget: irdir = "Flats/"
      else:
         irdir = "Science/"+os.path.basename(FourCLiftDataset[0].bdir)+"/"
#      if not os.path.exists(irdir):
#          os.makedirs(irdir)
      if not os.path.exists(irdir+irtarget):
          os.makedirs(irdir+irtarget)
      print irdir+irtarget
      wpars = glob("wavelets?.pars")
      links = [".Twisted","sex","apertures.dat"] + wpars
      ldir = os.listdir(irdir+irtarget)
      for l in links:
        if os.path.exists(l) and os.path.basename(l) not in ldir:
            print "Creating symlink to",l
            os.symlink(os.getcwd()+"/"+l,irdir+irtarget+"/"+os.path.basename(l))

SEXINTKEYS = ["NUMBER","VECTOR_ASSOC"]

def readsex(filename,verb=0):
   fu = open(filename,"r")
   icol = []
   keys = []
   fmts = []
   data = {}
   n=0
   for l in fu.xreadlines():
     if l[0] == "#":
       w = split(l)
       icol.append(int(w[1])-1)
       keys.append(w[2])
       if w[2] in SEXINTKEYS: fmts.append("%6d")
       elif w[2] == "FLAGS": fmts.append("%4d")
       elif w[2] == "CLASS_STAR": fmts.append("%5.2f")
       elif w[2] == "X_IMAGE": fmts.append("%9.3f")
       elif w[2] == "Y_IMAGE": fmts.append("%9.3f")
       else: fmts.append("%9.4f")
       data[w[2]] = []
       n+=1
     else:
       w = split(l)
       [data[keys[j]].append(w[j]) for j in range(n)]
   fu.close()
   if verb:
     print "Found Keys="
     print keys
     print "Number of Objects = %d" % ( len(data[keys[0]]))
   for k in keys:
     data[k] = array([[float,int][k in SEXINTKEYS](d) for d in data[k]])
   return data

class Exposure(flavors.Copyable):
   def __init__(self,N0):
      N = copy.copy(N0)
      self.N = N
      self.target = N.target
      self.fclass = N.fclass
      self.bad = N.bad
      self.objname = N.object
#      print "TARGET",self.target
#      print "OBJNAME",self.objname
      self.target = N.target
      self.obstype = N.type
      self.sky = N.sky
#      self.fits = N.info["Filename"]
      self.name = N.name.replace(".fits","")
      self.namec = N.name
      self.fits = N.bdir+"/"+N.base
      self.seq = N.seq
      self.lseq = N.lseq
#      self.lseq = 1
      if hasattr(N,"oloop"): self.oloop = map(Exposure,N.oloop)
      else: self.oloop = [self]
      if hasattr(N,"loop"): self.loop = map(Exposure,N.loop)
      else: self.loop = [self]
      self.bpath = os.path.basename(N.bdir)
      self.ra = N.ra
      self.dec = N.dec
      self.raoff = N.info["RAOFF"]
      self.decoff = N.info["DECOFF"]
      self.exptime = N.info["EXPTIME"]
      if self.fclass == "newfirm":
         self.noctim = N.info["NOCTIM"]
         self.ncoadd = N.info["NOCCOADD"]
         self.scale = 0.4
      elif self.fclass == "fourstar":
         self.noctim = N.info["EXPTIME"]
         self.ncoadd = 1
         self.ncoadd = len(self.loop)
         self.gain = N.info["GAIN"]
         self.gain = N.info["GAIN"]*len(self.loop)
         self.scale = 0.16
      else:
         self.scale = 0.2
         self.noctim = N.info["EXPTIME"]
         self.ncoadd = 1
      self.filter = N.info["FILTER"]
      self.mjd = N.info["MJD-OBS"]
      self.mastermjd = self.mjd
      self.base = N.base
#      if "image" in N.base:
#         self.expno = int(N.base.replace("image",""))
#      elif "raw" in N.base:
#         self.expno = int(N.base.replace("raw",""))
      self.expno = N.jno
      self.loopno = N.kno
      if "dark" in self.target:
         self.scratchspace = os.environ.get("SCRATCHSPACE",os.getcwd()+"/Darks/"+self.target)
      elif "flat" in self.target:
         self.scratchspace = os.environ.get("SCRATCHSPACE",os.getcwd()+"/Flats/"+self.target)
      else:
         self.scratchspace = os.environ.get("SCRATCHSPACE",os.getcwd()+"/Science/"+self.bpath+"/"+self.target)
#         print "dir=",self.scratchspace
      self.cache = False
      self.data = {}
      self.masks = {}
      self.sdata = {}
      self.lift = {}
      self.Bad()

   def __repr__(self):
      return "%s(%d/%d)[%d(%d)]" % (self.seq,self.lseq,len(self.loop),self.exptime,self.ncoadd)

   def scratch(self,f):
      if self.scratchspace:
         s=self.scratchspace+"/"
         easydir(s)
      else:
         s="./"
      d = f.split("/")
      n = len(d)-1
      e = s+"/"
      for i in range(n):
        e = e+d.pop(0)+"/"
        easydir(e)
      r = s+f
      return r

   def mfits0(self,c):
       return self.scratch("mode0/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def mfits1(self,c):
       return self.scratch("mode1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def rfits1(self,c):
       return self.scratch("back1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def ofits1(self,c):
       return self.scratch("out1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def wfits1(self,c):
       return self.scratch("mall1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def qfits1(self,c):
       return self.scratch("smow1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def ufits1(self,c):
       return self.scratch("uall1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def bfits1(self,c):
       return self.scratch("mbg1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def sfits0(self,c):
       return self.scratch("sky0/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def sfits1(self,c):
       return self.scratch("sky1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def mfits2(self,c):
       return self.scratch("mode2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def rfits2(self,c):
       return self.scratch("back2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def ofits2(self,c):
       return self.scratch("out2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def wfits2(self,c):
       return self.scratch("mall2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def qfits2(self,c):
       return self.scratch("smow2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def ufits2(self,c):
       return self.scratch("uall2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def bfits2(self,c):
       return self.scratch("mbg2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def sfits2(self,c):
       return self.scratch("sky2/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def mask1(self,c):
       return self.scratch("mask1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def pers1(self,c):
       return self.scratch("pers1/"+self.namec.replace(".fits","c%d.fits"%(c)))
   def cat1(self,c):
       return self.scratch("cat1/"+self.namec.replace(".fits","c%d.fits"%(c)).replace(".fits",".cat"))
   def cat2(self,c):
       return self.scratch("cat2/"+self.namec.replace(".fits","c%d.fits"%(c)).replace(".fits",".cat"))
   def shift1(self,c):
       return self.scratch("shift1/"+self.namec.replace(".fits",".png"))
   def shift2(self,c):
       return self.scratch("shift2/"+self.namec.replace(".fits",".png"))

   def Bad(self):
      bad = False
      for E in self.oloop:
          if E.bad or len([c for c in [1,2,3,4] if \
                    (os.path.exists(E.mfits1(c)+".bad") or \
                    os.path.exists(E.sfits1(c)+".bad") or \
                    os.path.exists(E.mfits2(c)+".bad") or \
                    os.path.exists(E.sfits2(c)+".bad"))]):
                       bad = True
          if bad: break
      self.bad = bad

   def ReadModes(self,first=True,second=False,data=0):
      chips = [1,2,3,4]
      m = asarray([self.ReadMode(chip,first=first,second=second,data=data) for chip in chips])
      return m
   def ReadPcts(self,chip,first=True,second=False):
      if first: mfits = self.mfits1(chip)
      elif second: mfits = self.mfits2(chip)
      else: mfits = self.mfits0(chip)
      G = FITS(mfits)
      pcts = [G["pct%d"%(x)] for x in [1,2,3,4]]
      G.close()
      print mfits,pcts
      return pcts
   def ReadMode(self,chip,first=True,second=False,data=0,p=""):
      if first: mfits = self.mfits1(chip)
      elif second: mfits = self.mfits2(chip)
      else: mfits = self.mfits0(chip)
      G = FITS(mfits)
      cent = G[p+"mode"]
      if cent == "N/A": cent = G[p+"median"]
      scat = G["scat"]
      G.close()
      print mfits,cent,scat
      if not data: return cent,scat
      if data:
         G = FITS(self.fits+"crap")
         d = G.data()
         G.close()
         return cent,scat,d
   def Job(self,func,args):
      os.nice(15)
      chips = [1,2,3,4]
      dicts = [{"args":(self.N,chip),"keywords":args} for chip in chips]
      if "verb" in args and args["verb"]:
         [apply(func,dict["args"],dict["keywords"]) for dict in dicts]
      else:
         print func.__name__
         self.queue = TwistedObjectQueue(func.__name__,dicts)
         self.queue.repeatable = False
         self.queue.Run(forks=False,sleeptime=0.02)
         print self.queue.results
   def Modes(self,first=True,second=False,msh=10,cat=None,histo=0,mag=3,flat=0,verb=1):
      args = {"first":first,"second":second,"msh":msh,"cat":cat,"mag":mag,"flat":flat,
        "histo":histo,"verb":verb}
      self.Job(FourCLiftMode,args)
   def Blank(self):
      self.data = {}
   def Clear(self,chips):
       if isinstance(chips,IntType): chips = [chips]
       for chip in chips:
          if hasattr(self,"data") and chip in self.data: self.data.pop(chip)
          if hasattr(self,"sdata") and chip in self.sdata: self.sdata.pop(chip)
          if hasattr(self,"masks") and chip in self.masks: self.masks.pop(chip)
   def Data(self,chip,first,second,verb=1,force=0,flat=0):
      if first:
        mfits = self.mfits1(chip)
        easydir(self.scratch("mode1"))
      elif second:
        mfits = self.mfits2(chip)
        easydir(self.scratch("mode2"))
      else:
        mfits = self.mfits0(chip)
        easydir(self.scratch("mode0"))

      ReadCalibs(self,chip,nfilt=self.filter,flat=flat,first=first,second=second)

      if force or not hasattr(self,"data") or not self.data.has_key(chip):
         if os.path.exists(mfits):

            print "Reading",mfits,
            G = FITS(mfits,readonly=1)
            self.data[chip] = G.data()
            self.exptime = G["exptime"]
            self.cent = G["mode"]
            if self.cent == "N/A": self.cent = G["median"]
            self.scat = G["scat"]
            G.close()
            if second and os.path.exists(self.pers1(chip)) and os.path.exists(self.mask1(chip)):
               print self.pers1(chip),
               print self.mask1(chip),
               G1 = FITS(self.pers1(chip),readonly=1)
               G2 = FITS(self.mask1(chip),readonly=1)
               self.masks[chip] = (G1.data(), G2.data())
               G1.close()
               G2.close()
            print
         else:
            if self.fclass == "newfirm":
               print self.fits
               F = FITS(self.fits+".fits")
               Fn = F.name()
               print "Reading",Fn
               exptime = F["exptime"]
               ncoadd = F["ncoadd"]
               if ncoadd == "N/A": ncoadd = 1
               F.goto(1+chip)
               data = F.data()
               data = data[:2048,:2048]
               data = where(between(data,-1e24,1e24),data,0).astype(float32)
               F.close()
            elif self.fclass == "fourstar":
               data = []
               for j,E in enumerate(self.loop):
                  F = FITS(E.fits+"c%d.fits" % (chip))
                  Fn = F.name()
                  print "Reading",Fn
                  exptime = F["exptime"]
                  data1 = F.data()
                  data1 = data1[:2048,:2048]
                  data1 = where(between(data1,-1e24,1e24),data1,0).astype(float32)
                  F.close()
                  if E == self.loop[0]:
                     data = zeros((len(self.loop),data1.shape[0],data1.shape[1]),float32)
                  data[j] = data1
               data = array([mean(data[::,j,::]) for j in range(data1.shape[0])])

            self.data[chip] = data

            if self.filter != "Dark":

               if self.fclass == "newfirm":
                  self.data[chip] = ncoadd*NEWFIRMLinearize1D(self.data[chip]/ncoadd,chip,exptime/ncoadd)
               elif self.fclass == "fourstar":
                  self.data[chip] = FourStarLinearize2D(self.data[chip],chip,mode=self.gain[0])

               if DARKD[self.pset].get(chip,None) != None:
                  if (self.noctim, self.ncoadd) in DARKD[self.pset].get(chip):
                     self.data[chip] = where(DARKD[self.pset][chip][self.noctim,self.ncoadd],self.data[chip] - exptime*DARKD[self.pset][chip][self.noctim,self.ncoadd],0.0)

               if not flat and PUPLD[self.pset].get(chip,None) != None and (first or second):
                  self.data[chip] = where(PUPLD[self.pset][chip],self.data[chip]-exptime*PUPLD[self.pset][chip],0.0)

               if not flat and BADPD[self.pset].get(chip,None) != None and (first or second):
                  self.data[chip] = self.data[chip]*BADPD[self.pset][chip]

               if not flat and MASKD[self.pset].get(chip,None) != None and (first or second):
                  self.data[chip] = self.data[chip]*MASKD[self.pset][chip]

               if not flat and FLATD[self.pset].get(chip,None) != None and (first or second):
                  self.data[chip] = divz(self.data[chip],FLATD[self.pset][chip])

               if not flat and AREAD[self.pset].get(chip,None) != None and (first or second):
                  self.data[chip] = self.data[chip]*AREAD[self.pset][chip]

            if self.fclass == "fourstar" and chip  == 1 and self.mjd < 55700:
                  mirr = self.data[chip][1024-64:1024+64]
                  mrep = zeros(mirr.shape,self.data[chip].dtype)
                  if first:
#                     mirr1 = (mirr[:64] + mirr[-64:][::-1] - mirr[-64:])
#                     mirr2 = (mirr[-64:] + mirr[:64][::-1] - mirr[:64])
                     mirr1 = (2*mirr[:64] - mirr[-64:])
                     mirr2 = (2*mirr[-64:] - mirr[:64])
                     mrep[:64] = mirr1
                     mrep[-64:] = mirr2
                  self.data[chip][1024-64:1024+64] = mrep.astype(self.data[chip].dtype)

            print "Done reading",Fn

   def SData(self,chip,first,second,verb=1,force=0):
      if first:
        sfits = self.sfits1(chip)
        easydir(self.scratch("sky1"))
      elif second:
        sfits = self.sfits2(chip)
        easydir(self.scratch("sky2"))

      if self.cache and (force or not hasattr(self,"sdata") or not self.sdata.has_key(chip)):
         if not os.path.exists(sfits):
            raise IOError("Where is %s (%s)?" % (sfits, os.getcwd()))
         if os.path.exists(sfits):
            G = FITS(sfits,readonly=1)
            self.sdata[chip] = G.data()
            G.close()

   def WData(self,chip,first,second,verb=1,force=0):
      if first:
        wfits = self.wfits1(chip)
        ufits = self.ufits1(chip)
      elif second:
        wfits = self.wfits2(chip)
        ufits = self.ufits2(chip)
      if self.cache and (force or not hasattr(self,"lift") or not self.lift.has_key(chip) or self.lift.get(chip) == None):
         if os.path.exists(wfits):
            print "Reading",wfits,ufits
            F = FITS(wfits,readonly=1)
            G = FITS(ufits,readonly=1)
            self.lift[chip] = F.data(),G.data()
            F.close()
            G.close()

   def Test(self,*args,**kw):
      print "Howdy!",os.getpid()
      n = len(args)
      m = kw
      return n,m.keys()

#  Mental Note: do DrawMask first and try to remove striping.
#  Mental Note: Andy's algorithm for guider cameras
   def Mode(self,chip,other=None,first=True,second=False,msh=10,cat=None,histo=0,norm=0,mag=3,flat=0,verb=1):
      start = time.time()
      print "Calculating location for %r [%d]" % (self,chip)
      ReadCalibs(self,chip,nfilt=self.filter,flat=flat,first=first,second=second)
      if not hasattr(self,"data") or not self.data.has_key(chip):
         self.Data(chip,first,second,flat=flat)
      data = self.data[chip]
#      if second:
#         dpup = self.scratch("pupil0")
#         pup= "%s/pupil%sc%d.fits" % (dpup,self.filter,chip)
#         if FileCheck(pup):
#            pF = FITS(pup)
#            pd = pF.data()
#            pF.close()
#            im0 = self.data[chip]
#            G = FITS(self.mfits1(chip))
#            etime = G["exptime"]
#            G.close()
#            self.data[chip] = evaluate("im0-pd*etime")
      if 0 and second and self.fclass == "fourstar":
         odata = None
         G = FITS(self.sfits1(chip))
         skysub = G.data()
         G.close()
         msky = median(skysub.ravel())
         dsky = (skysub-msky)
#         qdump("/tmp/dsky.fits",dsky)
         ssky = 1.49*median(abs(dsky.ravel()))
         print msky,ssky
#         qdump("/tmp/dsky2.fits",divz(dsky,ssky))
         um = greater(abs(dsky),10*ssky).astype(float32)
#         qdump("/tmp/um.fits",999999*um)
         um = VTKIslandRemoval(um,1,0,10000,1)
#         qdump("/tmp/um2.fits",999999*um)
         c = arange(0,2048,1,float32)
         x = []
         y = []
         jy,jx = 5,5
#         if chip == 4: jy=12
         for j in range(jy):
           x = concatenate([x,c])
           y = concatenate([y,(2047-j)*ones(c.shape)])
           x = concatenate([x,c])
           y = concatenate([y,(j)*ones(c.shape)])
         for j in range(jx):
           y = concatenate([y,c])
           x = concatenate([x,(2047-j)*ones(c.shape)])
           y = concatenate([y,c])
           x = concatenate([x,(j)*ones(c.shape)])
         um = (32766*VTKSeedConnectivity(um,x,y,val=1)).astype(int16)
#         qdump("/tmp/um3.fits",999999*um)
#         os._exit(1)
      elif 0 and other:
         other.Data(chip,first,second,flat=flat)
         odata = other.data[chip]
         um = None
      else:
         odata = None
         um = None
      maskd = MASKD[self.pset].get(chip,None)
      badpd = BADPD[self.pset].get(chip,None)
      if cat:
         sfits1 = self.sfits1(chip)
         mask1 = self.mask1(chip)
         pers1 = self.pers1(chip)
         if FileCheck(mask1) and FileCheck(pers1):
            G = FITS(mask1)
            mask = G.data()
            G.close()
            G = FITS(pers1)
            pers = G.data()
            G.close()
         else:
            mask,pers = DrawMask(chip,cat,self,data.shape,mag=mag,verb=verb)
            if um != None:
               pers = where(pers,pers,um)
            print "Writing %s" % (mask1)
#            temp1 = self.fits+"c%d.fits"%(chip)
            G = FITS(mask1,create=1,template=self.oloop[0].mfits1(chip))
            G.modkey("bitpix",16)
            G.modkey("bscale",1.0)
            G.modkey("bzero",0.0)
            G.resize( [mask.shape[1], mask.shape[0]])
            G.putdata(mask)
            G.close()
            print "Writing %s" % (pers1)
            G = FITS(pers1,create=1,template=self.oloop[0].mfits1(chip))
            G.modkey("bitpix",16)
            G.modkey("bscale",1.0)
            G.modkey("bzero",0.0)
            G.resize( [pers.shape[1], pers.shape[0]])
            G.putdata(pers)
            G.close()
#            os._exit(1)
         mask = logical_not(logical_or(mask,pers))
      else:
         mask = not_equal(data,0)
      if maskd!=None: mask = logical_and(mask,maskd).astype(int16)
      if badpd!=None: mask = logical_and(mask,badpd).astype(int16)
      if odata!=None:
         osc1 = median(data.ravel())
         osc2 = median(odata.ravel())
         if osc1 and osc2:
           osc = osc1/osc2
         else:
           osc = 1.0
         odiff = data-osc*odata
         odiff2 = compress(mask.ravel(),odiff.ravel())
         omed2 = median(odiff2)
         odiff2 = odiff2 - omed2
         oscat = 1.49*median(abs(odiff2))
         masko = equal(VTKConvolve(1.*less(abs(odiff-omed2),5*oscat),k=3,numret=1),1.0)
         mask = logical_and(mask,masko).astype(int16)
      kind = "mode"
      cent, scat, pcts = self.QuickMode(data,mask=mask,verb=verb,flat=flat,dark=self.filter=="Dark")
#      shrunk = VTKShrinkN(VTKAbs(VTKSubtract(data,cent)),128,128,numret=1,usemean=0,usemedian=1)
#      kind = "median"
#      cent, scat = self.QuickMedian(data.ravel(),mask=mask,verb=verb)
#      if not (first and not histo) and msh and cent > 0:
#         kind = "mode"
#         cent, scat = self.FindMode(data.ravel(),msh=msh,mask=mask,histo=histo,verb=verb)
      finish = time.time()
      ctime = finish-start
      if first:
        mfits = self.mfits1(chip)
      elif second:
        mfits = self.mfits2(chip)
      else:
        mfits = self.mfits0(chip)
      print "Writing %s[%d,%d] using (%s,scat) = (%.1f,%.1f), computed in %.2fs" % \
        (mfits,data.shape[1],data.shape[0],kind,cent,scat,ctime)
      if self.fclass == "newfirm":
         G = FITS(mfits,create=1,readonly=0)
         G.newhead("T",-32,2, [data.shape[1], data.shape[0]])
         F = FITS(self.fits+".fits")
         ignore = ["XTENSION","BITPIX","NAXIS","NAXIS1","NAXIS2","PCOUNT","GCOUNT",
         "EXTNAME","INHERIT","EXTVER","BSCALE","BZERO"]
         G.copyheader(F,ignore=ignore)
         G.delkey("extend")
         G.delkey("nextend")
         F.goto(1+chip)
         bad = ["XTENSION","BITPIX","NAXIS","NAXIS1","NAXIS2","PCOUNT","GCOUNT",
         "EXTNAME","INHERIT","EXTVER","BSCALE","BZERO"]
         [G.modkey(key,F[key]) for key in F.keys() if key not in bad]
      elif self.fclass == "fourstar":
         G = FITS(mfits,create=1,readonly=0,template=self.fits+"c%d.fits"%(chip))
         G.modkey("bitpix",-32)
         G.modkey("bscale",1.0)
         G.modkey("bzero",0.0)
         G.resize( [data.shape[1], data.shape[0]])
      if self.filter != "Dark":
         G.modkey("darkfd",os.path.basename(os.path.dirname(DARKN[self.pset][chip].get((self.noctim,self.ncoadd),"None"))))
         G.modkey("darkfr",os.path.basename(DARKN[self.pset][chip].get((self.noctim,self.ncoadd),"None")))
         G.modkey("flatfd",os.path.basename(os.path.dirname(FLATN[self.pset].get(chip,"None"))))
         G.modkey("flatfr",os.path.basename(FLATN[self.pset].get(chip,"None")))
         G.modkey("puplfd",os.path.basename(os.path.dirname(PUPLN[self.pset].get(chip,"None"))))
         G.modkey("puplfr",os.path.basename(PUPLN[self.pset].get(chip,"None")))
         G.modkey("areafd",os.path.basename(os.path.dirname(AREAN[self.pset].get(chip,"None"))))
         G.modkey("areafr",os.path.basename(AREAN[self.pset].get(chip,"None")))
         G.modkey("maskfd",os.path.basename(os.path.dirname(MASKN[self.pset].get(chip,"None"))))
         G.modkey("maskfr",os.path.basename(MASKN[self.pset].get(chip,"None")))
         G.modkey("badpfd",os.path.basename(os.path.dirname(BADPN[self.pset].get(chip,"None"))))
         G.modkey("badpfr",os.path.basename(BADPN[self.pset].get(chip,"None")))
      G.modkey(kind,cent)
      G.modkey("scat",scat)
      G.modkey("pct1",pcts[1])
      G.modkey("pct2",pcts[2])
      G.modkey("pct3",pcts[3])
      G.modkey("pct4",pcts[4])
      G.close()
#      if flat and "flat" in self.objname:
#         divide(self.data[chip],cent,self.data[chip])
      G = FITS(mfits,readonly=0)
      G.putdata(self.data[chip])
      G.close()
      MakeThumbnail(mfits,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
      MakeThumbnail(mfits,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
      finish = time.time()
      ctime = finish-start
      print "Total elapsed time for this frame was %.02fs" % (ctime)
      if not self.cache:
         self.data.pop(chip)
      if not self.cache: self.Clear([chip])
      return cent,scat

   def flwt2d(self,chip,Exposures,allmed=None,first=True,second=False,verb=1,nn=4,nt=4):
       fsub = lambda c: self.flwt2dchild(c,Exposures,allmed=allmed,first=first,second=second,verb=verb,nn=nn,nt=nt)
#       fsub(chip)
#       os._exit(1)
#       d = defer.Deferred()
#       d.addCallback(lambda result: fsub(chip))
#       d.callback(True)
#       bd = threads.deferToThread(bd.callback,True)
#       def watchD():
#          def iterD():
#              while 1:
#                  if hasattr(d,"result"):
#                     break
#                  else:
#                     time.sleep(0.1)
#                     yield
#          return task.cooperate(iterD())
#       co = watchD()
#       yield co.whenDone()
#       os._exit(1)
       p = Process(target=fsub,args=(chip,))
       p.start()
       p.join()
#       os._exit(1)

   def flwt2dchild(self,chip,Exposures,allmed=None,first=True,second=False,verb=1,nn=4,nt=4):
      p = (second and 2) or (first and 1)
      o = getattr(self,"mfits%d"%(p))(chip)
      t0 = time.time()
      print "Starting",o
      ReadCalibs(self,chip,nfilt=self.filter,flat=False,first=first,second=second)
      self.Data(chip,first,second)
      data = self.data[chip]
      tdata = None
      sdata = None
      fEpck = open(Exposures,"rb")
      Exposures = cPickle.load(fEpck)
      fEpck.close()
      if 1:
#         e1 = [E2 for E2 in Exposures if self.expno==E2.expno][0]
         e1 = self.oloop[0]
         if os.path.exists(e1.sfits1(chip)):
            F = FITS(e1.sfits1(chip))
            if F["mmode"] == "N/A": Fm = F["mmedian"]
            else: Fm = F["mmode"]
            Fr = F["anoise"]
            sdata = F.data()
            F.close()
         else:
            F = FITS(e1.mfits1(chip))
            if F["mmode"] == "N/A": Fm = F["mmedian"]
            else: Fm = F["mmode"]
            Fr = F["scat"]
            F.close()
            if Fr == "N/A":
               if self.fclass == "newfirm":
                 gain,rn = 8.0,25.0
               elif self.fclass == "fourstar":
                 if self.gain[0] == "F": gain,rn = 2.5,20.0
                 elif self.gain[0] == "L": gain,rn = 1.3,15.0
               gain = gain*len(self.loop)
               rn = rn/sqrt(len(self.loop))
               Fr = sqrt(gain*Fm+rn**2)/gain
      if hasattr(self,"masks") and chip in self.masks:
         persim,maskim = self.masks[chip]
         m1,b1 = MASKD[self.pset][chip],BADPD[self.pset][chip]
         if m1 == None: m1 = ones(data.shape,float32)
         if b1 == None: b1 = ones(data.shape,float32)
#         maskim = evaluate("((maskim+persim)==0) & (maskim!=0) & (persim!=0)").astype(float32)
#         maskim = evaluate("maskim*m1*b1").astype(float32)
         maskim = (logical_not(logical_or(maskim,persim))*m1*b1).astype(float32)
      else:
         m1,b1 = MASKD[self.pset][chip],BADPD[self.pset][chip]
         if m1 == None: m1 = ones(data.shape,float32)
         if b1 == None: b1 = ones(data.shape,float32)
#         maskim = evaluate("(m1 + b1)==0").astype(float32)
         maskim = (MASKD[self.pset][chip]*BADPD[self.pset][chip]).astype(float32)
#      maskim = VTKMultiply(maskim,VTKConvolve(VTKIslandRemoval(maskim,0,1,20000,1),k=5,numret=1))
#      maskim = VTKMultiply(maskim,VTKConvolve(VTKIslandRemoval(maskim,0,1,20000,1),k=5,numret=1))
      rmaskim = VTKIslandRemoval(maskim,0,1,20000,1)
      maskim = evaluate("maskim*rmaskim")
#      cent,scat = self.ReadMode(chip,first=first,second=second,data=0)
      easydir(self.scratch("mall%d" % (p)))
      easydir(self.scratch("back%d" % (p)))
      easydir(self.scratch("uall%d" % (p)))
#      omask=1.*logical_not(sum(self.masks[chip])),
      i1wu = MakeWaves(data,sdata,sig=5.0,mask=maskim,tdata=None,nn=nn,nt=nt,Fr=Fr)
      i1,mask3,w,u = i1wu
      m = getattr(self,"wfits%d"%(p))(chip)
      mu = getattr(self,"ufits%d"%(p))(chip)
      m2 = getattr(self,"rfits%d"%(p))(chip)
      m3 = getattr(self,"ofits%d"%(p))(chip)
#      self.lift[chip]={
#        "m2":i1, "m":w, "mu":u,
#        }
      for f,a in zip([m2,m3,m,mu],[i1,32767*mask3,w,u]):
         print "Writing",f
         G = FITS(f,create=1,template=o)
         G.putdata(a)
         G.close()
         MakeThumbnail(f,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
         MakeThumbnail(f,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
      t1 = time.time()
      print "Time for computation was %.2fs" % (t1-t0)
      if not self.cache: self.Clear([chip])

   def QuickMedian(self,s,mask=None,verb=0):
      if mask.any(): s = compress(mask.ravel(),s)
      s = sort(s)
      me = s[len(s)/2]
      sc = (s[int(0.84*len(s))] - s[int(0.16*len(s))])/2.
      return me, sc

   def QuickMode(self,x,th=0,sat=65e3,mask=None,msh=10,verb=0,histo=0,flat=0,dark=0):
      if flat and not dark and self.fclass == "fourstar":
         x0,xw=768,512
         y0,yw=768,512
         um = mask[y0:y0+yw,x0:x0+xw].ravel()
         ux = x[y0:y0+yw,x0:x0+xw].ravel()
         if mask.any(): s = compress(um*ux,ux)
         else: s = ux
         mode = median(s)
         s = compress(between(s,0.2*mode,1.2*mode),s)
         scat = 1.49*median(abs(s-mode))
         if mask.any(): s = compress(mask.ravel()*x.ravel(),x.ravel())
         else: s = compress(x.ravel(),x.ravel())
      else:
         if mask.any(): s = compress(mask.ravel()*x.ravel(),x.ravel())
         else: s = compress(x.ravel(),x.ravel())
         s = sort(s)
         e = diff(s)
         l = 0.5*e + s[:-1]
         e,l = take([e,l],argsort(e),1)
         n20 = int(0.20*len(e)+1)
         mode = median(l[:n20])
         scat = 2.0*median(abs(l[:n20]-mode))
      n = len(s)
      def g(x):
         lo=mode-x*scat
         hi=mode+x*scat
         m=sum(between(s,lo,hi,inc=1))
         return divz(100.*m,n)
      pcts = {}
      for x in [1,2,3,4]:
          pcts[x] = g(x)
      if verb: print ql10,scat,pcts
      return mode,scat,pcts

   def FindMode(self,s,th=0,sat=65e3,mask=None,msh=10,verb=0,histo=0):
      mode = 0.0
      scat = 0.0
      if mask != None: s = compress(mask.ravel(),s)
      s = compress(greater(abs(s),th),s)
      if sat: s = compress(less(s,sat),s)
      s = sort(s)
      if not msh: msh=10
      if histo:
         me = s[len(s)/2]
         ms = 1.49*median(abs(s-me))
         ml = me-3.0*ms
         mh = me+1.0*ms
         md = ms/msh
         bins = arange(ml,mh,md,float64)
         mi = diff(searchsorted(s,bins))
         mb = diff(bins)/2. + bins[:-1]
         lmi = log(mi)
         bases = polynom(mb,2)
         sol = linear_least_squares(transpose(bases),lmi)[0]
         print sol
         scat = sqrt(-0.5/sol[2])
         mode = pow(scat,2)*sol[1]
         print me,mode,scat
         if verb:
            lmi1 = max(lmi)
            mi1 = max(mi)
            xm=[mb[0],mb[-1]]
            ym=[lmi1-2,lmi1+0.3]
            newbox(xm,ym,ch=2.0)
            xlabel("Counts",ch=2.0)
            ylabel("ln N",ch=2.0)
            drawln(mb,lmi,ls=1,hist=1)
            drawln([mode,mode],ym,ls=1)
            drawln([mode-scat,mode-scat],ym,ls=2)
            drawln([mode+scat,mode+scat],ym,ls=2)
            raw_input("hit <cr> ")
      else:
         x = VTKShrinkN(0.5+arange(len(s)),msh,usemean=1,numret=1)/msh
         s = VTKShrinkN(s,msh,usemean=1,numret=1)
         p = x/(1.*len(s))
         m = s[3*len(s)/8]
         n = ndtri(p)
#         n = (pdtri(m,1-p)-m)/sqrt(m)
         q = (s[int(0.84*len(s)+0.5)]-s[int(0.16*len(s)+0.5)])/2.
         guess = [m,q]
         w = exp(-0.5*(p-0.5)**2/pow(0.25,2))
         def fitp(g):
           y = g[0]+g[1]*n
           r = s-y
           u = r*w
           if verb: print g,len(s)
           return u
         result = leastsq(fitp,guess)
         if verb: print result
         mode,scat = result[0]
      return mode,scat

   #def SkySubtracts(self,NDS,first=1,second=0,nf=3,verb=0,flat=0):
   #   NDS = [N1 for N1 in NDS if not Exposure(N1).bad]
   #   args = {"NDS":NDS,"first":first,"second":second,"nf":nf,"verb":verb,"flat":flat}
   #   self.Job(FourCLiftSkySubtract,args)

   def SkySubtract(self,chip,Exposures,first=1,second=0,nf=3,verb=0,flat=0,yskip=16,\
        sigclip=0,test=0,Hub=None,bigsky=0,NP=-1,already=0):
      start = time.time()
      Exposures = [e for e in Exposures if not e.bad]
      fsky = array([e.sky for e in Exposures])
      bab = not flat and (sum(fsky) and (sum(fsky) < len(fsky)))
      if Exposures[0].sky:
         bab = 0
         fsky = zeros(fsky.shape)
      if bab:
        sExposures = [e for e in Exposures if e.sky]
        sdir = self.scratch("").replace("obj","sky")
      else:
        sExposures = Exposures
        sdir = self.scratch("./")
      if first:
         mfits = self.mfits1(chip)
         sfits = self.sfits1(chip)
         nes = [j for j in range(len(Exposures)) if Exposures[j].base == self.base]
         jno = array([E.expno for E in Exposures])
         sjno = array([E.expno for E in sExposures])
         kno = array([E.loopno for E in Exposures])
         skno = array([E.loopno for E in sExposures])
         fsky = array([E.sky for E in Exposures])
         jnos = sort(list(Set(jno)))
         nj = len(jnos)
         kuse = 1
#         if chip == 1: print nes
         if nes:
            ne = nes[0]
         else:
            ne = len(Exposures)-1
         if flat and "dark" in Exposures[0].objname:
            ne30 = len(Exposures)
            skyframe = sdir + "sky1/Darkc%d.fits" % (chip)
         elif flat and "flat" in Exposures[0].objname:
            ne30 = len(Exposures)
            skyframe = sdir + "sky1/Flat"+Exposures[0].filter+"c%d.fits" % (chip)
         else:
            ne = argmin(abs(jno[ne] - sjno)+abs(kno[ne]-skno))
            jk = {}
            for j1 in jno: jk.setdefault(j1,0)
            [jk.__setitem__(j1,jk.get(j1)+1) for j1,k1 in zip(jno,kno)]
            kuse = max((jk.values()))
#            print kuse
#            os._exit(1)
#            kuse = median(kno)
#            kuse = max([k1 for j1,k1 in zip(jno,kno) if j1 == jno[ne]])
            nf = nf * kuse
            nf = min([nf,len(sjno)])
            nf = len(sjno)/(len(sjno)/nf)
            ne30 = (ne / nf * nf) + 1
            tskyframe = sdir+"sky1/.FirstSky%04dc%d.fits" % (ne30,chip)
            skyframe = sdir+"sky1/FirstSky%04dc%d.fits" % (ne30,chip)
#         if chip == 1: print ne,ne30
         if (ne+1) == ne30: await = False
         else: await = True
         if await and not os.path.exists(skyframe): print "Need to await",skyframe
      elif second:
         await = False
         mfits = self.mfits2(chip)
         sfits = self.sfits2(chip)
         pfits = self.pers1(chip)
         if flat:
            ne30 = len(Exposures)
            if "dark" in Exposures[0].objname:
              skyframe = sdir+"sky2/Darkc%d.fits" % (chip)
            else:
              skyframe = sdir+"sky2/Flat"+Exposures[0].filter+"c%d.fits" % (chip)
         else:
            skyframe = sdir + "sky2/SecondSky%04dc%d.fits" % (self.expno,chip)
      else:
         flat = 1
         mfits = self.mfits0(chip)
         sfits = self.sfits0(chip)
         nes = [j for j in range(len(Exposures)) if Exposures[j].base == self.base]
         jno = array([E.expno for E in Exposures])
         sjno = array([E.expno for E in sExposures])
         kno = array([E.loopno for E in Exposures])
         skno = array([E.loopno for E in sExposures])
         fsky = array([E.sky for E in Exposures])
         jnos = sort(list(Set(jno)))
         nj = len(jnos)
         kuse = 1
#         if chip == 1: print nes
         if nes:
            ne = nes[0]
         else:
            ne = len(Exposures)-1
         ne30 = len(Exposures)
         if (ne+1) == ne30: await = False
         else: await = True
         skyframe = sdir + "sky0/Flat"+Exposures[0].filter+"c%d.fits" % (chip)

      if flat and second: await = False
      if test: return await,skyframe,ne,ne30
      if bigsky and FileCheck(skyframe): return []
      ReadCalibs(self,chip,nfilt=self.filter,flat=flat,first=first,second=second)

      if skyframe in SKYFD[self.pset] or FileCheck(skyframe):
         use = None
      else:
        if first and await and not (first and flat):
          print "Looking for",skyframe
          self.WaitSkySubtract(skyframe,chip,first=first,second=second,already=already)
          use = None
        elif not await and nf and not first and not (second and flat):
          sfits1 = self.sfits1(chip)
          ne = [j for j in range(len(Exposures)) if Exposures[j].base == self.base][0]
          F = FITS(sfits1)
          xpos1 = F["xdiff1"]
          ypos1 = F["ydiff1"]
          F.close()
          sfitsE = lambda E: E.sfits1(chip)
          F = [FITS(sfitsE(E)) for E in Exposures]
          xdiff1 = array([f["xdiff1"] for f in F])
          ydiff1 = array([f["ydiff1"] for f in F])
          [f.close() for f in F]
          ds = sqrt((xpos1-xdiff1)**2 + (ypos1-ydiff1)**2)
          off = nonzero(greater(ds,2.5))
          neo = clip(searchsorted(off,ne),0,len(off)-1)
          off = off[max([0,neo-nf]):min([neo+nf,len(off)])]
          use = [Exposures[o] for o in off]
        elif flat:
          use = Exposures
        else:
          use = [E for E in sExposures[ne30-1:ne30-1+nf] if (not bab or E.sky)]
          if len(use) < 3*kuse and (ne30-1)>=3*kuse:
             use = sExposures[max([0,(ne30-1)-3]):min([len(sExposures),ne30-1+nf])]

      if use and not FileCheck(skyframe):
         print "Computing",skyframe
         print "At",self
         print "From",use
         M = self.MedianFrames(skyframe,chip,use,first,second,yskip=yskip,verb=verb,flat=flat,sigclip=sigclip,Hub=Hub,NP=NP)
         if Hub != None: return M
         finish = time.time()
         ctime = finish-start
         print "Writing %s, computed in %.2fs" % (skyframe,ctime)
      if not (first and flat and ("Dark" in skyframe or self.objname[:8] == "flat_obj")) and FileCheck(skyframe):
         self.DoSkySubtract(skyframe,chip,first=first,second=second)

   def WaitSkySubtract(self,skyframe,chip,first=0,second=0,already=0):
       print "Waiting for",skyframe
       if already and not os.path.exists(skyframe):
          raise IOError("%s sky frame missing!" % (skyframe))
       while not os.path.exists(skyframe):
          time.sleep(0.2)
       ssize = 0
       while ssize != os.path.getsize(skyframe):
          ssize = os.path.getsize(skyframe)
          time.sleep(0.2)
          print "Waiting for completion of",skyframe
       print "It (%s) seems to be there now!" % (skyframe)

   def DoSkySubtract(self,skyframe,chip,first=0,second=0):
      ReadCalibs(self,chip,nfilt=self.filter,flat=0,first=first,second=second)
      if first:
         mfits = self.mfits1(chip)
         sfits = self.sfits1(chip)
      elif second:
         mfits = self.mfits2(chip)
         sfits = self.sfits2(chip)
      print "Subtracting from",mfits
      print "To make",sfits
      print "Using",skyframe
      if chip not in SKYFD[self.pset]: SKYFD[self.pset][chip] = {}
      if skyframe in SKYFD[self.pset][chip]:
         S = SKYFD[self.pset][chip][skyframe]
      else:
         FS = FITS(skyframe)
         S = FS.data()
         SKYFD[self.pset][chip][skyframe] = S
         FS.close()
#      mval = []
#      for chip2 in [1,2,3,4]:
#         cent,scat = self.ReadMode(chip2,first=first,second=second)
#         mval.append(cent)
#      cent = median(mval)
      cent,scat = self.ReadMode(chip,first=first,second=second,p="m")
      self.Data(chip,first,second)
      D = self.data[chip]
      G = less(D,1e24)*not_equal(S,0)
      D = (D-cent*S)*G
      if chip in MASKD[self.pset] and MASKD[self.pset][chip] != None:
        D = D * MASKD[self.pset][chip]
      if chip in BADPD[self.pset] and BADPD[self.pset][chip] != None:
        D = D * BADPD[self.pset][chip]
      if second and chip in self.masks:
         print "Mask!"
         D = where(self.masks[chip][0],0,D)
      if chip in FLATD[self.pset] and FLATD[self.pset][chip] != None:
         Df = FLATD[self.pset][chip]
      else:
         Df = ones(D.shape)
      for mit in [0,1]:
          D2 = D*Df
          if mit == 0:
             M2 = not_equal(D2,0)
          else:
             M2 = not_equal(D2,0)
             Dt = D - D2y - D2x
             cDt = compress(Dt.ravel(),Dt.ravel())
             sDt = 1.49*median(abs(cDt.ravel()))
             M2 = M2*between(Dt,-3*sDt,1.5*sDt)
          D2y = divz(EasyPatch(array([EasyStat(x,m) for x,m in zip(D2,M2)]))[::,NewAxis],Df)*not_equal(D,0)
          D2 = (D-D2y)*Df
          D2x = divz(EasyPatch(array([EasyStat(x,m) for x,m in zip(transpose(D2),transpose(M2))]))[NewAxis,::],Df)*not_equal(D,0)
      D = D - D2y - D2x

      alen = len(compress(D.ravel(),D.ravel()))
      adiff = median(compress(D.ravel(),D.ravel()))
      anoise = 1.48*median(abs(compress(D.ravel(),D.ravel())))
#      Dax = 1.49*median(abs(D-adiff))
#      Dax1,Dax2 = bwt(Dax)
#      Day = 1.49*median(abs(transpose(D)-adiff))
#      Day1,Day2 = bwt(Day)
#      D = D*less(Dax-Dax1,10*Dax2)[NewAxis,::]*less(Day-Day1,10*Day2)[::NewAxis]
      print "N = %d Median = %.8f ,1.48MAD = %.8f" % (alen,adiff,anoise)

      if self.fclass == "newfirm":
        gain,rn = 8.0,25.0
      elif self.fclass == "fourstar":
        if self.gain[0] == "F": gain,rn = 2.5,20.0
        elif self.gain[0] == "L": gain,rn = 1.3,15.0
        gain = gain*len(self.loop)
        rn = rn/sqrt(len(self.loop))

      expnoise = sqrt(gain*cent+rn*rn)/gain

#      if cent < 5*expnoise and not os.path.exists( self.scratch("").replace("obj","sky")):
      if 0:
         bgfix = lambda a: (a.any() and getpct(a,25) or 0.0)
         mDy = asarray([bgfix(compress(D[j],D[j])) for j in range(D.shape[0])])[::,NewAxis]
         D2 = evaluate("where(D!=0,D-mDy,0)")
         tD = transpose(D2)
         mDx = transpose(asarray([bgfix(compress(tD[j],tD[j])) for j in range(D.shape[1])]))[NewAxis,::]
         D = evaluate("where(D2!=0,D2-mDx,0)")
         Dz = median(compress(D.ravel(),D.ravel()))
         D = evaluate("where(D!=0,D-Dz,0)")

#      print Dax1,Dax2,Day1,Day2
#      if FileCheck(sfits):
#        ns = len(glob(sfits+"*"))
#        sfits = sfits+str(ns)
      G = FITS(sfits,create=1,template=mfits)
      G.modkey("adiff",adiff)
      G.modkey("anoise",anoise)
      G.modkey("skyframe",os.path.basename(skyframe))
      G.putdata(D)
      G.close()
      if first: cat = self.cat1(chip)
      elif second: cat = self.cat2(chip)
      MakeThumbnail(sfits,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
      MakeThumbnail(sfits,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
      Sextractor(sfits,cat,scale=self.scale,thresh=5,saturate=50e3)
      print "Writing %s" % (sfits)
      if not self.cache: self.Clear([chip])

   def MedianFrames(self,skyframe,chip,Frames,first,second,yskip=32,verb=0,norm=0,flat=0,sigclip=5,Hub=None,NP=-1,tout=[]):
      if self.cache: [E.Data(chip,first,second) for E in [self]+Frames]
      ReadCalibs(self,chip,nfilt=self.filter,flat=flat,first=first,second=second)
      if NP == -1: NP =  int(os.environ.get("NP",0))
      elif NP == -2: NP =  int(os.environ.get("NP",0))/2
      if first: mfits = lambda f: f.mfits1
      elif second: mfits = lambda f: f.mfits2
      else: mfits = lambda f: f.mfits0
      F0 = FITS(mfits(Frames[0])(chip))
      naxis1,naxis2 = F0.naxes()
      F0.close()
      M = zeros((naxis2,naxis1),float32)
      F = {}
      K,L = {},{}
      Ftimes = []
      Fmodes = []
      Fscats = []
      Fno = []
      for f in Frames:
        if f.cache and ((not getattr(f,"data") or not f.data.has_key(chip))):
            f.Data(chip,first,second,verb=1)
        if "Dark" not in skyframe:
           F[f] = FITS(mfits(f)(chip))
           if F[f]["mmode"] == "N/A": mval = F[f]["mmedian"]
           else: mval = F[f]["mmode"]
           sval = F[f]["scat"]
           tval = F[f]["exptime"]
           F[f].close()
           Ftimes.append(tval)
           Fmodes.append(mval)
           Fscats.append(sval)
#           for chip2 in [1,2,3,4]:
#              F[f] = FITS(mfits(f)(chip2))
#              if F[f]["mode"] == "N/A": mval.append(F[f]["median"])
#              else: mval.append(F[f]["mode"])
#              F[f].close()
#           Fmodes.append(median(mval))
        else:
           F[f] = FITS(mfits(f)(chip))
           Ftimes.append(F[f]["exptime"])
           Fmodes.append(F[f]["exptime"])
           Fscats.append(1e24)
           F[f].close()
        Fno.append(f.expno)

      Ftimes = asarray(Ftimes)
      Fmodes = asarray(Fmodes)
      Fscats = asarray(Fscats)
      Fno = asarray(Fno)
#      [F[f].close() for f in F]
      Fnos = sort(list(Set(Fno)))
      for f in Frames:
          F[f] = mfits(f)(chip)
          if not first:
               K[f],L[f]  = f.mask1(chip), f.pers1(chip)
      Ny = (M.shape[0]-1)/yskip+1
      sumF = median(Fmodes)
      if first: mfits = self.mfits1(chip)
      elif second: mfits = self.mfits2(chip)
      else: mfits = self.mfits0(chip)
      tempframe = os.path.dirname(skyframe)+"/."+os.path.basename(skyframe)
      map(os.remove,glob(os.path.dirname(tempframe)+"/"+os.path.basename(tempframe).replace(".fits","_????.fits")))
      pup = None
      if not first and not second:
         dpup = self.scratch("")
         pup= "%s/pupil%sc%d.fits" % (dpup,self.filter,chip)
         if not FileCheck(pup):pup=None
      G = FITS(tempframe,create=1,template=mfits)
      G.modkey("ncombine",len(Frames))
      for j,E in enumerate(Frames):
         G.modkey("im%03d"%(j+1),E.name)
         if pup:
            G.modkey("PUPIL",os.path.basename(pup))
      G.close()
      Sections = [j*yskip for j in range(Ny)]
      if Hub != None:
          testsize = len(cPickle.dumps(self))
          print "len(pickle(self))=",testsize
          doj = []
          def SetupSection():
              j0 = Sections.pop(0)
              doj0 = TwistedTask(-1, \
                "lambda *args,**kw: args[0].MedianSection(*args[1:],**kw)",\
                self,tempframe,skyframe,j0,yskip,chip,Frames,F,K,L,Ftimes,Fmodes,Fscats,M.shape,\
                first,second,verb=verb,flat=flat,sigclip=sigclip,NP=0,pup=pup)
              doj0.setFromModules(["FourCLiftProcess"])
              doj.append(doj0)
#          doj = [TwistedTask(-1, \
#                 "lambda *args,**kw: args[0].MedianSection(*args[1:],**kw)",\
#                 self,tempframe,skyframe,j0,yskip,chip,Frames,F,K,L,Ftimes,Fmodes,Fscats,M.shape,\
#                 first,second,verb=verb,flat=flat,sigclip=sigclip,NP=0,pup=pup) \
#                 for j0 in Sections]
#          [item.setFromModules(["FourCLiftProcess"]) for item in doj]
          def EClean():
             [E.data.pop(chip) for E in [self]+Frames if E.cache and chip in E.data]
             [E.masks.pop(chip) for E in [self]+Frames if E.cache and chip in E.masks]
          def Package():
              print "len(doj)=",len(doj)
              if not len(doj):
                 print "WTF?!?!?!?!"
                 os._exit(1)
              print "tempframe,skyframe=",tempframe,skyframe
              return doj,tempframe,skyframe
          d = defer.Deferred()
          for n in range(len(Sections)):
              d.addCallback(lambda result: SetupSection())
          d.addCallback(lambda result: EClean())
          d.addCallback(lambda result: Package())
          d.callback(True)
          print d
          print "len(doj)=",len(doj)
          if not len(doj):
             print "WTF?!?!?!?!"
             os._exit(1)
          print "tempframe,skyframe=",tempframe,skyframe
          return doj,tempframe,skyframe
#          mhost,mport = Hub.split(":")
#          mport = int(mport)
#          print "hub host is %s, port %d" % (mhost,mport)
#          print "go!"
#          H = HubDispatch(doj,(mhost,mport),mport=0,namespace=globals(),verb=1,sleeptime=0.01)
      elif NP > 1:
         doj = lambda j0: self.MedianSection(tempframe,skyframe,j0,yskip,chip,Frames,F,K,L,Ftimes,Fmodes,Fscats,M.shape,\
                first,second,verb=verb,flat=flat,sigclip=sigclip,NP=NP,pup=pup)
         RunForkedQueue(doj,Sections,MaxThreads=NP,sleeptime=0.001,monitor=0,ThreadOutput=True)
      else:
         doj = lambda j0: self.MedianSection(tempframe,skyframe,j0,yskip,chip,Frames,F,K,L,Ftimes,Fmodes,Fscats,M.shape,\
                first,second,verb=verb,flat=flat,sigclip=sigclip,NP=NP,pup=pup)
         map(doj,Sections)
      if Hub == None:
         if self.cache: [E.Clear(chip) for E in [self]+Frames]
         os.rename(tempframe,skyframe)
         MakeThumbnail(skyframe,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
         MakeThumbnail(skyframe,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
         if verb: print

   def MedianSection(self,tempframe,skyframe,j0,yskip,chip,Frames,F,K,L,Ftimes,Fmodes,Fscats,Mshape,\
           first,second,verb=0,flat=0,sigclip=5,NP=0,pup=None):
       j1 = min([j0+yskip,Mshape[1]])
       pd = None
       if not first and not second and pup != None:
          pF = FITS(pup)
          pd = pF.readsec([0,j0],[Mshape[1]-1,j1-1])
          pF.close()
       Ma = zeros((len(Frames),j1-j0,Mshape[1]),float32)
       print j0,j1
       if not first:
         Ma2 = zeros((len(Frames),j1-j0,Mshape[1]),float32)
         if first: mfits = self.mfits1
         elif second: mfits = self.mfits2
         else: mfits = self.mfits0
         if self.cache:
           Ma3 = logical_not(self.masks[chip][0][j0:j1])
         else:
           Ff = FITS(mfits(chip))
           Ma3 = logical_not(Ff.readsec([0,j0],[Mshape[1]-1,j1-1]))
           Ff.close()
       for i,f in enumerate(Frames):
           if f.cache and hasattr(f,"data") and f.data.has_key(chip):
              Ma[i] = f.data[chip][j0:j1]
              if pd != None:
                 Ma[i] = Ma[i] - pd*Ftimes[i]
              if not first:
                 Ma2[i] = logical_or(f.masks[chip][0][j0:j1],f.masks[chip][1][j0:j1])
           else:
              Ff = FITS(F[f])
              Ma[i] = Ff.readsec([0,j0],[Mshape[1]-1,j1-1])
              if pd != None:
                 Ma[i] = Ma[i] - pd*Ftimes[i]
              Ff.close()
              if not first:
                 Kf = FITS(K[f])
                 Lf = FITS(L[f])
                 Ma2[i] = logical_or(Kf.readsec([0,j0],[Mshape[1]-1,j1-1]),\
                                Lf.readsec([0,j0],[Mshape[1]-1,j1-1]))
                 Kf.close()
                 Lf.close()
       if "Dark" not in os.path.basename(skyframe) and Frames[0].fclass=="fourstar":
          Fmodes = asarray(Fmodes)*greater(Fmodes,0)
       sumF = median(compress(Fmodes,Fmodes))
       Ms = 1.*Fscats[::,NewAxis,NewAxis]
       if flat and "Dark" not in os.path.basename(skyframe) and Frames[0].fclass == "fourstar":
          Fmodes = asarray(Fmodes)*greater(Fmodes,sumF/4)
#       if flat and "Flat" not in os.path.basename(skyframe) and \
#               "Dark" not in os.path.basename(skyframe):
       if "Dark" not in os.path.basename(skyframe):
          for i,f in enumerate(Frames):
              Ma[i] = divz(Ma[i],Fmodes[i])
              Ms[i] = divz(Fscats[i],Fmodes[i])
       
#       Ma = asarray([((hasattr(f,"data") and getattr(f,"data")[j0:j1]) or  \
#               f.readsec([0,j0],[Mshape[1]-1,j1-1])) for f in F])
#       if 0 and flat and (f.objname[:8] != "flat_obj" or "Dark" in f.filter):
#       if "Dark" in os.path.basename(skyframe):
#          Mj = divz(sum(Ma)*Fmodes[i],sum(not_equal(Ma,0)*Fmodes[i]))
#
       if 1:
#          for i in range(len(Ma)):
#             qdump("Ma%03d.fits" % (i),Ma[i])
          if not first:
             Ma = Ma * logical_not(Ma2)

#          Mg = not_equal(Ma,0.0)
          Mg = evaluate("Ma!=0.0")
#          Ma = where(Mg,Ma,1e18)
          Ma = evaluate("where(Mg!=0,Ma,1e18)")
          Ma = sort(Ma,0)
#          Mo = add.reduce(less(Ma,1e16),0).astype(int32)
          Mo = add.reduce(evaluate("Ma<1e16"),0).astype(int32)

          aF = arange(0,Ma.shape[0],1,int32)[::,NewAxis,NewAxis]

#          Mo2i = (Mo/2.).astype(int32)
          Mo2i = evaluate("Mo/2.").astype(int32)
#          Moi = ((Mo+1)/2.).astype(int32)
          Moi = evaluate("(Mo+1)/2.").astype(int32)
#          Meven = equal(Mo2i,Moi)
          Meven = evaluate("Mo2i==Moi")
#          Modd = not_equal(Mo2i,Moi)
          Modd = evaluate("Mo2i!=Moi")

#          Rodd = add.reduce(Ma * equal(aF,Mo2i),0)
          Rodd = add.reduce(evaluate("Ma * (aF==Mo2i)"),0)
#          Reven = add.reduce(Ma * (equal(aF,Mo2i-1)+equal(aF,Mo2i)),0)/2.0
          Reven = add.reduce(evaluate("Ma * ((aF==(Mo2i-1))|(aF==Mo2i))"),0)/2.0
#          mm = where(Modd,Rodd,Reven)*greater(Mo,0)
          mm = evaluate("where(Modd,Rodd,Reven)*(Mo>0)")

          aF = arange(0,Ma.shape[0],1,int32)[::,NewAxis,NewAxis]
#          sm = abs(Ma-mm[NewAxis,::,::])
          mmn = mm[NewAxis,::,::]
          sm = evaluate("abs(Ma-mmn)")
#          sms = sort(where(Mg,sm,1e18),0)
          sms = sort(evaluate("where(Mg!=0,sm,1e18)"),0)
#          Rodd = add.reduce(sms * equal(aF,Mo2i),0)
          Rodd = add.reduce(evaluate("sms * (aF==Mo2i)"),0)
#          Reven = add.reduce(sms * (equal(aF,Mo2i-1)+equal(aF,Mo2i)),0)/2.0
          Reven = add.reduce(evaluate("sms * ((aF==(Mo2i-1))|(aF==Mo2i))"),0)/2.0
#          rm = 1.49*where(Modd,Rodd,Reven)*greater(Mo,0)
          rm = evaluate("1.49*where(Modd,Rodd,Reven)*(Mo>0)")

#          if rm.any():
#             rm = median(compress(rm.ravel(),rm.ravel()))
#          else:
#             rm = zeros(mm.shape)

#          if sigclip and "Dark" not in skyframe:
          if sigclip:
             mmn = mm[NewAxis,::,::]
#             sm = Ma-mm[NewAxis,::,::]
             sm = evaluate("Ma-mmn")

             if "Flat" in skyframe or "Dark" in skyframe:
                 nit = 10
             else:
                 nit = 5

             for mit in range(nit):
#                um = not_equal(Ma,0.0)*less(Ma,1e18)
                um = evaluate("(Ma!=0.0)&(Ma<1e18)&(abs(sm)<(sigclip*rm))")
                if mit == 2:
                   wm = um*Cauchy(divz(sm,Ms),w=1)
                else:
                   wm = um*Huber(divz(sm,Ms),w=1)
#                mm = divz(sum(Ma*wm),sum(wm))
                Mawm = evaluate("Ma*wm")
                mm = divz(sum(Mawm),sum(wm))
                if mit < (nit-1):
#                   sm = abs(Ma-mm[NewAxis,::,::])
                   mmn = mm[NewAxis,::,::]
                   sm = evaluate("Ma-mmn")
                   sms = sort(evaluate("where(Mg!=0,abs(sm),1e18)"),0)
                   aF = arange(0,Ma.shape[0],1,int32)[::,NewAxis,NewAxis]
                   Rodd = add.reduce(evaluate("sms * (aF==Mo2i)"),0)
                   Reven = add.reduce(evaluate("sms * ((aF==(Mo2i-1))|(aF==Mo2i))"),0)/2.0
#                   rm = 1.49*where(Modd,Rodd,Reven)*greater(Mo,0)
                   rm = evaluate("1.49*where(Modd,Rodd,Reven)*(Mo>0)")
#             if "Flat" in skyframe or "Dark" in skyframe:
#                um = evaluate("(Ma!=0.0)&(Ma<1e18)")
#                Mg = not_equal(Ma,0.0)*less_equal(sm,sigclip*rm)*less(Ma,1e18)
#                mm = divz(add.reduce(Mg*Ma,0), add.reduce(Mg,0))

          Mj = mm
       elif second:
          if second:
             Mk = lambda t: 1-logical_or(t[0][j0:j1],t[1][j0:j1])
             Mb = asarray([Mk(f.masks[chip]) for f in Frames])
             Ma = Mb*Ma
          Mg = not_equal(Ma,0.0).astype(float32)
          Mj = VTKDivide(sum(Ma*Mg),sum(Mg))
          Mjo = logical_not(self.masks[chip][0][j0:j1])
          Mj = VTKMultiply(Mj,Mjo)
#       if (second and flat and f.objname[:8]=="flat_obj") or (flat:
       if "Flat" in os.path.basename(skyframe):
          Mj = Mj * sumF
#       M[j0:j1] = Mj.astype(float32)
#       qdump("Mj.fits",Mj)
#       exit()

       if NP:
         G = FITS(tempframe,readonly=0)
         G.writesec(Mj,[0,j0],[Mshape[1]-1,j1-1])
         G.close()
       else:
         tname1 = os.path.dirname(tempframe)+"/"+os.path.basename(tempframe).replace(".fits","_%04d.fits"%(j0))
         qdump(tname1,Mj)

       if verb: sys.stdout.write("."); sys.stdout.flush()

   def Shift(self,NDS,first=1,second=0,verb=0,mport=-1,chips=[1,2,3,4]):
      if isinstance(NDS,StringType):
         print "Reading NDS",NDS
         fEpck = open(NDS,"rb")
         Exposures = cPickle.load(fEpck)
         fEpck.close()
      else:
         print "Exposure list!"
         Exposures = NDS
      NP =  int(os.environ.get("NP",0))
      Exposures = [e for e in Exposures if not e.bad]
      fsky = array([e.sky for e in Exposures])
      bab = (sum(fsky) and (sum(fsky) < len(fsky)))
      if Exposures[0].sky:
         bab = 0
         fsky = zeros(fsky.shape)
      if bab:
         Exposures = [e for e in Exposures if not e.sky]
      ne = [j for j in range(len(Exposures)) if Exposures[j].name == self.name]
      if not len(ne):
         raise NameError("%r seems to not be in the list?" % (self))
      ne = ne[0]
      if first: stage = 1
      elif second: stage = 2

      F = FITS(getattr(self,"sfits%d"%(stage))(chips[0]))
      exptime = F["exptime"]
      F.close()
      if ne:
         ref = Exposures[ne-1]
         Fref = FITS(getattr(ref,"sfits%d"%(stage))(chips[0]))
         refexptime = Fref["exptime"]
         Fref.close()
         refim = Exposures[ne-1].name
         yoff1 = self.raoff
         xoff1 = -self.decoff
         yoff2 = ref.raoff
         xoff2 = -ref.decoff
# THIS IS THE OPPOSITE SIGN OF WHAT IS EXPECTED
         xo = -(xoff2-xoff1)
         yo = -(yoff2-yoff1)
         xo0 = xo
         yo0 = yo
         ux1,uy1,uf1,um1,us1,ut1,ura1,udec1 = [[] for j in range(8)]
         ux2,uy2,uf2,um2,us2,ut2,ura2,udec2 = [[] for j in range(8)]
         ax1,ay1,af1,am1,as1,at1,ara1,adec1 = [[] for j in range(8)]
         ax2,ay2,af2,am2,as2,at2,ara2,adec2 = [[] for j in range(8)]
         sexes = []
         cats = []
         for chip in chips:
            if first:
               cat = self.cat1(chip)
               sfits = self.sfits1(chip)
            elif second:
               cat = self.cat2(chip)
               sfits = self.sfits2(chip)
            if os.path.exists(cat):
               f = open(cat,"r")
               c = f.read()
               f.close()
               if c: runsex = False
               else: runsex = True
            else: runsex = True
            if runsex:
               if len(chips) > 1 and mport>-1:
                  ttask = TwistedTask(-1,"FourCLiftProcess.Sextractor",sfits,cat,scale=self.scale,thresh=5,saturate=50e3)
                  ttask.setModules(["FourCLiftProcess"])
                  ttask.setPath(os.getcwd())
                  sexes.append(ttask)
                  cats.append(cat)
               elif len(chips) > 1 and NP:
                  ttask = lambda sc: Sextractor(sc[0],sc[1],scale=self.scale,thresh=5,saturate=50e3)
                  sexes.append([sfits,cat])
                  cats.append(cat)
               else:
                  Sextractor(sfits,cat,scale=self.scale,thresh=5,saturate=50e3)
         if sexes:
            print sexes
            if mport > -1:
                Hub = HubDispatch( sexes, hub=("localhost",9000+mport), stayalive=1,mport=0,sleeptime=0.1,verb=1)
                WatchDispatcher(Hub)
#                Hub.tasks.extend(sexes)
                print "Hub done."
                while [cat for cat in cats if not os.path.exists(cat)]:
                  print "waiting for cats"
#                  reactor.iterate(1)
                  print [cat for cat in cats if not os.path.exists(cat)]
                  time.sleep(1)
            elif NP:
               RunForkedQueue(ttask,sexes,MaxThreads=NP,monitor=0,sleeptime=0.01)
         for chip in chips:
            if first:
               cat = self.cat1(chip)
               sfits = self.sfits1(chip)
               rcat = ref.cat1(chip)
               rfits = ref.sfits1(chip)
            elif second:
               cat = self.cat2(chip)
               sfits = self.sfits2(chip)
               rcat = ref.cat2(chip)
               rfits = ref.sfits2(chip)

            if self.fclass == "newfirm":
              gain,rn = 8.0,25.0
            elif self.fclass == "fourstar":
              if self.gain[0] == "F": gain,rn = 2.5,20.0
              elif self.gain[0] == "L": gain,rn = 1.3,15.0
              gain = gain*len(self.loop)
              rn = rn/sqrt(len(self.loop))

            F1 = FITS(sfits)
            skyval1 = F1["mode"]
            if skyval1 == "N/A":
               skyval1 = F1["median"]
            F1.close()
            skynoise1 = sqrt(skyval1/gain+(rn/gain)**2)

            F2 = FITS(rfits)
            skyval2 = F2["mode"]
            if skyval2 == "N/A":
               skyval2 = F2["median"]
            F2.close()
            skynoise2 = sqrt(skyval2/gain+(rn/gain)**2)

            sex1 = readsex(cat)
            sex2 = readsex(rcat)
            x1,y1 = sex1["X_IMAGE"],sex1["Y_IMAGE"]
            x2,y2 = sex2["X_IMAGE"],sex2["Y_IMAGE"]
            w1 = sex1["FWHM_IMAGE"]
            w2 = sex2["FWHM_IMAGE"]
            a1 = sex1["A_IMAGE"]
            a2 = sex2["A_IMAGE"]
            b1 = sex1["B_IMAGE"]
            b2 = sex2["B_IMAGE"]
            f1 = sex1["FLAGS"]
            f2 = sex2["FLAGS"]
            m1 = sex1["MAG_APER"]
            m2 = sex2["MAG_APER"]
            s1 = sex1["BACKGROUND"]
            s2 = sex2["BACKGROUND"]
            if "MAG_AUTO" in sex1 and "MAG_AUTO" in sex2:
               t1 = sex1["MAG_AUTO"]
               t2 = sex2["MAG_AUTO"]
            else:
               t1 = sex1["MAG_BEST"]
               t2 = sex2["MAG_BEST"]
            d1 = t1 - m1
            d2 = t2 - m2
            thisto0 = time.time()

            ix1 = (x1/10).astype(int32)
            iy1 = (y1/10).astype(int32)
            ix2 = (x2/10).astype(int32)
            iy2 = (y2/10).astype(int32)
            sx1,sy1 = {},{}
            sx2,sy2 = {},{}
            [sx1.__setitem__(i1,sx1.get(i1,0)+1) for j,i1 in enumerate(ix1)]
            [sy1.__setitem__(i1,sy1.get(i1,0)+1) for j,i1 in enumerate(iy1)]
            [sx2.__setitem__(i2,sx2.get(i2,0)+1) for j,i2 in enumerate(ix2)]
            [sy2.__setitem__(i2,sy2.get(i2,0)+1) for j,i2 in enumerate(iy2)]
            nx1 = array([sx1[i1] for i1 in sx1])
            ny1 = array([sy1[i1] for i1 in sy1])
            nx2 = array([sx2[i2] for i2 in sx2])
            ny2 = array([sy2[i2] for i2 in sy2])
            mx1 = median(compress(nx1,nx1))
            my1 = median(compress(ny1,ny1))
            mx2 = median(compress(nx2,nx2))
            my2 = median(compress(ny2,ny2))
            gx1 = array([sx1[i1] for i1 in ix1])
            gy1 = array([sy1[i1] for i1 in iy1])
            gx2 = array([sx2[i2] for i2 in ix2])
            gy2 = array([sy2[i2] for i2 in iy2])
#            histo1 = less(gx1,2*mx1)*less(gy1,2*my1)
#            histo2 = less(gx2,2*mx2)*less(gy2,2*my2)
#            x1,y1,f1,m1,s1,t1,w1,d1,a1,b1 = compress(histo1,[x1,y1,f1,m1,s1,t1,w1,d1,a1,b1],1)
#            x2,y2,f2,m2,s2,t2,w2,d2,a2,b2 = compress(histo2,[x2,y2,f2,m2,s2,t2,w2,d2,a2,b2],1)
            thisto1 = time.time()
#            print "Histogram kill in %s seconds." % (thisto1-thisto0)

            inside1 = between(x1,100,2048-100)*between(y1,100,2048-100)
            inside2 = between(x2,100,2048-100)*between(y2,100,2048-100)
            inside1 = inside1*less(f1,16)*between(w1,1.5,30)*less(d1,0.25)
            inside2 = inside2*less(f2,16)*between(w2,1.5,30)*less(d2,0.25)
            inside1 = inside1*greater(a1,0.3)*greater(b1,0.3)
            inside2 = inside2*greater(a2,0.3)*greater(b2,0.3)
            inside1 = inside1*between(s1,-5*skynoise1,5*skynoise1)
            inside2 = inside2*between(s2,-5*skynoise2,5*skynoise2)
            x1,y1,f1,m1,t1,s1 = compress(inside1, [x1,y1,f1,m1,t1,s1], 1)
            x2,y2,f2,m2,t2,s2 = compress(inside2, [x2,y2,f2,m2,t2,s2], 1)
#            use1 = argsort(m1)[:1000]
#            use2 = argsort(m2)[:1000]
#            x1,y1,f1,m1,t1,s1 = take([x1,y1,f1,m1,t1,s1], use1, 1)
#            x2,y2,f2,m2,t2,s2 = take([x2,y2,f2,m2,t2,s2], use2, 1)
            if self.fclass == "newfirm":
               if self.mjd < 54480:
                   soln = join([os.environ["PYTHONDATA"],"photometry","image3526c%d.soln" % (chip)],"/")
               else:
                   soln = join([os.environ["PYTHONDATA"],"photometry","image52627c%d.soln" % (chip)],"/")
            elif self.fclass == "fourstar":
               if self.mjd < 55700:
                  soln = join([os.environ["PYTHONDATA"],"photometry","fourstar201101c%d.soln" % (chip)],"/")
               else:
                  soln = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % (self.filter,chip)],"/")
                  if not os.path.exists(soln):
                     soln = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % ("J",chip)],"/")
            ra1,dec1 = xy2rd(soln,x1,y1,text=0)
            ra2,dec2 = xy2rd(soln,x2,y2,text=0)
            use1 = argsort(t1)[:40]
            use2 = argsort(t2)[:40]
            vx1,vy1,vf1,vm1,vt1,vra1,vdec1 = take([x1,y1,f1,m1,t1,ra1,dec1],use1,1)
            vx2,vy2,vf2,vm2,vt2,vra2,vdec2 = take([x2,y2,f2,m2,t2,ra2,dec2],use2,1)
            ux1,uy1,uf1,um1,ut1,ura1,udec1 = [concatenate([a,b]) for a,b in \
                    zip([ux1,uy1,uf1,um1,ut1,ura1,udec1], [vx1,vy1,vf1,vm1,vt1,vra1,vdec1])]
            ux2,uy2,uf2,um2,ut2,ura2,udec2 = [concatenate([a,b]) for a,b in \
                    zip([ux2,uy2,uf2,ut2,um2,ura2,udec2], [vx2,vy2,vf2,vm2,vt2,vra2,vdec2])]
            ax1,ay1,af1,am1,at1,ara1,adec1 = [concatenate([a,b]) for a,b in \
                    zip([ax1,ay1,af1,am1,at1,ara1,adec1], [x1,y1,f1,m1,t1,ra1,dec1])]
            ax2,ay2,af2,am2,at2,ara2,adec2 = [concatenate([a,b]) for a,b in \
                    zip([ax2,ay2,af2,am2,at2,ara2,adec2], [x2,y2,f2,m2,t2,ra2,dec2])]
         cra = mean(extrema(ura1))
         cdec = mean(extrema(udec1))
         ux1,uy1 = normalcoord(ura1,udec1,cra,cdec,conv=3600*180/pi)
         ux2,uy2 = normalcoord(ura2,udec2,cra,cdec,conv=3600*180/pi)
         x1,y1 = normalcoord(ara1,adec1,cra,cdec,conv=3600*180/pi)
         x2,y2 = normalcoord(ara2,adec2,cra,cdec,conv=3600*180/pi)
         t1 = at1
         t2 = at2
         dx1 = (ux1[::,NewAxis] - ux1[NewAxis,::])
         dy1 = (uy1[::,NewAxis] - uy1[NewAxis,::])
         dx2 = (ux2[::,NewAxis] - ux2[NewAxis,::])
         dy2 = (uy2[::,NewAxis] - uy2[NewAxis,::])
         du = (ux1[::,NewAxis] - ux2[NewAxis,::])
         dv = (uy1[::,NewAxis] - uy2[NewAxis,::])
         dr = sqrt(du**2+dv**2)
         ds1 = sqrt(dx1**2+dy1**2)
         ds2 = sqrt(dx2**2+dy2**2)
         dt1 = arctan2(dy1,dx1)*180/pi
         dt2 = arctan2(dy2,dx2)*180/pi
         D = ds1.shape[0]
         ns = []
         th = 1.5
         for D1 in range(D):
             ds = ds1[D1:D1+1,::,NewAxis,NewAxis] - ds2[NewAxis,NewAxis,::,::]
             dt = dt1[D1:D1+1,::,NewAxis,NewAxis] - dt2[NewAxis,NewAxis,::,::]
             th2d = clip(0.01*th*ds2[NewAxis,NewAxis,::,::],0.3,1.0)
#             th2d = th
             uds1 = less(abs(ds),th2d).astype(float32)
             uds2 = less(abs(dt),0.05).astype(float32)
             uds = evaluate("uds1*uds2")
             udr = less(dr,250).astype(float32)[NewAxis,::,NewAxis]
#         udr = less(dr,250)[::,NewAxis,::,NewAxis]
             uds = uds*udr
             ns1 = add.reduce(uds,3)
             ns = concatenate([ns,ns1],0)
         ns = asarray(ns)
         ns = add.reduce(ns,1)

         mns = ns.shape[0]/4
         cns = compress(ns.ravel(),ns.ravel())
         if not len(cns):
            xo,xr= -9999,-9999
            yo,yr= -9999,-9999
            to,tr= -9999,-9999
            lmat = 0
            open(sfits+".bad","w").close()
         else:
            mns = 0.75*max(cns)
            print sort(list(Set(ns.ravel())))[-10:],ns.shape[0],mns
            jm,km = transpose([(j,argmax(ns1)) for j,ns1 in enumerate(ns) if max(ns1) >= mns])
            dx = take(ux2,km)-take(ux1,jm)
            dy = take(uy2,km)-take(uy1,jm)
            dt = take(ut2,km)-take(ut1,jm)
            xb = bwt(dx)
            yb = bwt(dy)
            tb = bwt(dt)
            xo,xr = xb
            yo,yr = yb
            to,tr = tb
            lmat = len(dx)
            print "%3d %4.1f %3d %10.4f+-%.4f %10.4f+-%.4f %10.4f+-%.4f %s %s" % (0,th,lmat,xo,xr,yo,yr,to,tr,ref.base,self.base)
            th = 2.0
            if NP > 1: PGPLOT_DEV = self.scratch("shift%d/%s.ps" % (stage,self.name))+"/vcps"
            else: PGPLOT_DEV = os.getenv("PGPLOT_DEV")
            if PGPLOT_DEV and PGPLOT_DEV[:2] != "/x":
               so = open(self.scratch("shift%d/%s.out" % (stage,self.name)),"w")
               print >>so, "%3d %4.1f %3d %10.4f+-%.4f %10.4f+-%.4f %10.4f+-%.4f %s %s" % (0,th,lmat,xo,xr,yo,yr,to,tr,ref.base,self.base)
            for niter in range(5):
               csize = 100
               chunks = len(x2)/csize+1
               m1 = []
               m2 = []
               for c in range(chunks):
                  c0 = c*csize
                  c1 = (c+1)*csize
                  if niter and ao:
                     x1b,y1b = mbasis(rotsol,x1,y1,rot=1)
                  else:
                     x1b = x1 + xo
                     y1b = y1 + yo
                  dx = (x2[c0:c1,NewAxis]-x1b[NewAxis,::])
                  dy = (y2[c0:c1,NewAxis]-y1b[NewAxis,::])
                  ds = sqrt(dx**2 + dy**2)
                  okay = less(ds,th)
                  j1 = argmin(ds,1)
                  m2a = [j2 for j2 in range(len(dx)) if okay[j2,j1[j2]]]
                  if len(m2a):
                     m1a = take(j1,m2a)
                     m2 = concatenate([m2,add(m2a,c0)])
                     m1 = concatenate([m1,m1a])
               x1m = take(x1,m1)
               y1m = take(y1,m1)
               t1m = take(t1,m1)
               x2m = take(x2,m2)
               y2m = take(y2,m2)
               t2m = take(t2,m2)
               xb = bwt(x2m-x1m)
               yb = bwt(y2m-y1m)
               tb = bwt(t2m-t1m)+2.5*log10(refexptime)-2.5*log10(exptime)
               xo,xr= xb
               yo,yr= yb
               to,tr= tb
               if len(x1m)>1:
                  ab1 = abasis(0,x1m,y1m,rot=1)
                  xy2 = concatenate([x2m,y2m])
                  rotsol = svdfit(ab1,xy2)
                  xo = rotsol[0]
                  yo = rotsol[1]
                  ao = arctan2(rotsol[3],rotsol[2])*180/pi
               else:
                  ao = 0.0
               lmat = len(x2m)
               print "%3d %4.1f %3d %10.4f+-%.4f %10.4f+-%.4f %10.4f+-%.4f %s %s" % (niter+1,th,lmat,xo,xr,yo,yr,to,tr,ref.base,self.base)
####            th = max([15./(1+niter),4*sqrt(xb[1]**2+yb[1]**2)])
               th = max([2.0,5*sqrt(xb[1]**2+yb[1]**2)])
               if verb:
                  if (PGPLOT_DEV and PGPLOT_DEV[:2] != "/x" and niter==4) \
                          or (PGPLOT_DEV and PGPLOT_DEV[:2] == "/x"):
                      if (PGPLOT_DEV and PGPLOT_DEV[:2] != "/x" and niter==4) \
                          or (PGPLOT_DEV and PGPLOT_DEV[:2] == "/x" and niter==0):
                         opendev(PGPLOT_DEV,nx=1,ny=1,size=8.5,land=0,asp=1,ask=0)
                         cpgscr(1,0,0,0)
                         cpgscr(0,1,1,1)
                      newbox(extrema(x1),extrema(y1),ch=1.5)
                      xlabel("X",ch=1.5)
                      ylabel("X",ch=1.5)
                      title = "%s-%s [%d]" % (ref.base,self.base,chip)
                      subtitle(title,ch=1.5)
                      drawpt(x2,y2,ps=17,ch=3,ci=2)
                      drawpt(x1+xo,y1+yo,ps=4,ch=2,ci=4)
                      drawpt(x1,y1,ps=4,ch=1.5,ci=7)
                      drawpt(x1+xo0,y1+yo0,ps=17,ch=1,ci=5)
                  if PGPLOT_DEV and PGPLOT_DEV[:2] != "/x":
                     print >>so, "%3d %4.1f %3d %10.4f+-%.4f %10.4f+-%.4f %10.4f+-%.4f %s %s" % (niter+1,th,lmat,xo,xr,yo,yr,to,tr,ref.base,self.base)
            if verb:
####            PGPLOT_DEV = os.getenv("PGPLOT_DEV")
               if PGPLOT_DEV and PGPLOT_DEV[:2] == "/x": raw_input("hit <cr>")
               if NP > 1 or PGPLOT_DEV[:2] == "/x":
                   closedev()
                   pstopng(PGPLOT_DEV.replace("/vcps",""))
               if PGPLOT_DEV and PGPLOT_DEV[:2] != "/x": so.close()
      else:
         sexes = []
         cats = []
         for chip in chips:
            if first:
               cat = self.cat1(chip)
               sfits = self.sfits1(chip)
            elif second:
               cat = self.cat2(chip)
               sfits = self.sfits2(chip)
            if os.path.exists(cat):
               f = open(cat,"r")
               c = f.read()
               f.close()
               if c: runsex = False
               else: runsex = True
            else: runsex = True
            if runsex:
               if len(chips) > 1 and mport>-1:
                  ttask = TwistedTask(-1,"FourCLiftProcess.Sextractor",sfits,cat,scale=self.scale,thresh=5,saturate=50e3)
                  ttask.setModules(["FourCLiftProcess"])
                  ttask.setPath(os.getcwd())
                  sexes.append(ttask)
                  cats.append(cat)
               elif len(chips) > 1 and NP:
                  ttask = lambda sc: Sextractor(sc[0],sc[1],scale=self.scale,thresh=5,saturate=50e3)
                  sexes.append([sfits,cat])
                  cats.append(cat)
               else:
                  Sextractor(sfits,cat,scale=self.scale,thresh=5,saturate=50e3)
         if sexes:
            print sexes
            if mport > -1:
               Hub = HubDispatch( sexes, hub=("localhost",9000+mport), stayalive=1,mport=0,sleeptime=0.1,verb=1)
               WatchDispatcher(Hub)
#               Hub.tasks.extend(sexes)
               print "Hub done."
               while [cat for cat in cats if not os.path.exists(cat)]:
                 print "waiting for cats"
#                 reactor.iterate(1)
                 print [cat for cat in cats if not os.path.exists(cat)]
                 time.sleep(1)
            elif NP:
               RunForkedQueue(ttask,sexes,MaxThreads=NP,monitor=0,sleeptime=0.01)
         xo = 0.0
         yo = 0.0
         ao = 0.0
         to = 0.0
         xr = 0.0
         yr = 0.0
         tr = 0.0
         lmat = 0
         refim = Exposures[0].name
      for chip in chips:
         if first:
            cat = self.cat1(chip)
            sfits = self.sfits1(chip)
         elif second:
            cat = self.cat2(chip)
            sfits = self.sfits2(chip)
         if os.path.exists(sfits):
            F = FITS(sfits,readonly=0)
            F.modkey("refim1",refim)
            F.modkey("lmatch1",lmat)
            F.modkey("xdiff1",xo)
            F.modkey("ydiff1",yo)
            F.modkey("adiff1",ao)
            F.modkey("mdiff1",to)
            F.modkey("xscat1",xr)
            F.modkey("yscat1",yr)
            F.modkey("mscat1",tr)
            F.close()

def Sextractor(image,catalog,sexdir="./sex/",scale=0.16,thresh=3.0,saturate=55e3,seeing=1.3,segm=0,clean=1):
      simage = image.replace(".fits","sig.fits")
      uu = str(uuid.UUID(bytes=os.urandom(16),version=4).time_low)
#      uu = ""
      if "Stack" not in image and "Mosaic" not in image:
         uimage = "/tmp/"+uu+os.path.basename(image)
         uimage2 = "/tmp/"+uu+os.path.basename(image).replace(".fits","bck.fits")
         F = FITS(image)
         d = F.data()
         F.close()
         d = evaluate("where((d>-1e24)&(d<1e24),d,0.0)")
         w = evaluate("d!=0").astype(float32)
#         qdump("/tmp/d.fits",d)
#         qdump("/tmp/w.fits",w)
#         ds = VTKMedianSmooth(d,256,256)
#         m = evaluate("where(d!=0,d-ds,-1e31)")
         print image,uimage
         b,m,s2 = ModalSmooth(d,w,64,3,cut=0)
#         return image,catalog
#         G = FITS(uimage2,create=1,template=image)
#         G.putdata(b)
#         G.close()
#         m = evaluate("where(d!=0,m,-1e31)")
         mo = not_equal(d,0).astype(float32)
         mg = divz(VTKGauss(m*mo,1,1),VTKGauss(mo,1,1))
         m = evaluate("where(d!=0,m,mg)")
         m = evaluate("where(m!=0,m,-1e31)")
         G = FITS(uimage,create=1,template=image)
         G.putdata(m)
         G.close()
         flg = None
         print uimage,os.path.exists(uimage)
         tw = 0
         while not os.path.exists(uimage) and tw < 20:
           print uimage,os.path.exists(uimage)
           time.sleep(0.1)
           tw += 1
         if not os.path.exists(uimage):
            raise IOError("%s not found!" % (uimage))
         sexcom = ["sex "+uimage.replace(" ","\\ ")]
         sexcom += ["-c "+sexdir+"default.sex"]
         chip = int(image.split(".")[-2][-1])
#         sexcom += ["-WEIGHT_TYPE BACKGROUND"]
#         sexcom += ["-WEIGHT_IMAGE maskc%d.fits" % (chip)]
      else:
         F = FITS(image)
         d = F.data()
         F.close()
         d = evaluate("where((d>-1e24)&(d<1e24),d,0.0)").astype(float32)
         simage = image.replace(".fits","sig.fits")
         if os.path.exists(simage):
            F = FITS(image.replace(".fits","sig.fits"))
            s = F.data()
            F.close()
            s = evaluate("where((s>-1e24)&(s<1e24),s,0.0)").astype(float32)
            s = evaluate("where(s!=0,s,-1e31)")
         w = evaluate("d!=0").astype(float32)
         b,m,s2 = ModalSmooth(d,w,128,7,pct=25,cut=0)
         m = evaluate("where(d!=0,m,-1e31)")
         if 0:
#            b = 3*VTKDivide(VTKMeanSmooth(d*w,128,128,1),VTKMeanSmooth(w,128,128,1)) - \
#                    2*VTKMedianSmooth(d,128,128,1)
            b1 = VTKMedianSmooth(d*w,128,128,1)
            b2 = VTKDivide(VTKMeanSmooth(VTKAbs(VTKSubtract(d,b1))*w,128,128,1), VTKMeanSmooth(w,128,128,1))
            w = w*less_equal(VTKAbs(VTKSubtract(d,b1)),3*b2)
            b = VTKDivide(VTKLevel(d*w,5,k=3,verb=1), VTKLevel(w,5,k=3,verb=1))
            if "Stack2" in image or "Mosaic2" in image:
               m = evaluate("where(d!=0,d,-1e31)")
            else:
               m = evaluate("where(d!=0,d-b,-1e31)")
#            b = VTKMedianSmooth(d*w,512,3,1)
#            m = where(w,d-b,0)
#            b = VTKMedianSmooth(m*w,3,512,1)
#            m = where(w,m-b,0)
#            flg = where(logical_or(equal(s,0),equal(m,0)),1,0)
         print "FLG EVALUATE",s.shape, m.shape
         flg = evaluate("where(((s==0)|(m==0)),1,0)")
         G = FITS("/tmp/"+uu+os.path.basename(image),create=1,template=image)
         G.putdata(m)
         G.close()
         G = FITS("/tmp/"+uu+os.path.basename(image.replace(".fits","sig.fits")),create=1,template=image)
         G.putdata(s)
         G.close()
         G = FITS(image.replace(".fits","flg.fits"),create=1,template=image)
         G.modkey("bitpix",16)
         G.close()
         G = FITS(image.replace(".fits","flg.fits"),readonly=0)
         G.putdata(flg.astype(int16))
         G.close()
         G = FITS(image.replace(".fits","smo.fits"),create=1,template=image)
         G.putdata(b)
         G.close()
         G = FITS(image.replace(".fits","sex.fits"),create=1,template=image)
         G.putdata(m)
         G.close()
         G = FITS(image.replace(".fits","sexsig.fits"),create=1,template=image)
         G.putdata(s)
         G.close()
         uimage = "/tmp/"+uu+os.path.basename(image)
         tw = 0
         while not os.path.exists(uimage) and tw < 20:
            print uimage,os.path.exists(uimage)
            time.sleep(0.1)
            tw += 1
         if not os.path.exists(uimage):
            raise IOError("%s not found!" % (uimage))
         sexcom = ["sex /tmp/"+uu+os.path.basename(image)]
         sexcom += ["-c "+sexdir+"default.sex"]
#         sexcom += ["-WEIGHT_TYPE MAP_RMS"]
#         sexcom += ["-WEIGHT_IMAGE /tmp/"+uu+os.path.basename(image.replace(".fits","sig.fits"))]
         sexcom += ["-FLAG_IMAGE "+image.replace(".fits","flg.fits").replace(" ","\\ ")]
         sexcom += ["-FLAG_TYPE AND"]
         chip = 0
      sexcom += ["-MAG_ZEROPOINT 25"]
      sexcom += ["-INTERP_MAXXLAG 32"]
      sexcom += ["-INTERP_MAXYLAG 32"]
      sexcom += ["-INTERP_TYPE ALL"]
#      if "Stack2" in image or "Mosaic2" in image:
#         sexcom += ["-BACK_TYPE MANUAL"]
#         sexcom += ["-BACK_VALUE 0.0"]
#         sexcom += ["-BACK_FILTTHRESH  0.0"]
      sexcom += ["-PARAMETERS_NAME "+sexdir+"default.param"]
      sexcom += ["-DETECT_MINAREA 3"]
      sexcom += ["-DETECT_THRESH "+str(thresh)]
      sexcom += ["-BACK_SIZE 65"]
      sexcom += ["-BACK_FILTERSIZE 5"]
      sexcom += ["-ANALYSIS_THRESH "+str(thresh)]
      sexcom += ["-PIXEL_SCALE %f" % (scale)]
      sexcom += ["-SEEING_FWHM %f" % (seeing)]
      tmpcat = "/tmp/%s" % (uu+os.path.basename(catalog))
      sexcom += ["-CATALOG_NAME "+tmpcat]
      if segm:
         sexcom += ["-CHECKIMAGE_TYPE SEGMENTATION,BACKGROUND"]
         segm = image.replace(".fits","seg.fits")
         bgm = image.replace(".fits","bck.fits")
         uusegm = "/tmp/"+uu+os.path.basename(image).replace(".fits","seg.fits")
         uubgm = "/tmp/"+uu+os.path.basename(image).replace(".fits","bck.fits")
         sexcom += ["-CHECKIMAGE_NAME %s,%s" %(uusegm,uubgm)]
      else:
         sexcom += ["-CHECKIMAGE_TYPE NONE"]
         uusegm = None
         uubgm = None
#      if "Stack" not in image and "Mosaic" not in image: sexcom += ["-FILTER_NAME "+sexdir+"gauss_3.0_5x5.conv"]
#      else: sexcom += ["-FILTER_NAME "+sexdir+"mexhat_2.0_7x7.conv"]
#      sexcom += ["-FILTER_NAME "+sexdir+"gauss_3.0_5x5.conv"]
#      sexcom += ["-FILTER_NAME "+sexdir+"mexhat_1.5_5x5.conv"]
      sexcom += ["-FILTER_NAME "+sexdir+"gauss_1.5_3x3.conv"]
      sexcom += ["-STARNNW_NAME "+sexdir+"default.nnw"]
      sexcom += ["-SATUR_LEVEL "+str(saturate)]
      sexcom += ["-VERBOSE_TYPE QUIET"]
      command = " ".join(sexcom)
      verbsh(command)
#      sc = open("/tmp/sc","w")
#      print >>sc, command
#      sc.close()
      while not os.path.exists( tmpcat):
          print tmpcat, os.path.exists( tmpcat)
          time.sleep(1)
          raise IOError( "%s does not exist!"%(tmpcat))

      f = open(tmpcat,"r")
      fdat = f.read()
      f.close()
      if os.path.exists(catalog): catalog=catalog+str(len(glob(catalog+"*")))
      g = open(catalog,"w")
      g.write(fdat)
      g.close()
      if uusegm:
         shutil.copyfile(uusegm,segm)
         shutil.copyfile(uubgm,bgm)
      if clean:
         tmpimage = "/tmp/"+uu+os.path.basename(image)
         tmpsimage = "/tmp/"+uu+os.path.basename(simage)
         [os.remove(fclean) for fclean in [tmpcat,tmpimage,tmpsimage,uusegm,uubgm] if fclean and os.path.exists(fclean)]

def Offsets( Exposures, chip):
   mXs = []
   mYs = []
   sXs = []
   sYs = []
#   e1 = lambda E: [E2 for E2 in Exposures if E.expno==E2.expno]
##   e1 = lambda E: [E2 for E2 in e0(E) if E2.jno == 1]
#   sfits = lambda E,c: e1(E)[0].sfits1(c)
#   cs = [c for c in [1,2,3,4] if FileCheck(sfits(Exposures[0],c))]
   sfits = lambda E,c: E.sfits1(c)
   ol = {}
   for E in Exposures:
       if E.oloop[0] not in ol:
          n = [c for c in [1,2,3,4] if FileCheck(sfits(E.oloop[0],c))]
          ol[E.oloop[0]] = len(ol),n
#   cs = ol.values()[0]
   oExposures = ol.keys()
   j = [ol[key][0] for key in oExposures]
   cs2 = [ol[key][1] for key in oExposures]
   oExposures = [oExposures[o] for o in argsort(j)]
   cs2 = [cs2[o] for o in argsort(j)]
   cs = cs2[0]
   xscale = Exposures[0].scale
   yscale = Exposures[0].scale
   xdiffs = {}
   ydiffs = {}
   for c in cs:
       for E in Exposures:
           if E == E.oloop[0]:
              G = FITS(sfits(E.oloop[0],c)) 
              xdiffs[E] = G["xdiff1"]
              ydiffs[E] = G["ydiff1"]
              G.close()
           else:
              xdiffs[E] = 0.0
              ydiffs[E] = 0.0
#       G = [FITS(sfits(E.oloop[0],c)) for E in oExposures if FileCheck(sfits(E.oloop[0],c))]
#       gX = array([g["xdiff1"] for g in G])/xscale
#       gY = array([g["ydiff1"] for g in G])/yscale
#       [g.close() for g in G]
       gX = array([xdiffs[E] for E in Exposures])/xscale
       gY = array([ydiffs[E] for E in Exposures])/yscale
       gXs = add.accumulate(gX)
       gYs = add.accumulate(gY)
       mX0,mX1 = extrema(gXs)
       mY0,mY1 = extrema(gYs)
       sX = mX1 - mX0
       sY = mY1 - mY0
       sXs.append(sX)
       sYs.append(sY)
       mXs.append(mX0)
       mYs.append(mY0)
#   print sXs
#   print sYs
#   raw_input("<cr> ")
   aX = argmax(sXs)
   aY = argmax(sYs)
   sX = int(sXs[aX])
   sY = int(sYs[aY])
   mX0 = mXs[aX]
   mY0 = mYs[aY]
   if Exposures[0].fclass == "newfirm":
      if Exposures[0].mjd < 54480:
         s = add((2048,2048),(sX,sY)).astype(int32)+1
         solnfile = join([os.environ["PYTHONDATA"],"photometry","image3526c%d.soln" % (chip)],"/")
      else:
         s = add((2048,2048),(sY,sX)).astype(int32)+1
         solnfile = join([os.environ["PYTHONDATA"],"photometry","image52627c%d.soln" % (chip)],"/")
   elif Exposures[0].fclass == "fourstar":
      if Exposures[0].mjd < 55700:
         s = add((2048,2048),(sY,sX)).astype(int32)+1
         solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar201101c%d.soln" % (chip)],"/")
      else:
         s = add((2048,2048),(sY,sX)).astype(int32)+1
         solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % (Exposures[0].filter,chip)],"/")
         if not os.path.exists(solnfile):
            solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % ("J",chip)],"/")
   print "Reading",solnfile
   solndat = readsoln(solnfile)
#   F = [FITS(sfits(E.oloop[0],chip)) for E in Exposures if FileCheck(sfits(E.oloop[0],chip))]
#   X = array([f["xdiff1"] for f in F])/xscale
#   Y = array([f["ydiff1"] for f in F])/yscale
#   [f.close() for f in F]
   X = array([xdiffs[E] for E in Exposures])/xscale
   Y = array([ydiffs[E] for E in Exposures])/yscale
   Xd = add.accumulate(X)
   Yd = add.accumulate(Y)
   Xs = s[1]/2. - solndat["center"][0]
   Ys = s[0]/2. - solndat["center"][1]
   Xm = mean(extrema(Xd))
   Ym = mean(extrema(Yd))
   Xd = Xd - Xm
   Yd = Yd - Ym
   Xz = Xd
   Yz = Yd
   return Xz,Yz,Xs,Ys

def Job(func,args):
   os.nice(15)
   chips = [1,2,3,4]
   dicts = [{"args":(chip,),"keywords":args} for chip in chips]
   print func.__name__
   queue = TwistedObjectQueue(func.__name__,dicts)
   queue.repeatable = False
   queue.Run(forks=False,sleeptime=0.02)
   print queue.results

def ShiftsCheck(NDS,chips,stage,flat,p):
#    if isinstance(NDS[0],newfirm):
#       print "NEWFIRM FourCLiftDataset!"
#       UseExposures = [Exposure(N1) for N1 in NDS]
#    elif isinstance(NDS[0],fourstar):
#       print "FourStar FourCLiftDataset!"
#       UseExposures = [Exposure(N1) for N1 in NDS]
    if isinstance(NDS,StringType):
       fEpck = open(NDS,"rb")
       UseExposures = cPickle.load(fEpck)
       fEpck.close()
    else:
       print "Exposure list!"
       UseExposures = NDS
    print "Checking the shifts, iteration No. %d" % (p)
    chip = chips[0]
    xd,yd,ad,md,xs,ys,ms,nn = [{} for j in range(8)]
    fn = {}
    tn = {}
    qn = {}
    en = {}
    sn = {}
    wn = {}
    Exposures = [E for E in UseExposures if not E.bad]
    fsky = array([e.sky for e in Exposures])
    bab = not flat and (sum(fsky) and (sum(fsky) < len(fsky)))
    if Exposures[0].sky:
       bab = 0
       fsky = zeros(fsky.shape)
    if bab:
       Exposures = [E for E in Exposures if not E.sky]
       sExposures = [e for e in Exposures if e.sky]
    else:
       sExposures = Exposures

    for E in Exposures:
        f = eval("E.sfits"+stage)(chip)
        if FileCheck(f):
           F = FITS(f)
           xd[f] = F["xdiff1"]
           yd[f] = F["ydiff1"]
           ad[f] = F["adiff1"]
           md[f] = F["mdiff1"]
           xs[f] = F["xscat1"]
           ys[f] = F["yscat1"]
           ms[f] = F["mscat1"]
           nn[f] = F["lmatch1"]
           qn[f] = F["exptime"]
           F.close()
           fn[f] = E.expno
           tn[f] = E.mjd
           en[f] = E
           sn[f] = E.sky
           cat = eval("E.cat"+stage)(chip)
           catd = readsex(cat)
           fw = catd["FWHM_IMAGE"]
           bg = catd["BACKGROUND"]
           fw = compress(not_equal(bg,0),fw)
           if len(fw): fw = median(fw)
           else: fw = 0.0
           wn[f] = fw
    fk = fn.keys()

    o = argsort([tn[f] for f in fk])
    xd = take([xd[f] for f in fk],o)
    yd = take([yd[f] for f in fk],o)
    ad = take([ad[f] for f in fk],o)
    md = take([md[f] for f in fk],o)
    xs = take([xs[f] for f in fk],o)
    ys = take([ys[f] for f in fk],o)
    ms = take([ms[f] for f in fk],o)
    tn = take([tn[f] for f in fk],o)
    nn = take([nn[f] for f in fk],o)
    sn = take([sn[f] for f in fk],o)
    qn = take([qn[f] for f in fk],o)
    wn = take([wn[f] for f in fk],o)

    xe = divz(xs,sqrt(nn))
    ye = divz(ys,sqrt(nn))
    me = divz(ms,sqrt(nn))

    xd = add.accumulate(xd)
    yd = add.accumulate(yd)
    ad = add.accumulate(ad)
    md = add.accumulate(md)
    md = md - median(md)

    xo,xr = bwt(xd)
    yo,yr = bwt(yd)
    ao,ar = bwt(ad)
    mo,mr = bwt(md)
    no,nr = bwt(nn)

    print md
    print mo,mr
    print nn
    print no,nr
    tn = tn - tn[0]

    pgdev = Exposures[0].scratch("Shifts%s_%d.ps"%(stage,p))+"/vcps"
    opendev(pgdev,nx=3,ny=2,land=0,asp=1.*2/3,size=7.5)

    xm = extrema(xd)
    xm = add(xm,[-0.1*diff(xm)[0],0.1*diff(xm)[0]])
    ym = add(extrema(yd),[-xr,xr])
    newbox(xm[::-1],ym,ch=2)
    xlabel("\gdx (arcsec)",ch=2)
    ylabel("\gdy (arcsec)",ch=2)
    drawpt(xd,yd,ps=17,ci=4,ch=3)
    drawpterr(xd,xs,yd,ys,ci=4,ch=3)
    drawpt1(xo,yo,ps=5,ci=2,ch=5)
    th = arange(0,2*pi,pi/100,float32)
    cth,sth = cos(th), sin(th)
    drawln(xo+xr*cth,yo+yr*sth,ls=1,ci=3,lw=2)

    st = diff(extrema(tn))[0]/100
    xm = add(extrema(tn),[-st,st])

    ym = multiply([-1,1],max(abs(ad)+2*ar)+ao)
    newbox(xm,ym,ch=2)
    xlabel("t-t\d0\u (d)",ch=2)
    ylabel("\gh (degrees)",ch=2)
    drawpt(tn,ad,ps=17,ci=4,ch=3)
    drawln([xm[0],xm[-1]],[-ar,-ar],ls=2,ci=3,lw=2)
    drawln([xm[0],xm[-1]],[+ar,+ar],ls=2,ci=3,lw=2)

    ym = multiply([-1,1],max(abs(md)+me+2*mr))
    newbox(xm,ym,ch=2)
    xlabel("t-t\d0\u (d)",ch=2)
    ylabel("\gdm (mag)",ch=2)
    drawpt(tn,md,ps=17,ci=4,ch=3)
    drawpterr(tn,0*tn,md,me,ci=4,ch=3)
    drawln([xm[0],xm[-1]],[-mr,-mr],ls=2,ci=3,lw=2)
    drawln([xm[0],xm[-1]],[+mr,+mr],ls=2,ci=3,lw=2)

    ym = [-0.1*max(nn),1.1*max(nn)]
    newbox(xm,ym,ch=2)
    xlabel("t-t\d0\u (d)",ch=2)
    ylabel("N",ch=2)
    drawpt(tn,nn,ps=17,ci=4,ch=3)
    drawln([xm[0],xm[-1]],[no-nr,no-nr],ls=2,ci=3,lw=2)
    drawln([xm[0],xm[-1]],[no+nr,no+nr],ls=2,ci=3,lw=2)

    ym = [-0.1*max(wn),1.1*max(wn)]
    newbox(xm,ym,ch=2)
    xlabel("t-t\d0\u (d)",ch=2)
    ylabel("median(FWHM_IMAGE)",ch=2)
    drawpt(tn,wn,ps=17,ci=4,ch=3)

    n1 = len(md)/(len(md)-1)
    b1 = greater_equal(abs(md-mo),50*max([mr,0.01]))
    b2 = where(arange(len(nn)),logical_or(b1,equal(nn,0))*greater(fw,0),0)
    b = nonzero(b2)
    f = None
    if len(b):
       E = en[fk[o[b[0]]]]
       f = eval("E.sfits"+stage)(chip)
       print "Bad:",E,f
       open(f+".bad","w").close()
    print "Before check",len(UseExposures)
#    self.Cull()
#    print "After check",len(UseExposures)
    closedev()
    pstopng(pgdev.replace("/vcps",""))

    assert (median(nn[1:]) > 4), "Probably Not Enough Objects Visible in Individual Frames!"

    return f

def Stacks(NDS,yskip=32,usemed=1,first=1,second=0,name="FirstStack.fits",justsex=0):
   NDS = [N1 for N1 in NDS if not Exposure(N1).bad]
   args = {"NDS":NDS,"yskip":yskip,"first":first,"second":second,"name":name,"justsex":justsex,"usemed":usemed}
   Job(FourCLiftStack,args)

def FourCLiftStack(chip,NDS=[],yskip=32,usemed=1,first=1,second=0,name="FirstStackcD.fits",\
        justsex=0,sigclip=0,SuperExposures=[],Hub=None,NP=-1,create=0,doj=[]):
   if NP == -1: NP = int(os.environ.get("NP",0))
#   if isinstance(NDS[0],newfirm):
#      NDS = [N1 for N1 in NDS if not Exposure(N1).bad]
#      Exposures = [Exposure(N1) for N1 in NDS]
#   elif isinstance(NDS[0],fourstar):
#      NDS = [N1 for N1 in NDS if not Exposure(N1).bad]
#      Exposures = [Exposure(N1) for N1 in NDS]
   if isinstance(NDS,StringType):
      fEpck = open(NDS,"rb")
      Exposures = cPickle.load(fEpck)
      fEpck.close()
   else:
      Exposures = NDS
   if SuperExposures:
#      if isinstance(SuperExposures[0],newfirm):
#         SuperExposures = [Exposure(N1) for N1 in SuperExposures]
#      elif isinstance(SuperExposures[0],fourstar):
#         SuperExposures = [Exposure(N1) for N1 in SuperExposures]
      if isinstance(SuperExposures,StringType):
         fEpck = open(SuperExposures,"rb")
         SuperExposures = cPickle.load(fEpck)
         fEpck.close()
   else:
      SuperExposures = Exposures
   Esky = array([E.sky for E in Exposures])
   SuperEsky = array([E.sky for E in SuperExposures])
   bab = (sum(SuperEsky) and (sum(SuperEsky) < len(SuperEsky)))
   if bab and Exposures[0].sky:
      bab = 0
      SuperEsky = zeros(SuperEsky)
      Esky = zeros(Esky)
   if bab:
     ncombine = len(Esky)
   else:
     ncombine = len(Esky) - sum(Esky)
   if first:
     sfits = lambda E,c: E.sfits1(c)
     mfits = lambda E,c: E.mfits1(c)
   elif second:
     sfits = lambda E,c: E.sfits2(c)
     mfits = lambda E,c: E.mfits2(c)
     pfits = lambda E,c: E.pers1(c)
   F = [FITS(sfits(E,chip)) for E in Exposures]
   exptimes = array([f["exptime"] for f in F])
   mdiffs = array([f["mdiff1"] for f in F])
   [f.close() for f in F]
   mdiffs = add.accumulate(mdiffs)
   mdiffs = mdiffs - median(mdiffs)
   print exptimes
   print mdiffs
   cname = name.replace("cD.fits","c"+str(chip)+".fits")
   ename = cname.replace(".fits","map.fits")
   sname = cname.replace(".fits","sig.fits")
   if not justsex:
      if 1:
         xscale = Exposures[0].scale
         yscale = Exposures[0].scale
         mXs = []
         mYs = []
         sXs = []
         sYs = []
#                     if os.path.exists(sfits(SuperExposures[0],c)):

         for c in [1,2,3,4]:
             gX,gY = [],[]
             for E in SuperExposures:
                 g = FITS(sfits(E,c))
                 gX.append(g["xdiff1"])
                 gY.append(g["ydiff1"])
                 g.close()

             gX = asarray(gX)/xscale
             gY = asarray(gY)/yscale
             gXs = add.accumulate(gX)
             gYs = add.accumulate(gY)
             mX0,mX1 = extrema(gXs)
             mY0,mY1 = extrema(gYs)
             sX = (mX1 - mX0)
             sY = (mY1 - mY0)
             sXs.append(sX)
             sYs.append(sY)
             mXs.append(mX0)
             mYs.append(mY0)

         aX = argmax(sXs)
         aY = argmax(sYs)
         sX = int(sXs[aX])
         sY = int(sYs[aY])
         mX0 = mXs[aX]
         mY0 = mYs[aY]
         if Exposures[0].fclass == "newfirm":
               if Exposures[0].mjd < 54480:
                  s = add((2048,2048),(sX,sY)).astype(int32)+1
               else:
                  s = add((2048,2048),(sY,sX)).astype(int32)+1
         elif Exposures[0].fclass == "fourstar":
              s = add((2048,2048),(sY,sX)).astype(int32)+1
         print  "Image size = %d x %d" % (s[1],s[0])
         stack = zeros(s,float32) + 1e38
         emap = zeros(s,float32)
         smap = zeros(s,float32)
         if os.path.exists(cname): os.remove(cname)
         if os.path.exists(ename): os.remove(ename)
         if os.path.exists(sname): os.remove(sname)
         if Exposures[0].fclass == "newfirm":
            if Exposures[0].mjd < 54480:
               solnfile = join([os.environ["PYTHONDATA"],"photometry","image3526c%d.soln" % (chip)],"/")
            else:
               solnfile = join([os.environ["PYTHONDATA"],"photometry","image52627c%d.soln" % (chip)],"/")
         elif Exposures[0].fclass == "fourstar":
            if Exposures[0].mjd < 55700:
               solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar201101c%d.soln" % (chip)],"/")
            else:
               solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % (Exposures[0].filter,chip)],"/")
               if not os.path.exists(solnfile):
                  solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % ("J",chip)],"/")
         print "Reading",solnfile
         solndat = readsoln(solnfile)
         solndat["ic"] = invsoln(solndat,2048,2048,verb=1)
#         y,x = indices(s,float32)
#         x = x - s[1]/2. #+ solndat["center"][0]
#         y = y - s[0]/2. #+ solndat["center"][1]
         X,Y,A,P,M,W = [],[],[],[],[],[]
         for E in SuperExposures:
             f = FITS(sfits(E,chip))
             X.append(f["xdiff1"])
             Y.append(f["ydiff1"])
             A.append(f["adiff1"])
             P.append(f["mdiff1"])
             if f["mode"]  == "N/A": M.append(f["median"])
             else: M.append(f["mode"])
             W.append(f["anoise"]**2)
             f.close()
         Xd = add.accumulate(X)
         Yd = add.accumulate(Y)
         Ad = add.accumulate(A)
         P = add.accumulate(P)
         P = P - median(P)
         print "Magnitude trend:"
         print P
         Xd = Xd - mean(extrema(Xd))
         Yd = Yd - mean(extrema(Yd))
         if Exposures[0].fclass == "newfirm":
            if Exposures[0].mjd < 54480: s[1],s[0] = s[0],s[1]
         supernos = [E.expno for E in SuperExposures]
         ebegin = supernos.index(Exposures[0].expno)
         Xd = Xd[ebegin:]
         Yd = Yd[ebegin:]
         print "Image Size",s
         for mname,marray in zip([cname,ename,sname],[stack,emap,smap]):
            print "Creating",mname
            if create or not FileCheck(mname):
               map(os.remove,glob(os.path.dirname(mname)+"/."+os.path.basename(mname).replace(".fits","_????.fits")))
               So = FITS(mname,create=1,template=sfits(E,chip))
               So.modkey("exptime",1.0)
               So.modkey("ncombine",ncombine)
               So.resize([s[1],s[0]])
               So.putdata(marray)
               So.flush()
               So.close()
         start = time.time()
         Ny = stack.shape[0]/yskip+1
         sys.stdout.flush()
         if Hub != None and Hub[0] != None:
             mhost,mport = Hub[0].split(":")
#             hport = Hub[1]
             mport = int(mport)
#             print "hub host is %s, port %d" % (mhost,mport)
             print "GOING TO MAKE LIST OF TASKS!"
             for j in range(Ny):
                doj1 = TwistedTask(-1,"FourCLiftStackSec",\
                        j,yskip,cname,sname,ename,s,chip,Exposures,P,M,W,\
                        exptimes,mdiffs,solndat,first,second,Xd,Yd,Ad,usemed,sigclip)
                doj1.setFromModules(["FourCLiftProcess"])
                doj.append(doj1)
             print "DID WE MAKE LIST OF TASKS?",len(doj)
             print "go!"
             H = HubDispatch(doj,(mhost,mport),mport=0,namespace=globals(),verb=1,sleeptime=0.01,stayalive=True)
#             return H.spin.whenDone()
             while not H.reallydone:
                   reactor.callFromThread(reactor.wakeUp)
                   time.sleep(1)
             return
#             if create: return doj
         elif NP:
            doj = lambda j: FourCLiftStackSec(j,yskip,cname,sname,ename,s,chip,Exposures,P,M,W,exptimes,mdiffs,solndat,first,second,Xd,Yd,Ad,usemed,sigclip,NP=NP)
            RunForkedQueue(doj,range(Ny),MaxThreads=NP,monitor=0,sleeptime=0.01)
         else:
            doj = lambda j: FourCLiftStackSec(j,yskip,cname,sname,ename,s,chip,Exposures,P,M,W,exptimes,mdiffs,solndat,first,second,Xd,Yd,Ad,usemed,sigclip)
            for j in range(Ny):
               doj(j)
               dt = (time.time()-start)
               j1 = (j+1)*yskip
               print "Elapsed=%.2fs Remain=%.2fs" % (dt,(stack.shape[0]-j1)*dt/j1)
               sys.stdout.flush()
         print
         finish = time.time()
         print "Total=%.2fs" % (finish-start)
         sys.stdout.flush()
   catalog = cname.replace(".fits",".cat")
   saturate = 50e3 * len(Exposures) / sum(exptimes)
#   while not os.path.exists(cname) or not os.path.exists(ename) or not os.path.exists(sname):
#     print cname, ename, sname
#     print os.getcwd(), Exposures[0].objname
#     print not os.path.exists(cname), not os.path.exists(ename), not os.path.exists(sname)
#     time.sleep(0.5)
   MakeThumbnail(cname,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
   MakeThumbnail(ename,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
   MakeThumbnail(sname,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
   MakeThumbnail(cname,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85)
   MakeThumbnail(ename,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85)
   MakeThumbnail(sname,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85)
   scale = Exposures[0].scale
   Sextractor(cname,catalog,scale=scale,saturate=saturate,thresh=2.0,seeing=3*scale,segm=1)

def FourCLiftStackSec(j,yskip,cname,sname,ename,sshape,chip,Exposures,P,M,W,exptimes,mdiffs,solndat,first,second,Xd,Yd,Ad,usemed,sigclip,NP=0):
   if first:
     sfits = lambda E,c: E.sfits1(c)
     bfits = lambda E,c: E.bfits1(c)
     mfits = lambda E,c: E.mfits1(c)
   elif second:
     sfits = lambda E,c: E.sfits2(c)
     bfits = lambda E,c: E.bfits2(c)
     mfits = lambda E,c: E.mfits2(c)
     pfits = lambda E,c: E.pers1(c)
   j0 = j*yskip
   j1 = min([j0+yskip,sshape[0]])
   if j1>j0:
      dm,em,um,vm = [zeros((len(Exposures),j1-j0,sshape[1]),float64) \
                       for jim in range(4)]
#      xi0 = x[j0:j1] #- solndat["center"][0]
#      yi0 = y[j0:j1] #- solndat["center"][1]
      x = arange(sshape[1]) - sshape[1]/2.
      y = arange(j1-j0)+j0  - sshape[0]/2.
      xi0 = x[NewAxis,::] * ones(y.shape)[::,NewAxis]
      yi0 = y[::,NewAxis] * ones(x.shape)[NewAxis,::]
      si0 = xi0.shape
      ui0,vi0 = mbasis(solndat["c"],xi0,yi0)
      for i,E in enumerate(Exposures):
         if exptimes[i]:
            Xd1 = Xd[i]*pi/180/3600
            Yd1 = Yd[i]*pi/180/3600
            Ad1 = -Ad[i]*pi/180
            ca1,sa1 = cos(Ad1),sin(Ad1)
            rotsol = array([-Xd1,-Yd1,ca1,sa1])
            ui,vi = mbasis(rotsol,ui0,vi0,rot=1)
            xi,yi = mbasis(solndat["ic"],ui,vi)
            xi = xi + solndat["center"][0]
            yi = yi + solndat["center"][1]
            x0,x1 = clip(add([0,1],extrema(xi.ravel())),0,2047).astype(int32)
            y0,y1 = clip(add([0,1],extrema(yi.ravel())),0,2047).astype(int32)
            if not E.cache:
               f = FITS(sfits(E,chip))
               d = f.readsec([x0,y0],[x1,y1])
               f.close()
#               mf = FITS(mfits(E,chip))
#               nd = mf.readsec([x0,y0],[x1,y1])
#               mf.close()
            elif E.cache:
               f = FITS(sfits(E,chip))
               f.close()
#               E.Data(chip,first,second)
               E.SData(chip,first,second)
               d = E.sdata[chip][y0:y1+1,x0:x1+1]
#               nd = E.data[chip][y0:y1+1,x0:x1+1]
            d = where(between(d,-1e12,1e12),d,0.0)
##            bf = FITS(bfits(E,chip))
##            bd = bf.readsec([x0,y0],[x1,y1])
##            bf.close()
            fei = exptimes[i]*exp10(0.4*P[i])
            d = divz(d,fei).astype(float32)
#            if second:
##               pf = FITS(pfits(E,chip))
#               pd = pF[i].readsec([x0,y0],[x1,y1])
##               pf.close()
#               d = where(pd,0,d)
#            v = (not_equal(d,0)*getsqrt(8*bd + 25**2)/8.).astype(float32)
#            v = divz(v,exptimes[i]).astype(float32)
            v = divz(W[i]*ones(d.shape),fei).astype(float32)
#            v = divz(getsqrt(M[i])*ones(d.shape),exptimes[i]).astype(float32)
            e = (not_equal(d,0)*exptimes[i]).astype(float32)
            ny,nx = d.shape
            xi0 = (xi+0.5-x0).astype(int32).ravel()
            yi0 = (yi+0.5-y0).astype(int32).ravel()
            c0 = (yi0*nx + xi0)
            t0 = clip(c0,0,len(d.ravel())-1)
            o0 = reshape(between(c0,0,len(d.ravel())-1),si0)
            d0 = reshape(take(d.ravel(),t0),si0)
            v0 = reshape(take(v.ravel(),t0),si0)
            e0 = reshape(take(e.ravel(),t0),si0)
            u0 = between(xi,0,2047)*between(yi,0,2047)
            u0 = u0*not_equal(d0,0)*o0*greater(d0,-4*v0)
            u0 = u0.astype(float32)
            v0 = (v0*u0).astype(float32)
            dm[i] = d0.astype(dm.dtype)
            em[i] = e0.astype(em.dtype)
            um[i] = u0.astype(um.dtype)
            vm[i] = v0.astype(vm.dtype)
#      qdump("/tmp/dm.fits",dm)
#      qdump("/tmp/vm.fits",vm)
#      print sort(dm.ravel())[:10], sort(dm.ravel())[-10:]
#      print sort(vm.ravel())[:10], sort(vm.ravel())[-10:]
      ums = sum(um)
#      vm2 = evaluate("vm*vm")
      if usemed:
         if 1:
            dms = sort(evaluate("where(vm!=0,dm,1e18)"),0)
            Mo = sum(evaluate("(dms<1e16)")).astype(int32)
            mMo = int(max(Mo.ravel()))
            nope = True
            if mMo:
               nope = False
               dms = dms[:mMo]
               Mo2i = evaluate("Mo/2.").astype(int32)
               Moi = evaluate("(Mo+1)/2.").astype(int32)
               Meven = evaluate("(Mo2i==Moi)")
               Modd = evaluate("(Mo2i!=Moi)")
               aF = arange(0,len(dms),1,int32)[::,NewAxis,NewAxis]

               Rodd = add.reduce(evaluate("dms * (aF==Mo2i)"),0)
               Reven = add.reduce(evaluate("dms * ((aF==(Mo2i-1))|(aF==Mo2i))"),0)/2.0
               mm = evaluate("where(Modd,Rodd,Reven)*(Mo>0)")
               mmn = mm[NewAxis,::,::]
               sm = evaluate("abs(dm-mmn)")

               if sigclip:
                  aF = arange(0,len(dms),1,int32)[::,NewAxis,NewAxis]
                  sms = sort(evaluate("where(vm!=0,sm,1e18)"),0)[:mMo]
                  Rodd = add.reduce(evaluate("sms * (aF==Mo2i)"),0)
                  Reven = add.reduce(evaluate("sms * ((aF==(Mo2i-1))|(aF==Mo2i))"),0)/2.0
                  rm = evaluate("1.49*where(Modd,Rodd,Reven)*(Mo>0)")
                  wm = divz(um,vm)
                  nit = 5

                  for mit in range(nit):
                     rmn = rm[NewAxis,::,::]
#                     if mit < 3: wm = um*Lp(divz(sm,rmn),w=1)
#                     else: wm = um*Huber2(divz(sm,rmn),w=1)
                     wm = um*Huber(divz(sm,rmn),w=1)
#                     if mit>2: wm = wm*evaluate("abs(rmn)<=sigclip")
                     wm = divz(wm,vm)
                     mm = divz(sum(evaluate("dm*wm")),sum(wm))
                     mmn = mm[NewAxis,::,::]
                     sm = evaluate("abs(dm-mmn)")
                     sms = sort(evaluate("where(wm!=0,sm,1e18)"),0)[:mMo]
                     aF = arange(0,len(dms),1,int32)[::,NewAxis,NewAxis]
                     Rodd = add.reduce(evaluate("sms * (aF==Mo2i)"),0)
                     Reven = add.reduce(evaluate("sms * ((aF==(Mo2i-1))|(aF==Mo2i))"),0)/2.0
                     rm = evaluate("1.49*where(Modd,Rodd,Reven)*(Mo>0)")

               else:
                  wm = um
#               sm = getsqrt(divz(sum(power(sm,2)*wm),(sum(um)-1)*sum(wm)))
#               sm = where(sm,sm,getsqrt(divz(sum(vm),sum(greater(vm,0))-1)))
               sm = rm
               sm = divz(sm,getsqrt(sum(greater(vm,0))))
               em = sum(em*um)
            else:
               mm = zeros(dms[0].shape,float32)
               sm = zeros(dms[0].shape,float32)
               em = zeros(dms[0].shape,float32)
         elif 0:
            mm = divz(sum(um*dm),sum(um))
            sm = sqrt(divz(sum(um*vm**2),sum(um)*sum(um)))
            em = sum(em*um)
         if 0 and second:
            rm = dm-mm[NewAxis,::,::]
#            km = less(abs(rm),5*vm)
            wm = divz(1,vm**2)
            km = Lp(divz(rm,vm),w=1)
            um = um*not_equal(km,0)
            mm = divz(sum(dm*um*km*wm),sum(um*km*wm))
            em = divz(sum(em*um*km*wm),sum(um*km*wm))
            sm = sqrt(divz(sum((dm-mm)**2*um*km*wm),sum(um*km*wm)*sum(um*km)))
      else:
         wm = divz(1.0,vm**2)
         mm = divz(sum(dm*um*wm),sum(um*wm))
         em = divz(sum(em*um*wm),sum(um*wm))
         sm = sqrt(divz(sum((dm-mm)**2*um*wm),sum(um*wm)*sum(um)))
      jno = Set([E.expno for E in Exposures])
      minn = len(Exposures)/10.+1
      numn = len(Exposures)
      minn = 2
#      s2n = divz(mm,sm)
#      keep = greater(ums,minn)
      mint = sum(exptimes)/16.0
#      mint = sum(exptimes)/4.0
      keep = greater_equal(em,mint)*where(greater(numn,2*minn),greater_equal(ums,minn),greater_equal(ums,4))
      mm = mm*keep
      sm = sm*keep
      em = em*keep
      mm = mm.astype(float32)
      em = em.astype(float32)
      sm = sm.astype(float32)

      if NP:
         So = FITS(cname,readonly=0)
         So.writesec(mm,[0,j0],[sshape[1]-1,j1-1])
         So.close()

         Eo = FITS(ename,readonly=0)
         Eo.writesec(em,[0,j0],[sshape[1]-1,j1-1])
         Eo.close()

         Vo = FITS(sname,readonly=0)
         Vo.writesec(sm,[0,j0],[sshape[1]-1,j1-1])
         Vo.close()
      else:
         cname1 = os.path.dirname(cname)+"/."+os.path.basename(cname).replace(".fits","_%04d.fits"%(j0))
         ename1 = os.path.dirname(ename)+"/."+os.path.basename(ename).replace(".fits","_%04d.fits"%(j0))
         sname1 = os.path.dirname(sname)+"/."+os.path.basename(sname).replace(".fits","_%04d.fits"%(j0))
         qdump(cname1,mm)
         qdump(ename1,em)
         qdump(sname1,sm)

def DrawMask(chip,cat,E,size0,mag=3.0,verb=0,pad=256):
   hpad = int(pad/2+1)
   pad = 2*hpad
   size = add(size0,[pad,pad])
   mask = zeros(size,float32)
   pers = zeros(size,float32)
   Xz = cat["Xz"]
   Yz = cat["Yz"]
   Xs = cat["Xs"]
   Ys = cat["Ys"]
   Es = cat["exp"]
   cnaxis1, cnaxis2 = cat["naxes"]
   Ei = [i for i,E1 in enumerate(Es) if E1.name == E.name][0]
   xscale = E.scale
   yscale = E.scale
   if E.fclass == "newfirm":
      if E.mjd < 54480:
         solnfile = join([os.environ["PYTHONDATA"],"photometry","image3526c%d.soln" % (chip)],"/")
      else:
         solnfile = join([os.environ["PYTHONDATA"],"photometry","image52627c%d.soln" % (chip)],"/")
   elif E.fclass == "fourstar":
      if E.mjd < 55700:
         solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar201101c%d.soln" % (chip)],"/")
      else:
         solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % (E.filter,chip)],"/")
         if not os.path.exists(solnfile):
            solnfile = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % ("J",chip)],"/")
   solndat = readsoln(solnfile)
   solndat["ic"] = invsoln(solndat,2048,2048,verb=1)
   i = Ei
   ip = 0
   dtol = 50.0

   zim1 = NumToVTKImage(mask)
   zim2 = NumToVTKImage(pers)

   canvas1 = vtkImageCanvasSource2D()
   canvas1.SetExtent(1,mask.shape[1],1,mask.shape[0],0,0)
   canvas1.SetScalarType(VTK_FLOAT)
   canvas1.DrawImage(0,0,zim1)
   canvas1.SetDrawColor(1.0)
   canvas1.Update()

   canvas2 = vtkImageCanvasSource2D()
   canvas2.SetExtent(1,pers.shape[1],1,pers.shape[0],0,0)
   canvas2.SetScalarType(VTK_FLOAT)
   canvas2.DrawImage(0,0,zim2)
   canvas2.SetDrawColor(1.0)
   canvas2.Update()

#   cent,scat = Es[i].ReadMode(chip,first=1,second=0)

   if Es[i].fclass == "fourstar":
      maxip = 0
      if Es[i].mjd < 55700:
         soln = join([os.environ["PYTHONDATA"],"photometry","fourstar201101c%d.soln" % (chip)],"/")
      else:
         soln = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % (Es[i].filter,chip)],"/")
         if not os.path.exists(soln):
            soln = join([os.environ["PYTHONDATA"],"photometry","fourstar20111202%sc%d.soln" % ("J",chip)],"/")
   elif Es[i].fclass == "newfirm":
      maxip = 3
      if Es[i].mjd < 54480:
          soln = join([os.environ["PYTHONDATA"],"photometry","image3526c%d.soln" % (chip)],"/")
      else:
          soln = join([os.environ["PYTHONDATA"],"photometry","image52627c%d.soln" % (chip)],"/")

   print Es[i],Ei
   while i >= 0 and ip <=maxip:
      print i,ip,Es[i]
      if (i == Ei) or sqrt((Xz[i]-Xz[Ei])**2+(Yz[i]-Yz[Ei])**2) > dtol:
         if (i != Ei) and sqrt((Xz[i]-Xz[i+1])**2+(Yz[i]-Yz[i+1])**2) > dtol: ip += 1
         if ip == 0:
            cdat = readsex( cat["cat"])
            cxl,cyl = asarray([cdat["X_IMAGE"],cdat["Y_IMAGE"]])
            cal,cbl = asarray([cdat["A_IMAGE"],cdat["B_IMAGE"]])
            area = sum(pi*(mag*cal*1.5)*(mag*cbl*1.5))
            print "Area covered by masks=",area,area/(cnaxis1*cnaxis2)
            if area > 0.75*(cnaxis1*cnaxis2):
                print "Old mag=",mag,
                mag = sqrt(divz(0.75*cnaxis1*cnaxis2,sum(pi*(cal*1.5)*(cbl)*1.5)))
                print "\tNew mag=",mag
            csoln = cat["cat"].replace(".cat",".soln")
            crl,cdl = xy2rd(csoln,cxl,cyl,text=0)
            if "soln" in cat and "pa" in cat:
	       impa = cat["pa"]
               print "Image PA=",impa
               cdat["X_IMAGE0"],cdat["Y_IMAGE0"] = cdat["X_IMAGE"],cdat["Y_IMAGE"]
               cdat["X_IMAGE"],cdat["Y_IMAGE"] = sky2xy(crl,cdl,cat["soln"])
               abuf = 2*multiply(cdat["A_IMAGE"],mag*1.5)+hpad
               xin = between( cdat["X_IMAGE"],-abuf,cat["soln"]["naxes"][0]+abuf,inc=1)
               yin = between( cdat["Y_IMAGE"],-abuf,cat["soln"]["naxes"][1]+abuf,inc=1)
               uin = xin*yin
               dat = CompressDictionary(cdat,uin)
            else:
               tmpdirs = glob(Es[i].scratchspace+"_tmp*")
               tmpdirs.sort()
               tmpdir = [tmp for tmp in tmpdirs if os.path.basename(Es[i].mfits1(chip)) in os.listdir(tmp+"/mode1")]
               if not tmpdir:
                  raise NameEror("Stack1c%d.fits not found!"%(chip))
               ssolnfits = tmpdir + "/Stack1c%d.fits"%(chip)
               ssolnfile = tmpdir + "/Stack1c%d.soln"%(chip)
               F = FITS(ssolnfits)
               ssolnnaxes = F.naxes()
               F.close()
               ssolndat = readsoln(ssolnfile)
               impa = (atan2(ssolndat["c"][3],ssolndat["c"][2]) + pi) % (2*pi)
               print "Image PA=",impa
               cdat["X_IMAGE0"],cdat["Y_IMAGE0"] = cdat["X_IMAGE"],cdat["Y_IMAGE"]
               cdat["X_IMAGE"],cdat["Y_IMAGE"] = sky2xy(crl,cdl,ssolndat)
               abuf = 2*multiply(cdat["A_IMAGE"],mag*1.5)+hpad
               xin = between( cdat["X_IMAGE"],-abuf,cat["soln"]["naxes"][0]+abuf,inc=1)
               yin = between( cdat["Y_IMAGE"],-abuf,cat["soln"]["naxes"][1]+abuf,inc=1)
               uin = xin*yin
               dat = CompressDictionary(cdat,uin)
            xl,yl = dat["X_IMAGE"]-Xs, dat["Y_IMAGE"]-Ys
            u,v = mbasis(solndat["c"],xl-solndat["center"][0],yl-solndat["center"][1])
            du = -Xz[i]*xscale*pi/180/3600
            dv = -Yz[i]*yscale*pi/180/3600
            xl,yl = mbasis(solndat["ic"],u+du,v+dv)
            xl = xl + 1024+hpad
            yl = yl + 1024+hpad
            print "using stack catalog"
         else:
            print "using local catalog"
#            e1 = lambda E: [E2 for E2 in Es if E.expno==E2.expno]
            e1 = lambda E: E.oloop[0]
            dat = readsex( e1(Es[i]).cat1(chip))
            xl,yl = dat["X_IMAGE"], dat["Y_IMAGE"]

#         TEST THIS...
#         e1 = lambda E: [E2 for E2 in Es if E.expno==E2.expno]
         e1 = lambda E: E.oloop[0]
         cent,scat = e1(Es[i]).ReadMode(chip,first=1,second=0)

         contours = []

         for n in range( len(dat["NUMBER"])):
            x = xl[n]
            y = yl[n]
            if "MAG_AUTO" in dat:
              mb = dat["MAG_AUTO"][n]
            else:
              mb = dat["MAG_BEST"][n]
            ma = dat["MAG_APER"][n]
            fw = dat["FWHM_IMAGE"][n]
            a = 1.5*dat["A_IMAGE"][n]
            b = 1.5*dat["B_IMAGE"][n]
            a = max([a / (1.0+ip),1])
            b = max([b / (1.0+ip),1])
            ar = pi*a*b
            bg = dat["BACKGROUND"][n]
            t = (dat["THETA_IMAGE"][n])*pi/180 + impa
            tc = exp10(-0.4*(mb-25))/ar + bg + cent
            abuf = 2*a+hpad

            if i == Ei:
               canvas = canvas1
               cim = mask
            else:
               canvas = canvas2
               cim = pers

            if -abuf<x<(size0[1]+abuf) and -abuf<y<(size0[0]+abuf) and (i==Ei or (tc>10000.0 and Es[i].fclass == "newfirm")) and \
                        bg and mb != 99.0:
               dth = (2*pi)/50
               th = arange(0,2*pi+0.5*dth,dth,float64)
               cth = cos(th)
               sth = sin(th)
               ct = cos(t)
               st = sin(t)
               if Es[i].fclass == "fourstar":
                  sqab = sqrt(a*b)
                  lsqab = clip(log10(sqab),1,4)
               elif Es[i].fclass == "newfirm":
                  lsqab = 1.0
               xr = lsqab*mag*a*cth
               yr = lsqab*mag*b*sth
               xr, yr = xr*ct - yr*st, +xr*st + yr*ct
#               print "%5d" % (dat["NUMBER"][n]),
#               print "%9.2f %9.2f" % (dat["X_IMAGE"][n], dat["Y_IMAGE"][n]),
#               print "%9.2f %9.2f" % (dat["X_IMAGE0"][n], dat["Y_IMAGE0"][n]),
#               print "%9.2f" % (dat["THETA_IMAGE"][n]),
#               print "%9.2f %9.2f %9.2f" % (x,y,t*180/pi)
               xr, yr = xr+x-1, yr+y-1
               xr = concatenate([xr,xr[:1]])
               yr = concatenate([yr,yr[:1]])
               segments = asarray([[(xr[jr],xr[jr+1]),(yr[jr],yr[jr+1])] for jr in range(len(xr)-1)])
               contours.append(segments)
               V=VTKEnclosedContour(cim,[segments],verb=0,speed=0,pixels=1)[0][0]
               Vx,Vy,Vn = V
               if len(Vx):
                  li=(Vy*cim.shape[1]+Vx).astype(int32)
                  vi = 1.0*ones(li.shape).astype(cim.dtype)
                  put(cim.ravel(),li,vi)

            if 0 and  -abuf<x<(size0[1]+abuf) and -abuf<y<(size0[0]+abuf) and (i==Ei or (tc>10000.0 and Es[i].fclass == "newfirm")) and \
                        bg and mb != 99.0:
#                        and ma != 99.0:
               dth = (2*pi)/50
               th = arange(0,2*pi+0.5*dth,dth,float64)
               cth = cos(th)
               sth = sin(th)
               ct = cos(t)
               st = sin(t)
               sqab = sqrt(a*b)
               lsqab = clip(log10(sqab),1,4)
               xr = mag*a*cth
               yr = mag*b*sth
               xr,yr = xr*ct - yr*st, xr*st + yr*ct
               xr,yr = xr+x-1,yr+y-1
               m = len(xr)
#               if verb: print Es[i],int(x),int(y),a,b,int(t*180/pi),mb,int(cent),int(tc)
               ixr = (xr+0.5).astype(int32)
               iyr = (yr+0.5).astype(int32)
     
               ixr0,ixr1 = extrema(clip(1+ixr,1,size[1]))
               iyr0,iyr1 = extrema(clip(1+iyr,1,size[0]))

               es = vtkImageEllipsoidSource()
               es.SetOutputScalarTypeToFloat()
               es.SetWholeExtent( ixr0,ixr1,iyr0,iyr1,0,0)
               es.SetCenter(x,y,0)
               es.SetRadius(a,b,0)
               es.SetInValue(1.0)
               es.SetOutValue(0.0)

               rr = vtkGeneralTransform()
               rr.Translate(x,y,0)
               rr.RotateZ(t*180/pi)
               rr.Translate(-x,-y,0)

               er = vtkImageReslice()
               er.SetResliceTransform(rr)
               er.SetInput(es.GetOutput())
               ee = er.GetOutput()
               er.Update()

               tmp = vtkImageClip()
               canvas.Update()
               tmp.SetInput( canvas.GetOutput())
               tmp.SetOutputWholeExtent( ixr0,ixr1,iyr0,iyr1,0,0)
               tmp.ClipDataOn()
               tmp.Update()
               oe = tmp.GetOutput()

               el = vtkImageLogic()
               el.SetOperationToOr()
               el.SetInput2(ee)
               el.SetInput1(oe)
               eb = el.GetOutput()
               el.Update()
               canvas.DrawImage(ixr0,iyr0,eb,0,0,ixr1-ixr0,iyr1-iyr0+1)

      i -= 1

#   mask = VTKDrawContour(0.0*mask,contours,color=32767,fill=0,verb=0)

#   output1 = canvas1.GetOutput()
#   output1.Update()
#   mask = VTKImageToNum(output1)
   mask = mask[hpad:hpad+2048,hpad:hpad+2048]
#   output2 = canvas2.GetOutput()
#   output2.Update()
#   pers = VTKImageToNum(output2)
   pers = pers[hpad:hpad+2048,hpad:hpad+2048]

#   mask = logical_not(mask).astype(int32)
#   mask = VTKMultiply(mask,VTKConvolve(VTKIslandRemoval(mask,0,1,20000,1),k=5,numret=1))
#   mask = VTKMultiply(mask,VTKConvolve(VTKIslandRemoval(mask,0,1,20000,1),k=5,numret=1))
#   mask = logical_not(mask).astype(int32)

   if Es[i].fclass == "fourstar":
       pers = zeros(mask.shape,int32)
       if Es[i].mjd<55700 and chip == 1:
          mirr = mask[1024-64:1024+64]
          mirr = logical_or(mirr,mirr[::-1])
          mask[1024-64:1024+64] = mirr.astype(mask.dtype)
   else:
       pers = logical_not(pers).astype(int32)
       pers = VTKMultiply(pers,VTKConvolve(VTKIslandRemoval(pers,0,1,20000,1),k=5,numret=1))
       pers = VTKMultiply(pers,VTKConvolve(VTKIslandRemoval(pers,0,1,20000,1),k=5,numret=1))
       pers = logical_not(pers).astype(int32)

   mask = VTKConvolve(greater(mask,0).astype(float32),k=5,numret=1)
   pers = VTKConvolve(greater(pers,0).astype(float32),k=5,numret=1)
   mask = (32766*greater(mask,0)).astype(int16)
   pers = (32766*greater(pers,0)).astype(int16)
   print sum(equal(mask.ravel(),0)),
   print sum(not_equal(mask.ravel(),0))
   print sum(equal(pers.ravel(),0)),
   print sum(not_equal(pers.ravel(),0))
#   os._exit(1)

   return mask,pers

#def FourCLiftWave(N,chip,first=True,second=False,verb=1):
#   E = Exposure(N)
#   E.flwt2d(chip,first=first,second=second,verb=verb)

#def FourCLiftSkySubtract(N,chip,NDS=[],flat=0,first=1,second=0,nf=3,verb=0):
#   NDS = [N1 for N1 in NDS if not Exposure(N1).bad]
#   Exposures = [Exposure(N1) for N1 in NDS]
#   u = [j for j in range(len(NDS)) if NDS[j].base == N.base][0]
#   E = Exposures[u]
#   E.SkySubtract(chip,Exposures,first=first,flat=flat,second=second,nf=nf,verb=verb)

#def FourCLiftShift(N,chip,NDS=[],first=1,second=0,nf=3,verb=0):
#   NDS = [N1 for N1 in NDS if not Exposure(N1).bad]
#   Exposures = [Exposure(N1) for N1 in NDS]
#   u = [j for j in range(len(NDS)) if NDS[j].base == N.base][0]
#   E = Exposures[u]
#   E.Shift(chip,Exposures,first=first,second=second,verb=verb)

#def nonexist(f,d):
#   return (f not in os.listdir(d)) or os.stat(d+"/"+f)[6]==0

def invsoln(solndat,naxis1,naxis2,verb=0):
    nterms = len(solndat["c"])
    np = 2*nterms
    x = asarray( range(0,naxis1+naxis1/np,naxis1/np) + [naxis1])
    y = asarray( range(0,naxis2+naxis2/np,naxis2/np) + [naxis2])
    xc = solndat["center"][0]
    yc = solndat["center"][1]
    x = evaluate("x - xc")
    y = evaluate("y - yc")
    nx = len(x); ny = len(y)
    o = ones((ny,nx),float32)
    yy = (o*y[::,NewAxis]).ravel()
    xx = (o*x[NewAxis,::]).ravel()
    u,v = mbasis(solndat["c"],xx,yy)
    nterm = [4,6,12,20,30,42,56]
    nords = [0,1, 2, 3, 4, 4, 4]
    m = nords[nterm.index(nterms)]
    b = abasis(m,u,v)
    c = svdfit(b,concatenate([xx,yy]))
    if verb:
      xf,yf = mbasis(c,u,v)
      xres = evaluate("xf-xx"); yres = evaluate("yf-yy")
      print "Using",nterm,"terms (order=",m,")"
      print "Inverse solution RMS=",rms(xres),rms(yres)
    return c

def FourStarLinearize1D(x, chip,mode="F"):
    F = {1:(2.927e-6,-3.464e-11,8.476e-16),
         2:(2.603e-6,-2.556e-11,6.636e-16),
         3:(3.215e-6,-4.064e-11,7.393e-16),
         4:(2.490e-6,-1.329e-11,6.897e-16),
         }
    L = {1:(9.338e-7,3.308e-12),
         2:(7.96e-7,5.101e-12),
         3:(1.100e-6,8.068e-13),
         4:(1.366e-6,-1.200e-12),
         }
    coe = eval(mode)[chip]
    if mode == "F":
      s = "x*(1+%r*x  + %r*x**2 + %r*x**3)" % coe
    elif mode == "L":
      s = "x*(1+%r*x  + %r*x**2)" % coe
    data = evaluate(s)
#    cor = ones(x.shape,float)
#    [add(cor,c*power(x,j+1),cor) for j,c in enumerate(coe)]
#    data = multiply(x,cor)
    return data

def FourStarLinearize2D(x, chip,mode="F"):
    if mode == "F":
       f = "%s/photometry/lc_fw_%d.fits" % (os.environ["PYTHONDATA"],chip)
    elif mode == "L":
       f = "%s/photometry/lc_ln_%d.fits" % (os.environ["PYTHONDATA"],chip)
    F = FITS(f)
    c = F.data()
    F.close()
#    data = where(c,x*(1+c*x*getsqrt(x)),0.0)
#    cm = median(c.ravel())
#    s = "where(c<2*cm,c,0.0)"
#    c = evaluate(s)
    s = "where(c!=0,x*(1+c*x*sqrt(where(x>0.0,x,0.0))),0.0)"
    data = evaluate(s)
    return data

#Anthony's function
def NEWFIRMLinearize1D(data, chip, exptime, digavg=4, nreads=1):
    xsize = data.shape[1]
    ysize = data.shape[0]
    if (digavg == 1):
      tcds = 0.56
    else:
      tcds = 0.564+0.148*digavg

    if (chip == 1):
      treset = 1./ysize*(arange(xsize*ysize).reshape(ysize,xsize)/xsize+1)
    elif (chip == 2):
      treset = 1./xsize*(arange(xsize*ysize).reshape(ysize,xsize)%xsize+1)
    elif (chip == 3):
      treset = 1./xsize*(xsize+1-arange(xsize*ysize).reshape(ysize,xsize)%xsize)
    elif (chip == 4):
      treset = 1./ysize*(ysize+1-arange(xsize*ysize).reshape(ysize,xsize)/xsize+1)
    else:
      treset = zeros((ysize,xsize))+0.

    if (nreads > 1):
      treset = 0.0346 + (tcds+0.0568)*(nreads-1)/2. + tcds*treset
    else:
      treset = 0.0346 + tcds*treset
    tsq = (treset+exptime)**2 - treset**2

    #Below s must be replaced by images for final full solution
    if (chip == 1):
      s= -6.377e-6      #SN019  #Medians off 2d map.
    elif (chip == 2):
      s= -6.714e-6      #SN022
    elif (chip == 3):
      s= -4.528e-6      #SN013
    elif (chip == 4):
      s= -5.148e-6      #SN011
    else:
      s = 0
    #Linearity formula
    output = exptime * ( -1.*exptime +(exptime**2+4*s*tsq*data)**0.5)/(2*s*tsq)
    return output

def SeriousMasks(i1,sig=3,mask=None,allmed=None):
    if mask != None:
       mask = (not_equal(i1,0)*mask).astype(float32)
    else:
       mask = not_equal(i1,0).astype(float32)
    if allmed == None:
        i1 = where(mask,i1,divz(VTKMeanSmooth(VTKMultiply(i1,mask),64,64,numret=1),
                  VTKMeanSmooth(mask,64,64,numret=1)))
        i12 = VTKGrowN(i1,2,numret=1)
        c1 = VTKConvolve(i12,numret=1,kernel=array([[0,-1,0],[-1,4,-1],[0,-1,0]])/4.)
        k1 = not_equal(i12,0).astype(float32)
        r1 = VTKDivide(VTKMeanSmooth(VTKMultiply(VTKAbs(c1),k1),128,128,numret=1),VTKMeanSmooth(k1,128,128,numret=1))
        r1 = VTKMultiply(r1,1.25)
        l1 = VTKLesFalsesEqual(VTKDivide(VTKAbs(c1),r1),sig).astype(float32)
        for e1 in range(2):
          r1 = VTKDivide(VTKMeanSmooth(VTKMultiply(VTKAbs(c1),l1),128,128,numret=1),VTKMeanSmooth(l1,128,128,numret=1))
          r1 = VTKMultiply(r1,1.25)
          l1 = VTKLessEqual(VTKDivide(VTKAbs(c1),r1),sig).astype(float32)
        l1 = VTKShrinkN(l1,2,usemean=1,numret=1)
        u1 = VTKMultiply(l1,mask)
        m1 = VTKDivide(VTKMeanSmooth(VTKMultiply(i1,u1),64,64,numret=1),
                    VTKMeanSmooth(u1,64,64,numret=1))
        t1 = where(u1,i1,m1)
        b1 = VTKMedianSmooth(t1,256,256,numret=1)
    else:
        b1 = allmed
        u1 = mask
        l1 = mask
    s1 = VTKMultiply(VTKSubtract(i1,b1),u1)
    r1 = VTKDivide(VTKMeanSmooth(VTKAbs(s1),256,256,numret=1),
            VTKMeanSmooth(u1,256,256,numret=1))
    r1 = VTKMultiply(r1,1.25)
    r1 = clip(getsqrt(b1/8+(25/8.)**2),r1,1e10).astype(float32)
    u1 = (not_equal(i1,0.0)*less(abs(s1),sig*r1)).astype(float32)
    if mask!=None: u1 = where(l1*mask,u1,1)
    else: u1 = where(l1,u1,1)
    u1 = VTKIslandRemoval(u1,0,1,8,numret=1)
    u1 = VTKMeanSmooth(u1,8,8,numret=1)
    u1 = equal(u1,1).astype(float32)
    u1 = l1*mask*u1
    return u1

def IslandClean(z,mask,k=2.5):
    s1 = 512
    zmask = evaluate("z*mask")
    z0 = QuickSmooth(zmask,mask,s1)
    zz0 = evaluate("abs(z-z0)")
    cmask = evaluate("1.25*mask*zz0")
    zs = QuickSmooth(cmask,mask,s1)
    mask = evaluate("mask*(zz0<(k*zs))").astype(float32)
    b = evaluate("1.0-mask")
    z2 = z
    ss = [512,128,32,8]
    zmask = evaluate("z*mask")
    for s in ss:
       if s == ss[-1]:
          b1 = b
       else:
          s2 = int(pow(s/2.,2.0)+1)
          tt0 = time.time()
          b1 = VTKIslandRemoval(b,1.0,0.0,s2,numret=1)
          b = evaluate("b-b1")
       if b1.any():
#          m = evaluate("1-b1")
          z21 = QuickSmooth(zmask,mask,s)
          z2 = evaluate("where(b1>0,z21,z2)")
    return z2

def QuickSmooth(xw,w,l):
    w = VTKMeanSmooth(w,l,numret=1)
    xw = VTKMeanSmooth(xw,l,numret=1)
    s = divz(xw,w)
    return s

def MakeClean(i1,si1=None,sig=3,mask=None,tdata=None,Fm=None,Fr=None):
    if si1 != None:
       si1s = 1.49*median(abs(compress(mask.ravel(),si1.ravel())))
       si1m = median(si1.ravel())
       omask = evaluate("abs(si1-si1m)<(sig*si1s)").astype(int32)
       omask2 = VTKConvolve(VTKIslandRemoval(omask,1,0,100,1),k=5,numret=1)
       omask = evaluate("omask*omask2")
       mask = evaluate("mask*omask")
    mask = mask*not_equal(i1,0.0).astype(float32)
    maski1 = evaluate("mask*i1")
    Mi1,Di1,Si1 = ModalSmooth(i1,mask,256,3,pct=40,cut=0.)
#    qdump("/tmp/i1.fits",i1)
#    qdump("/tmp/Mi1.fits",Mi1)
    scs = [32,64,128]
    scs = [4,5,6,7,8,9]
    nsc = 0.0
    dsc = 0.0
    for jsc,sc in enumerate(scs):
#        nsc = VTKGauss(maski1,sc,numret=1)
#        bsc = VTKGauss(mask,sc,numret=1)
#        nsc = VTKLevel(maski1,sc,k=5)
#        bsc = VTKLevel(mask,sc,k=5)
        nsc = VTKMeanSmooth(maski1,2**sc,numret=1)
        bsc = VTKMeanSmooth(mask,2**sc,numret=1)
        sscu = evaluate("nsc/(bsc+(bsc==0))*(bsc!=0)")
#        nsc = nsc + ssc1*not_equal(ssc1,0)
#        dsc = dsc + not_equal(ssc1,0)
#        qdump("/tmp/ssc1_%03d.fits"%(sc),sscu)
#        sscu = divz(nsc,dsc)
        if sc == scs[0]: ssc = sscu
        else: ssc = evaluate("where((ssc==0),sscu,ssc)")
        toolow = evaluate("(ssc<(0.9*abs(Mi1)))")
#        qdump("/tmp/ssc_%03d.fits"%(sc),sscu)
#        qdump("/tmp/toolow_%03d.fits"%(sc),toolow*37267.0)
        if not toolow.any(): break
#        maski1 = evaluate("mask*ssc")
    i2 = evaluate("where(maski1!=0,i1,ssc)")
#    qdump("/tmp/i2.fits",i2)
#    os._exit(1)
    bmu1 = evaluate("(mask!=0)").astype(float32)
    mask3 = evaluate("abs(i1-i2)>(3*Fr)").astype(float32)
    mask3 = VTKIslandRemoval(mask3,1,0,1000,1)
    x,y = transpose([(0,0),(2047,0),(0,2047),(2047,2047)])
    mask3 = VTKSeedConnectivity(mask3,x,y,val=1)
    mask3 = mask3.astype(float32)
    mask3 = greater(VTKConvolve(mask3,k=5,numret=1),0).astype(float32)
    fy = 1.*greater(1.*add.reduce(mask3,0)/mask3.shape[0],0.998)
    fx = 1.*greater(1.*add.reduce(mask3,1)/mask3.shape[1],0.998)
    fy = 1.*greater(VTKGauss(fy,24.0,1),0.01)
    fx = 1.*greater(VTKGauss(fx,24.0,1),0.01)
    mask3xy = 1.*logical_or(fy[NewAxis,::], fx[::,NewAxis])
    mask3 = evaluate("mask3*mask3xy").astype(float32)
    return i2,bmu1,mask3

def notMakeClean(i1,si1=None,sig=3,mask=None,tdata=None,Fm=None,Fr=None):
    if si1 != None:
       si1s = 1.49*median(abs(compress(mask.ravel(),si1.ravel())))
       si1m = median(si1.ravel())
       omask = evaluate("abs(si1-si1m)<(sig*si1s)").astype(int32)
       omask2 = VTKConvolve(VTKIslandRemoval(omask,1,0,100,1),k=5,numret=1)
       omask = evaluate("omask*omask2")
       mask = evaluate("mask*omask")
#    qdump("/tmp/i1.fits",1.*i1)
#    qdump("/tmp/mask.fits",1.*mask)
    Mi1,Di1,Si1 = ModalSmooth(i1,mask,32,3,pct=40,cut=0.)
#    qdump("/tmp/Mi1.fits",1.*Mi1)
#    qdump("/tmp/Di1.fits",1.*Di1)
#    qdump("/tmp/Si1.fits",1.*Si1)
#    os._exit(1)
    Di1 = evaluate("abs(i1-Mi1)")
#    Si1 = divz(VTKMeanSmooth(Di1*mask,512,512,1),VTKMeanSmooth(mask,512,512,1))
#    Si1 = evaluate("1.25*Si1")
#    Si1 = evaluate("where((Si1>Fr),Si1,Fr)")
    Di1 = divz(Di1,Si1)
    Ri1 = divz(i1,Mi1)
    Ri1x = sum(Ri1[512:1536])
    Ri1y = sum(transpose(Ri1)[512:1536])
    Ri1x = divz(Ri1x,median( Ri1x))
    Ri1y = divz(Ri1y,median( Ri1y))
    Bi1,Bi2 = greater_equal(Ri1x,0.3)[NewAxis,::],greater_equal(Ri1y,0.3)[::,NewAxis]
    Bi = (Bi1*Bi2).astype(float32)
    u1 = logical_or(Bi,VTKLessEqual(Di1,5.0)).astype(float32)
    u1 = VTKLessEqual(Di1,5.0).astype(float32)
    u1a = VTKMeanSmooth(u1,4,numret=1)
    u1 = evaluate("(Bi*mask*u1a)!=0").astype(float32)
    i1u1 = evaluate("i1*u1")
    bigu2 = VTKIslandRemoval((1.-u1),1,0,10000,1)
    bigu1a = VTKConvolve(bigu2,k=3,numret=1)
    bigu1 = evaluate("bigu1a==0").astype(int32)
    b5 = zeros(i1.shape,float64)
#    sc = 512
#    b5c512 = VTKGrowN(ShrinkN(i1,u1,sc,sc,median),sc,sc,interp=1,numret=1,xshift=-0.5,yshift=-0.5,mirror=1,origsize=(2048,2048))
#    b5c512 = Mi1
#    for sc in [64,128,256]:
#       if equal(b5,0).any():
#          b5c = divz(VTKMeanSmooth(i1u1,sc,sc,1), VTKMeanSmooth(u1,sc,sc,1))
#          b5 = evaluate("where(b5!=0,b5,b5c)")
#       else:
#          break
#    b5 = evaluate("where(bigu1!=0,b5,b5c512)")
#    Di1 = evaluate("abs(i1-b5)")
##    Bmask = evaluate("Bi*mask")
#    Bmask = mask
##    u1 = evaluate("Di1 <= (sig*Si1)").astype(float32)
##    u1 = logical_and(u1,not_equal(i1,0)).astype(float32)
##    bmu1 = evaluate("Bi*mask*u1")
    bmu1 = evaluate("mask*bigu1")
    i2 = evaluate("where(bmu1!=0,i1,Mi1)")
    i2 = evaluate("where(i2!=0,i2,Mi1)")
    Mi1,Di1,Si1 = ModalSmooth(i2,not_equal(i2,0),128,3,pct=40,cut=0.)
    i2 = where(less(abs(Di1),sig*Si1),i2,Mi1)

    mask3 = evaluate("abs(i1-i2)>(3*Fr)").astype(float32)
    mask3 = VTKIslandRemoval(mask3,1,0,1000,1)
    x,y = transpose([(0,0),(2047,0),(0,2047),(2047,2047)])
    mask3 = VTKSeedConnectivity(mask3,x,y,val=1)
    mask3 = mask3.astype(float32)
    mask3 = greater(VTKConvolve(mask3,k=5,numret=1),0).astype(float32)
    fy = 1.*greater(1.*add.reduce(mask3,0)/mask3.shape[0],0.998)
    fx = 1.*greater(1.*add.reduce(mask3,1)/mask3.shape[1],0.998)
    fy = 1.*greater(VTKGauss(fy,24.0,1),0.01)
    fx = 1.*greater(VTKGauss(fx,24.0,1),0.01)
    mask3xy = 1.*logical_or(fy[NewAxis,::], fx[::,NewAxis])
    mask3 = evaluate("mask3*mask3xy").astype(float32)
#    mask31 = greater(VTKGauss(mask31,4,1),0.01).astype(float32)
#    mask3 = logical_or(mask31,mask30).astype(float32)
#    i4 = where(mask2,i1,back)
#    qdump("/tmp/i4.fits",i4)
    if 0:
        qdump("/tmp/Ri1.fits",Ri1)
        qdump("/tmp/Ri1x.fits",Ri1x)
        qdump("/tmp/Ri1y.fits",Ri1y)
        qdump("/tmp/Mi1.fits",Mi1)
        qdump("/tmp/Si1.fits",Si1)
        qdump("/tmp/Di1.fits",Di1)
        qdump("/tmp/Bi.fits",Bi)
        qdump("/tmp/mask.fits",99999*mask)
        qdump("/tmp/u1.fits",999999*u1)
        qdump("/tmp/bigu1.fits",999999*bigu1)
        qdump("/tmp/bigu2.fits",999999*bmu1)
        qdump("/tmp/b5.fits",b5)
        qdump("/tmp/i2.fits",i2)
    return i2,bmu1,mask3
#    return Bi,u1,mask,b5,bmu1,i2

def huhMakeClean(i1,si1=None,sig=3,omask=None,mask=None,tdata=None,Fm=None,Fr=None):
    if si1 != None:
       si1s = 1.49*median(abs(compress(mask.ravel(),si1.ravel())))
       si1m = median(si1.ravel())
       omask = evaluate("abs(si1-si1m)<(sig*si1s)").astype(int32)
       omask2 = VTKConvolve(VTKIslandRemoval(omask,1,0,100,1),k=5,numret=1)
       omask = evaluate("omask*omask2")
       mask = evaluate("mask*omask")
    if tdata!=None:
       Mi1 = tdata
    else:
       Mi1 = divz(VTKMeanSmooth(i1*mask,128,128,1), VTKMeanSmooth(mask,128,128,1))
    Di1 = evaluate("abs(i1-Mi1)")
    Si1 = divz(VTKMeanSmooth(Di1*mask,512,512,1),VTKMeanSmooth(mask,512,512,1))
    Si1 = evaluate("1.25*Si1")
    Si1 = evaluate("where((Si1>Fr),Si1,Fr)")
    Di1 = divz(Di1,Si1)
    Ri1 = divz(i1,Mi1)
    Ri1x = sum(Ri1[512:1536])
    Ri1y = sum(transpose(Ri1)[512:1536])
    Ri1x = divz(Ri1x,median( Ri1x))
    Ri1y = divz(Ri1y,median( Ri1y))
    Bi1,Bi2 = greater(Ri1x,0.7)[NewAxis,::],greater(Ri1y,0.7)[::,NewAxis]
    Bi = (Bi1*Bi2).astype(float32)
    u1 = logical_or(Bi,VTKLessEqual(Di1,5.0)).astype(float32)
    u1a = VTKMeanSmooth(u1,4,numret=1)
    u1 = evaluate("(Bi*mask*u1a)!=0").astype(float32)
    i1u1 = evaluate("i1*u1")
    bigu2 = VTKIslandRemoval((1.-u1),1,0,10000,1)
    bigu1a = VTKConvolve(bigu2,k=3,numret=1)
    bigu1 = evaluate("bigu1a==0").astype(int32)
    b5 = zeros(i1.shape,float64)
    sc = 512
    b5c512 = VTKGrowN(ShrinkN(i1,u1,sc,sc,median),sc,sc,interp=1,numret=1,xshift=-0.5,yshift=-0.5,mirror=1,origsize=(2048,2048))
    for sc in [64,128,256]:
       if not equal(b5,0).any(): break
       b5c = divz(VTKMeanSmooth(i1u1,sc,sc,1), VTKMeanSmooth(u1,sc,sc,1))
       b5 = evaluate("where(b5!=0,b5,b5c)")
    b5 = evaluate("where(bigu1!=0,b5,b5c512)")
    Di1 = evaluate("abs(i1-b5)")
    Bmask = evaluate("Bi*mask")
    u1 = evaluate("Di1 <= (sig*Si1)").astype(float32)
    bmu1 = evaluate("Bi*mask*u1")
    i2 = evaluate("where(bmu1!=0,i1,b5)")
    return Bi,u1,mask
    if 0:
        qdump("/tmp/Ri1.fits",Ri1)
        qdump("/tmp/Ri1x.fits",Ri1x)
        qdump("/tmp/Ri1y.fits",Ri1y)
        qdump("/tmp/Mi1.fits",Mi1)
        qdump("/tmp/Si1.fits",Si1)
        qdump("/tmp/Di1.fits",Di1)
        qdump("/tmp/Bi.fits",Bi)
        qdump("/tmp/mask.fits",99999*mask)
        qdump("/tmp/u1.fits",999999*u1)
        qdump("/tmp/bigu1.fits",999999*bigu1)
        qdump("/tmp/bigu2.fits",999999*bmu1)
        qdump("/tmp/b5.fits",b5)
        qdump("/tmp/i2.fits",i2)
    return Bi,u1,mask,b5,bmu1,i2

def mehMakeClean(i1,si1=None,sig=3,omask=None,mask=None,tdata=None):
    sc = 16
    noise0 = ModalSmooth(i1,mask,512,3,pct=40,cut=0.)[2]
    back,obj,noise = ModalSmooth(i1,mask,16,3,pct=40,cut=0.)
    urp = less(back,median(back.ravel())-5*noise0)
    while urp.any() and sc < 256:
       sc = sc*2
       back2,obj2,noise2 = ModalSmooth(i1,mask,sc,3,pct=40,cut=0.)
       back = where(urp,back2,back)
       obj = i1-back
       noise = where(urp,noise2,noise)
       urp = less(back,median(back.ravel())-5*noise0)
    ok = evaluate("abs(obj)<(sig*noise)").astype(float32)
    ok = equal(VTKConvolve(ok,k=3,numret=1),1.0).astype(float32)
    mask2 = evaluate("ok*mask")
    mask3 = evaluate("abs(obj)>(2*noise)")
    mask3 = mask3.astype(float32)
#    masko = VTKIslandRemoval(1.0-mask,1,0,1000,1)
    mask3 = VTKIslandRemoval(mask3,1,0,1000,1)
#    qdump("/tmp/masko.fits",masko)
#    qdump("/tmp/mask3.fits",mask3)
#    mask3 = logical_and(mask3,logical_not(masko)).astype(float32)
    x,y = transpose([(0,0),(2047,0),(0,2047),(2047,2047)])
    mask3 = VTKSeedConnectivity(mask3,x,y,val=1)
    mask3 = mask3.astype(float32)
    mask3 = greater(VTKConvolve(mask3,k=5,numret=1),0).astype(float32)
    fy = 1.*greater(1.*add.reduce(mask3,0)/mask3.shape[0],0.9)
    fx = 1.*greater(1.*add.reduce(mask3,1)/mask3.shape[1],0.9)
    fy = 1.*greater(VTKGauss(fy,16.0,1),0.01)
    fx = 1.*greater(VTKGauss(fx,16.0,1),0.01)
    mask3xy = 1.*logical_or(fy[NewAxis,::], fx[::,NewAxis])
    mask3 = evaluate("mask3*mask3xy")
    i2 = where(mask2,i1,back)
    if 0:
       qdump("/tmp/i1.fits",i1)
       qdump("/tmp/i1m.fits",i1*mask)
       qdump("/tmp/back.fits",back)
       qdump("/tmp/obj.fits",obj)
       qdump("/tmp/obj2.fits",obj*mask)
       qdump("/tmp/noise.fits",noise)
       qdump("/tmp/mask1.fits",mask)
       qdump("/tmp/mask2.fits",mask2)
    return i2,mask2,mask3

def testMakeClean(i1,si1=None,sig=3,omask=None,mask=None,tdata=None):
    if 0 and tdata != None: 
       tback,tobj,tnoise = ModalSmooth(tdata,mask,128,5,pct=25,cut=0.)
       tmask = greater(tobj,2*tnoise).astype(float32)
       tmaskb = greater(VTKGauss(VTKIslandRemoval(tmask,1.0,0.0,4000,1),24,1),0.001).astype(float32)
       mask30 = tmaskb.astype(float32)
       omask = omask*logical_not(tmask)*logical_not(tmaskb)
    m2 = mask*omask*not_equal(i1,0)
    T=divz(VTKGauss(i1*m2,4,1),VTKGauss(1.*m2,4,1))
    i1 = where(m2,i1,T)
    m2 = mask*omask*not_equal(i1,0)
    back = zeros(i1.shape,float32)
    sc,k = 32,5
    sback,sobj,snoise = ModalSmooth(i1,mask,sc,k,pct=25,cut=0.)
    sgrad = VTKGradMag(sback,numret=1)
    sgrad1 = median(sgrad.ravel())
    sgrad2 = 1.49*median(abs(sgrad.ravel()-sgrad1))
    sgrad3 = less(sgrad,sgrad1+5*sgrad2)
    sback = sback*sgrad3
#    qdump("/tmp/sback.fits",sback)
    back0 = sback
    back = sback
    uback = 1.*not_equal(back,0.0)
    sc = 32
    while equal(back,0).any() and sc < 512:
       print sc, sum(1.*equal(back,0).ravel())/(i1.shape[0]*i1.shape[1])
       sback = VTKDivide(VTKGauss(back0*uback,sc,1), VTKGauss(uback,sc,1))
       sgrad = VTKGradMag(sback,numret=1)
       sgrad1 = median(sgrad.ravel())
       sgrad2 = 1.49*median(abs(sgrad.ravel()-sgrad1))
       sgrad3 = less(sgrad,sgrad1+5*sgrad2)
       sback = sback*sgrad3
       back = where(back,back,sback)
       sc = sc*1.5
#    qdump("/tmp/sback.fits",back)
    i2 = where(m2,i1,back)
#    qdump("/tmp/back.fits",i2)
    back,obj,noise = ModalSmooth(i2,mask,64,3,pct=25,cut=0.)
#    ok = evaluate("obj>(-sig*noise)").astype(float32)
#    ok = equal(VTKConvolve(ok,k=3,numret=1),1.0).astype(float32)
#    i2 = where(ok,i2,back)
#    oback = greater(i2,0.5*median(compress(i2.ravel(),i2.ravel())))
#    i2 = where(oback,i2,median(compress(i2.ravel(),i2.ravel())))
#    mask2 = evaluate("ok*mask")
    mask2 = mask
    mask3 = evaluate("abs(i1-i2)>(3*noise)").astype(float32)
    mask3 = VTKIslandRemoval(mask3,1,0,1000,1)
    x,y = transpose([(0,0),(2047,0),(0,2047),(2047,2047)])
    mask3 = VTKSeedConnectivity(mask3,x,y,val=1)
    mask3 = mask3.astype(float32)
    mask3 = greater(VTKConvolve(mask3,k=5,numret=1),0).astype(float32)
    fy = 1.*greater(1.*add.reduce(mask3,0)/mask3.shape[0],0.998)
    fx = 1.*greater(1.*add.reduce(mask3,1)/mask3.shape[1],0.998)
    fy = 1.*greater(VTKGauss(fy,24.0,1),0.01)
    fx = 1.*greater(VTKGauss(fx,24.0,1),0.01)
    mask3xy = 1.*logical_or(fy[NewAxis,::], fx[::,NewAxis])
    mask3 = evaluate("mask3*mask3xy").astype(float32)
#    mask31 = greater(VTKGauss(mask31,4,1),0.01).astype(float32)
#    mask3 = logical_or(mask31,mask30).astype(float32)
#    i4 = where(mask2,i1,back)
#    qdump("/tmp/i4.fits",i4)
    return i2,mask2,mask3


def bahMakeClean(i1,si1=None,sig=3,omask=None,mask=None,tdata=None):
    if tdata != None: 
       tback,tobj,tnoise = ModalSmooth(tdata,mask,128,5,pct=25,cut=0.)
       tmask = greater(tobj,2*tnoise).astype(float32)
       tmaskb = greater(VTKGauss(VTKIslandRemoval(tmask,1.0,0.0,4000,1),24,1),0.001).astype(float32)
       mask30 = tmaskb.astype(float32)
       omask = omask*logical_not(tmask)*logical_not(tmaskb)
    H = FillHoles(i1,omask,area=64,maxarea=1e4,maxlen=0,pad=256)
    m2 = mask*omask*not_equal(H,0)
    T=divz(VTKGauss(H*m2,4,1),VTKGauss(1.*m2,4,1))
    i2 = where(m2,H,T)
    ci1 = compress(mask.ravel()*i1.ravel(),i1.ravel())
    mi1 = getpct(ci1,40)
    noise0 = 1.49*median(abs(ci1-mi1))
#    i2 = where(greater(i2,mi1-3*noise0),i2,mi1)
#    i2 = FillHoles(i2,omask,area=36,maxarea=1e5,maxlen=0,pad=256)
#    qdump("/tmp/omask.fits",99999.*omask)
#    qdump("/tmp/mask.fits",99999.*mask)
#    qdump("/tmp/T.fits",T)
#    qdump("/tmp/i1.fits",i1)
#    qdump("/tmp/i2.fits",i2)
#    mc = 1.*greater(i2,mi1-5*noise0)*greater(mask,0)
#    qdump("/tmp/mask.fits",99999.*mc)
#    i2 = FillHoles(i2,omask,area=100,maxarea=1e5,maxlen=0)
    back,obj,noise = ModalSmooth(i2,mask*(1.-mask30),128,5,pct=25,cut=0.)
    maskb = 1.0-VTKIslandRemoval(1.0-mask,1.0,0.0,4000,1)
    i2 = where(maskb*mask30,back,i2)
    back,obj,noise = ModalSmooth(i2,m2*mask30*greater(i2,mi1-3*noise0),256,5,pct=40,cut=0.)
    mc = 1.*greater(abs(obj),-2.5*noise)
    i2 = where(mc,i2,back)
    mc = 1.*greater(i2,mi1-5*noise0)
    i2 = where(mc,i2,mi1)
#    qdump("/tmp/i3.fits",i2)
    back,obj,noise = ModalSmooth(i2,mask,64,3,pct=25,cut=0.)
    ok = evaluate("obj>(-sig*noise)").astype(float32)
    ok = equal(VTKConvolve(ok,k=3,numret=1),1.0).astype(float32)
    i2 = where(ok,i2,back)
    mask2 = evaluate("ok*mask")
    mask3 = evaluate("abs(i1-i2)>(3*noise)").astype(float32)
    mask3 = VTKIslandRemoval(mask3,1,0,1000,1)
    x,y = transpose([(0,0),(2047,0),(0,2047),(2047,2047)])
    mask3 = VTKSeedConnectivity(mask3,x,y,val=1)
    mask3 = mask3.astype(float32)
    mask3 = greater(VTKConvolve(mask3,k=5,numret=1),0).astype(float32)
    fy = 1.*greater(1.*add.reduce(mask3,0)/mask3.shape[0],0.998)
    fx = 1.*greater(1.*add.reduce(mask3,1)/mask3.shape[1],0.998)
    fy = 1.*greater(VTKGauss(fy,24.0,1),0.01)
    fx = 1.*greater(VTKGauss(fx,24.0,1),0.01)
    mask3xy = 1.*logical_or(fy[NewAxis,::], fx[::,NewAxis])
    mask3 = evaluate("mask3*mask3xy").astype(float32)
#    mask31 = greater(VTKGauss(mask31,4,1),0.01).astype(float32)
#    mask3 = logical_or(mask31,mask30).astype(float32)
#    i4 = where(mask2,i1,back)
#    qdump("/tmp/i4.fits",i4)
    return i2,mask2,mask3

#    sc = 16
#    ci1 = compress(mask.ravel()*i1.ravel(),i1.ravel())
#    mi1 = median(ci1)
#    noise0 = 1.49*median(abs(ci1-mi1))
##    noise0 = ModalSmooth(i1,mask,256,3,pct=40,cut=0.)[2]
#    back,obj,noise = ModalSmooth(i1,mask,sc,3,pct=25,cut=0.)
#    urp = less(back,median(back.ravel())-2.5*noise0)
#    while urp.any() and sc < 128:
#       sc = sc*2
#       back2,obj2,noise2 = ModalSmooth(i1,mask,sc,5,pct=25,cut=0.)
#       back = where(urp,back2,back)
#       obj = i1-back
##       noise = where(urp,noise2,noise)
#       urp = less(back,median(back.ravel())-2.5*noise0)
#    back = where(urp,mi1,back)
#    obj = i1-back
#    noise = noise0
    ok = evaluate("abs(obj)<(sig*noise)").astype(float32)
    ok = equal(VTKConvolve(ok,k=3,numret=1),1.0).astype(float32)
    mask2 = evaluate("ok*mask")
    mask3 = evaluate("abs(obj)>(2*noise)")
    mask3 = mask3.astype(float32)
#    masko = VTKIslandRemoval(1.0-mask,1,0,1000,1)
    mask3 = VTKIslandRemoval(mask3,1,0,1000,1)
#    qdump("/tmp/masko.fits",masko)
#    qdump("/tmp/mask3.fits",mask3)
#    mask3 = logical_and(mask3,logical_not(masko)).astype(float32)
    x,y = transpose([(0,0),(2047,0),(0,2047),(2047,2047)])
    mask3 = VTKSeedConnectivity(mask3,x,y,val=1)
    mask3 = mask3.astype(float32)
    mask3 = greater(VTKConvolve(mask3,k=5,numret=1),0).astype(float32)
    fy = 1.*greater(1.*add.reduce(mask3,0)/mask3.shape[0],0.9)
    fx = 1.*greater(1.*add.reduce(mask3,1)/mask3.shape[1],0.9)
    fy = 1.*greater(VTKGauss(fy,16.0,1),0.01)
    fx = 1.*greater(VTKGauss(fx,16.0,1),0.01)
    mask3xy = 1.*logical_or(fy[NewAxis,::], fx[::,NewAxis])
    mask3 = evaluate("mask3*mask3xy")
    i2 = where(mask2,i1,back)
    if 0:
       qdump("/tmp/i1.fits",i1)
       qdump("/tmp/i1m.fits",i1*mask)
       qdump("/tmp/back.fits",back)
       qdump("/tmp/obj.fits",obj)
       qdump("/tmp/obj2.fits",obj*mask)
       qdump("/tmp/noise.fits",noise)
       qdump("/tmp/mask1.fits",mask)
       qdump("/tmp/mask2.fits",mask2)
    return i2,mask2,mask3

#def MakeWaves(i1,si1,sig=3,omask=None,mask=None,tdata=None,nn=4,nt=4,nowave=0,Fr=0):
#    mc = MakeClean(i1,si1,sig=sig,omask=omask,mask=mask,tdata=tdata,Fr=Fr)
def MakeWaves(i1,si1,sig=3,mask=None,tdata=None,nn=4,nt=4,nowave=0,Fr=0):
    mc = MakeClean(i1,si1,sig=sig,mask=mask,tdata=tdata,Fr=Fr)
    i2,bmu1,m3 = mc
#    Bi,u1,mask,b5,bmu1,i2 = mc
#    if nowave:
#       return Bi,u1
#    else:
    if 1:
       w = tomall(flwt2d(i2,nn=nn,nt=nt),nn=nn,nt=nt)
       u = flwt2df(bmu1,nn=nn,nt=nt)
       return i2,m3,w,u

def OldMakeWaves(i1,sig=3,mask=None,nn=4,nt=4,allmed=None):
    print "Making masks..."
    u1 = SeriousMasks(i1,sig=3,mask=mask,allmed=allmed)
    print "Making waves..."
    i1u1 = VTKMultiply(i1,u1)
    b1 = VTKDivide(VTKMeanSmooth(i1u1,64,64,numret=1),
                VTKMeanSmooth(u1,64,64,numret=1))
    b4 = VTKDivide(VTKMeanSmooth(i1u1,128,128,numret=1),
                VTKMeanSmooth(u1,128,128,numret=1))
    b5 = VTKDivide(VTKMeanSmooth(i1u1,512,512,numret=1),
                VTKMeanSmooth(u1,512,512,numret=1))
    b1 = where(b1,b1,b4)
    b1 = where(b1,b1,b5)
    b1 = b5
    i2 = where(logical_and(u1,not_equal(i1,0)),i1,b1)
    w = tomall(flwt2d(i2,nn=nn,nt=nt),nn=nn,nt=nt)
    u = flwt2df(u1,nn=nn,nt=nt)
    print "Done making waves."
    return i2,w,u

#def PlotModes(Exposures,chips,first=1,second=0,flat=0):
#    A = lambda x: DoPlotModes(Exposures,chips,first=first,second=second,flat=flat)
#    RunForkedQueue(A,[0],MaxThreads=1,monitor=0,ThreadOutput=True)

def PlotModes(Exposures,chips,first=1,second=0,flat=0):
    print "Plotting chips",chips
    if len(chips) == 1:
       if first: skyplot = Exposures[0].scratch("skyplot1c%d.ps" % (chips[0]))+"/vcps"
       elif second: skyplot = Exposures[0].scratch("skyplot2c%d.ps" % (chips[0]))+"/vcps"
       else: skyplot = Exposures[0].scratch("skyplot0c%d.ps" % (chips[0]))+"/vcps"
    else:
       if first: skyplot = Exposures[0].scratch("skyplot1.ps")+"/vcps"
       elif second: skyplot = Exposures[0].scratch("skyplot2.ps")+"/vcps"
       else: skyplot = Exposures[0].scratch("skyplot0.ps")+"/vcps"

    Exposures = Exposures
    fsky = array([e.sky for e in Exposures])
    bab = not flat and (sum(fsky) and (sum(fsky) < len(fsky)))
    if Exposures[0].sky:
       bab = 0
       fsky = zeros(fsky.shape)
    if bab:
      print "Justing using the object frames!"
      Exposures = [E for E in Exposures if not E.sky]
    skies = [asarray([E.ReadMode(chip,first=first,second=second) for E in Exposures]) for chip in chips]
    pcts = [transpose([E.ReadPcts(chip,first=first,second=second) for E in Exposures]) for chip in chips]

    mjd = array([E.mjd for E in Exposures])
    fsky = array([E.sky for E in Exposures])
    if Exposures[0].sky:
       bab = 0
       fsky = zeros(fsky.shape)
    etime = array([E.exptime for E in Exposures])
    mjd = mjd - mjd[0]
    cis = [1,2,3,4]
    modes = asarray([sky[::,0] for sky in skies])
    mmodes = median(modes)
    for mm,E in zip(mmodes,Exposures):
       for chip in chips:
           if first: mfits = E.mfits1(chip)
           elif second: mfits = E.mfits2(chip)
           else: mfits = E.mfits0(chip)
           F = FITS(mfits,readonly=0)
           if F["mode"] == "N/A": F.modkey("mmedian",mm)
           else: F.modkey("mmode",mm)
           F.close()

    scats = asarray([sky[::,1] for sky in skies])
    if Exposures[0].fclass == "fourstar":
       if Exposures[0].gain[0] == "F":
          gain,rn = 2.5,20.0
       elif Exposures[0].gain[0] == "L":
          gain,rn = 1.3,15.0
       gain = gain*len(Exposures[0].oloop)
       rn = rn/sqrt(len(Exposures[0].oloop))
       preds = getsqrt(modes/gain+(rn/gain)**2)
       mratbad = 3.0
    elif Exposures[0].fclass == "newfirm":
       gain,rn = 8.0,25.0
       preds = getsqrt(modes/gain+(rn/gain)**2)
       mratbad = 5.0
    rscats = divz(scats,preds)
    lscat = 2*getpct(transpose(rscats),75)

    mrats = mean(divz(scats,preds))
    if flat and "Dark" not in Exposures[0].target:
       for ic,(pct,chip) in enumerate(zip(pcts,chips)):
#           bad = logical_or(greater(mrats,4), less(pct[2],95))
#           bad = greater(mrats,3.0)
           bad = logical_or(greater(mrats,mratbad),greater(gain*mmodes,100e3))
           if first:
              [os.remove(Exposures[j].mfits1(chip)+".bad") for j in range(len(Exposures)) if FileCheck(Exposures[j].mfits1(chip)+".bad")]
           for j in nonzero(bad):
               bf = Exposures[j].mfits1(chip)+".bad"
               open(bf,"w").close()
    elif not flat:
       bad = logical_or(greater(rscats,lscat[::,NewAxis]),less(modes,0))
       if fsky.any():
          bad = logical_and(bad, fsky[NewAxis,::])
       for ic,chip in enumerate(chips):
           if first:
              [os.remove(Exposures[j].mfits1(chip)+".bad") for j in range(len(Exposures)) if FileCheck(Exposures[j].mfits1(chip)+".bad")]
           for j in nonzero(bad[ic]):
               bf = Exposures[j].mfits1(chip)+".bad"
               print bf
               open(bf,"w").close()

    [E.Bad() for E in Exposures]
    reallybad = array([E.bad for E in Exposures])

    modes = divz(modes,etime[NewAxis,::])
    scats = divz(scats,etime[NewAxis,::])
    preds = divz(preds,etime[NewAxis,::])
    rats = divz(scats,preds)
    xm = add([-0.002,0.002],extrema(mjd))
    ym1 = add([-10,10],extrema(ravel(modes)))
    ym2 = [0.0,2.0*getpct(ravel(scats),95)]
    ym3 = [0.0,2.0*getpct(ravel(rats),95)]
    opendev(skyplot,nx=2,ny=2,land=0,size=7.5,asp=1)

    newbox(xm,ym1,ch=2.3)
    xlabel("MJD-MJD\d0\u",ch=2.3)
    ylabel("Sky (DN/s)",ch=2.3)
    for sky,chip in zip(skies,chips):
       modes = sky[::,0]/etime
       drawpt(mjd,modes,ps=17,ci=cis[chip-1],ch=2)

       bx,by = compress(reallybad,[mjd,modes],1)
       drawpt(bx,by,ps=4,ci=cis[chip-1],ch=3)

    newbox(xm,ym2,ch=2.3)
    xlabel("MJD-MJD\d0\u",ch=2.3)
    ylabel("\gs (DN/s)",ch=2.3)
    for l,rsig,pred,sky,chip in zip(lscat,rscats,preds,skies,chips):
       scats = sky[::,1]/etime
       noise = pred
       drawpt(mjd,scats,ps=17,ci=cis[chip-1],ch=2)
       drawln(mjd,noise,ls=4,ci=cis[chip-1],lw=2)

       bx,by = compress(reallybad,[mjd,scats],1)
       drawpt(bx,by,ps=4,ci=cis[chip-1],ch=3)

    newbox(xm,ym3,ch=2.3)
    xlabel("MJD-MJD\d0\u",ch=2.3)
    ylabel("\gs/\gs\dp\u",ch=2.3)
    drawpt(mjd,mrats,ps=3,ci=5,ch=4)
    for l,rsig,pred,sky,chip in zip(lscat,rscats,preds,skies,chips):
       scats = sky[::,1]/etime
       noise = pred
       rat = divz(scats,noise)
       print chip,quartiles(rat)
       drawpt(mjd,rat,ps=17,ci=cis[chip-1],ch=2)

       bx,by = compress(reallybad,[mjd,rat],1)
       drawpt(bx,by,ps=4,ci=cis[chip-1],ch=3)

       drawln(xm,array([l,l]),ls=1,ci=cis[chip-1],lw=1)

    newbox(xm,[0.0,100.0],ch=2.3)
    xlabel("MJD-MJD\d0\u",ch=2.3)
    ylabel("Pct < |N\gs|",ch=2.3)
    for pct,chip in zip(pcts,chips):
       drawpt(mjd,pct[0],ps=17,ci=cis[chip-1],ch=3)
       drawpt(mjd,pct[1],ps=17,ci=cis[chip-1],ch=2)
       bx,by1,by2 = take([mjd,pct[0],pct[1]],nonzero(reallybad),1)
       drawpt(bx,by1,ps=4,ci=cis[chip-1],ch=2)
       drawpt(bx,by2,ps=4,ci=cis[chip-1],ch=3)

    closedev()
    pstopng(skyplot.replace("/vcps",""))

def pstopng(f):
        print f
        if f[-2:] == "ps":
           verbex("fixout '%s'"%(f))
           verbex("gs -dBATCH -sDEVICE=png16m -r200 -dEPSCrop -dNOPAUSE -sOutputFile='%s' '%s'"%(f.replace(".ps",".png"),f))
#           verbex("convert -density 200x200 %s %s"%(f,f.replace(".ps",".png")))

def ShiftCheck(NDS,chips,stage):
#    if isinstance(NDS[0],newfirm):
#       print "NEWFIRM FourCLiftDataset!"
#       UseExposures = [Exposure(N1) for N1 in NDS]
#    elif isinstance(NDS[0],fourstar):
#       print "FourStar FourCLiftDataset!"
#       UseExposures = [Exposure(N1) for N1 in NDS]
#    else:
    if isinstance(NDS,StringType):
       fEpck = open(NDS,"rb")
       UseExposures = cPickle.load(fEpck)
       fEpck.close()
    else:
       print "Exposure list!"
       UseExposures = NDS
    Exposures = [E for E in UseExposures if not E.bad]
    doshifts = False
    if not FileCheck(Exposures[0].scratch("Shifts%s.dat"%(stage))):
       stbl = open(Exposures[0].scratch("Shifts%s.dat"%(stage)),"w")
       print >> stbl, "# frame xdiff1 xscat1 ydiff1 yscat1 adiff1 mdiff1 mscat1 lmatch1"
    else: stbl = None
    for E in Exposures:
        if doshifts: break
        for chip in chips:
            if doshifts: break
            if E != Exposures[0] and not FileCheck(eval("E.shift"+stage)(chip).replace(".png",".out")):
               doshifts = True
               print eval("E.shift"+stage)(chip).replace(".png",".out"),doshifts
               break
            if not FileCheck(eval("E.cat"+stage)(chip)):
               doshifts=True
               print eval("E.cat"+stage)(chip),doshifts
               break
            if not doshifts:
               F = FITS(eval("E.sfits"+stage)(chip))
               xdiff1 = F["xdiff1"]
               xscat1 = F["xscat1"]
               ydiff1 = F["ydiff1"]
               yscat1 = F["yscat1"]
               adiff1 = F["adiff1"]
               mdiff1 = F["mdiff1"]
               mscat1 = F["mscat1"]
               lmatch1 = F["lmatch1"]
               F.close()
               print >> stbl, os.path.basename(eval("E.sfits"+stage)(chip)), \
                       xdiff1, xscat1, ydiff1, yscat1, adiff1, mdiff1, mscat1, lmatch1
               if type(xdiff1) == StringType or type(ydiff1) == StringType:
                  doshifts=True
                  print eval("E.sfits"+stage)(chip), doshifts
                  break
    if stbl != None: stbl.close()
    return doshifts

def ShiftsTable(NDS,chips,stage):
#    if isinstance(NDS[0],newfirm):
#       print "NEWFIRM FourCLiftDataset!"
#       UseExposures = [Exposure(N1) for N1 in NDS]
#    elif isinstance(NDS[0],fourstar):
#       print "FourStar FourCLiftDataset!"
#       UseExposures = [Exposure(N1) for N1 in NDS]
#    else:
    if isinstance(NDS,StringType):
       fEpck = open(NDS,"rb")
       UseExposures = cPickle.load(fEpck)
       fEpck.close()
    else:
       print "Exposure list!"
       UseExposures = NDS
    Exposures = [E for E in UseExposures if not E.bad]
    stbl = open(Exposures[0].scratch("Shifts%s.dat"%(stage)),"w")
    print >> stbl, "# frame xdiff1 xscat1 ydiff1 yscat1 adiff1, mdiff1 mscat1 lmatch1"

    for E in Exposures:
        for chip in chips:
            F = FITS(eval("E.sfits"+stage)(chip))
            xdiff1 = F["xdiff1"]
            xscat1 = F["xscat1"]
            ydiff1 = F["ydiff1"]
            yscat1 = F["yscat1"]
            adiff1 = F["adiff1"]
            mdiff1 = F["mdiff1"]
            mscat1 = F["mscat1"]
            lmatch1 = F["lmatch1"]
            F.close()
            print >> stbl, os.path.basename(eval("E.sfits"+stage)(chip)), \
                    xdiff1, xscat1, ydiff1, yscat1, adiff1, mdiff1, mscat1, lmatch1
    stbl.close()


def MakeJXY(nn,nt):
   x = ones((2048,2048),float32)
   if not JXY:
      if FileCheck("jar%d_%d.fits" %(nn,nt)) and FileCheck("xyr%d_%d.fits" %(nn,nt)):
         print "Reading jar%d_%d.fits" %(nn,nt)
         F = FITS("jar%d_%d.fits" %(nn,nt))
         jar = F.data()
         F.close()
         print "Reading xyr%d_%d.fits" %(nn,nt)
         F = FITS("xyr%d_%d.fits" %(nn,nt))
         xyr = F.data()
         F.close()
         JXY["jar"] = jar
         JXY["xyr"] = xyr
      else:
         print "Making jar and xyr..."
         y,x = indices((2048,2048),int16)
         jar,xyr = jar2d(x,nn,nt)
         jar = jar.astype(int16)
         xyr = xyr.astype(int16)
         JXY["jar"] = jar
         JXY["xyr"] = xyr
      if not FileCheck("jar%d_%d.fits" %(nn,nt)):
         F = FITS("jar%d_%d.fits" %(nn,nt),create=1)
         F.newhead("T",16,2,[2048,2048])
         F.putdata(JXY["jar"])
         F.close()
      if not FileCheck("xyr%d_%d.fits" %(nn,nt)):
         F = FITS("xyr%d_%d.fits" %(nn,nt),create=1)
         F.newhead("T",16,2,[2048,2048])
         F.putdata(JXY["xyr"])
         F.close()
      JXY["L"] = extrema(list(Set(JXY["jar"].ravel())))

def WaveAnalyze(Exposures,chip,first,second,l,s,ME=None,mpi=1,noclean=0,\
          inter=0,nn=4,nt=4,verb=0,bdir="",origdir="",ys=0,kss=[],noplots=0):
#    ClearWaves(force=1)
    fEpck = open(Exposures,"rb")
    Exposures = cPickle.load(fEpck)
    fEpck.close()
    Wx = arange(len(Exposures))
    if first: stage = "1"
    elif second: stage = "2"
    p = int(stage)
    kd = {}
    if Exposures[0].fclass=="fourstar":
       jno = array([E.expno for E in Exposures])
       kno = array([E.loopno for E in Exposures])
       for j,k in zip(jno,kno):
           if j in kd: kd[j] = max([k,kd[j]])
           else: kd[j] = k
       mloops = median([kd[j] for j in jno])
    elif Exposures[0].fclass=="newfirm":
       mloops = 1
    Wt = array([f.mjd for f in Exposures])
    FIN = [FITS(f.mfits2(chip)) for f in Exposures]
    We = array([E.exptime*len(E.loop) for E in Exposures])
    Wem = We/60.0
    if FIN[0]["mmode"] == "N/A": Wms = array([f["mmedian"] for f in FIN])
    else: Wms = array([f["mmode"] for f in FIN])
#    Wt = array([f["mjd-obs"] for f in FIN])
    [f.close() for f in FIN]
    Wt = Wt*24.0*60.0 + We/60.0/2.
    Hmax =   (Wt[-1]-Wt[0]+2*(Wem[-1]+Wem[0]))
    Hmin = (Wt[0]-Wem[0])
    Wt0 = Wt-Hmin
    Hx = (Wt-Hmin)/Hmax
    MakeJXY(nn=nn,nt=nt)
    L = JXY["L"]
    jar = JXY["jar"]
    xyr = JXY["xyr"]
    wpars = "wavelets%d.pars" % (p)
    if origdir: wpars = origdir + "/" + wpars
    wpars = readtable(wpars,header=0,icols=[0,1,2,3])
    nvar,tvar,wvar,svar = compress(equal(wpars["l"],L[1]-l),[wpars["n"],wpars["t"],wpars["w"],wpars["s"]],1)[::,0]
    pvar = [0,1][not nvar and not tvar and wvar>0]
    y,x = indices(jar.shape,int16)
    u = equal(jar,l)*equal(xyr,s)
    yu,xu = compress(u.ravel(),[y.ravel(),x.ravel()],1)
    ay0,ay1 = extrema(yu)
    ax0,ax1 = extrema(xu)
#    if len(Exposures) < 60:
#       [setattr(f,"cache",1) for f in Exposures if f.cache]
#       [f.WData(chip,first=first,second=second) for f in Exposures if f.cache]
    if not ys:
#       if not nvar and not tvar: ys = 2
#       if not nvar and not tvar: ys = 2*int(len(Wt)/1 + 1)
       if not nvar and not tvar: ys = (ay1-ay0)/(int(len(Wt)/1 + 1))
       else: ys = int(len(Wt)/1 + 1)
#    if ys>(ay1-ay0+1): ns = (ay1-ay0)/ys + 1
#    else: ns = 2
    ns = (ay1-ay0)/ys + 1
    px = 2
    if ns > 1: px = 4
#    py = ns/(px/2)
    py = ns/px + 1
    if inter: px,py = 2,1
    if tvar and svar: px = px*3/2
    if tvar > 0:
       Nh = int(Hmax/tvar+1)
    elif tvar < 0:
       nrate = 2*median(diff(Wt))*mloops
       nrate = 2*mean(diff(Wt))*mloops
       Nh = int(Hmax/ (abs(tvar)*nrate))
    tstart = time.time()
    store = Exposures[0].scratch("smow%d/wtrendc%d_%d%s.fits" % (p,chip,L[1]-l,"xyr"[s-1]))
    if kss == None or kss == []:
       fstore = FITS(store,create=1)
       if nvar:
          fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,1])
       elif pvar:
          fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,len(Exposures)])
       elif not nvar and not tvar:
          fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,1])
       elif tvar:
          fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,2*Nh+1])
          fstore.modkey("tmin",Hmin)
          fstore.modkey("tspan",Hmax)
          fstore.modkey("Nh",Nh)
       fstore.flush()
       fstore.close()
       if l: return range(ns)
    if kss == None or kss == []: kss = range(ns)
    Wspans = {}
    Wmss = {}
#    for ks in kss:
    def GoThroughOne(ks):
       fstore = FITS(store,readonly=0)
       if noplots: pgdev = None
       elif inter: pgdev = "/xs"
       else: pgdev = Exposures[0].scratch("smow%d/wtrendc%d_%d%s.ps" % (p,chip,L[1]-l,"xyr"[s-1]))+"/vcps"
       t = "L=%d | %s (%d/%d)" % (L[1]-l,"xyr"[s-1],ks+1,ns)
       print t,;sys.stdout.flush()
       y0 = ks*ys+ay0
       y1 = min([(ks+1)*ys+ay0,ay1])
       x0 = ax0
       x1 = ax1
#       print x0,x1,y0,y1
       ne = len(Exposures)
       ny,nx = y1-y0+1,x1-x0+1
       W = zeros((ne,ny,nx),float32)
       Wscs3d = zeros((ne,ny,nx),float32)
       U = zeros((ne,ny,nx),float32)
       for k,E in enumerate(Exposures):
#         if verb: print k,E,E.wfits2(chip)
#         print k,E,E.wfits2(chip),E.cache
         if E.cache:
            W[k] = E.lift[chip][0][y0:y0+ny,x0:x0+nx].astype(W.dtype)
            U[k] = E.lift[chip][1][y0:y0+ny,x0:x0+nx].astype(W.dtype)
         else:
            WF = FITS(E.wfits2(chip))
            W[k] = WF.readsec([x0,y0],[x0+nx-1,y0+ny-1]).astype(W.dtype)
            WF.close()
            UF = FITS(E.ufits2(chip))
            Uk = UF.readsec([x0,y0],[x0+nx-1,y0+ny-1])
            U[k] = Uk.astype(U.dtype)
            UF.close()
#         if k == 0: print k,sum(W[k].ravel()),sum(U[k].ravel())
         W[k] = divz(W[k],Wms[k]).astype(float32)
         U[k] = greater(U[k],0).astype(float32)
#         Uk = U[k]
#         U[k] = evaluate("Uk>0").astype(float32)
         if wvar:
            U[k] = ones(U[k].shape,float32)
            U[k] = VTKAdd(VTKMultiply(U[k],wvar+1),wvar)
#            Uk = U[k]
#            U[k] = evaluate("Uk*(wvar+1) + wvar")
       Wmed = median(W.ravel())
       Wspan = 5*rms(W.ravel()-Wmed)
       Wspans[l] = Wspan
       Wmss[l] = Wms
       if l: Wspan = Wspan*10
       sW = getsqrt(Wms/We)*0 + 1
       R = zeros(W.shape,float32)
       if nvar:
          sys.stdout.write("(S) "),;sys.stdout.flush()
          noplot = False
#          if not ks:
#             fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,1])
          k1d = concatenate([ nvar*[1.0],[0.0],nvar*[1.0]])
          k2d = k1d[::,NewAxis] * concatenate([ nvar*[0.0],[1.0],nvar*[0.0]])[NewAxis,::]
          k2d = (k2d/sum(k2d.ravel())).astype(float32)
          for j in range(W.shape[2]):
              Wj = W[::,::,j].astype(float32)
              Uj = U[::,::,j].astype(float32)
              mWj = median(Wj)[NewAxis,::]
              sWj = 1.49*median(abs(Wj-mWj))
              if l:
                rWj = divz(1,evaluate("(3*sWj)**2")+evaluate("(Wj-mWj)**2"))
                rWj = divz(rWj,median(rWj))
              else:
                rWj = 1
              Uj = (sW[::,NewAxis]*Uj*rWj).astype(float32)
              for mp in range(mpi):
#                 WUj = VTKMultiply(Wj,Uj)
                 WUj = evaluate("Wj*Uj")
                 if l:
                    numer = VTKCorrelation(WUj,k2d,numret=1,mirror=1,wrap=0,constant=None)
                    denom = VTKCorrelation(Uj,k2d,numret=1,mirror=1,wrap=0,constant=None)
                 else:
                    numer = VTKCorrelation(WUj,k2d,numret=1,mirror=1,wrap=0,constant=None)
                    denom = VTKCorrelation(Uj,k2d,numret=1,mirror=1,wrap=0,constant=None)
#                 Rj = VTKDivide(numer,denom)
                 Rj = divz(numer,denom)
                 R[::,::,j] = Rj
                 if ME and mp<mpi-1:
                    d = VTKSubtract(Wj,Rj)
                    sWr = 1.49*median(abs(d))
                    Uj = U[::,::,j].astype(float32)
#                    Uj = (sW[::,NewAxis]*U[::,::,j]*rWj).astype(float32)
                    sWn = sW[::,NewAxis]
                    Uj = evaluate("sWn*U[::,::,j]*rWj").astype(float32)
                    Uj2 = ME(divz(d,sWr[NewAxis,::]),w=1).astype(float32)
#                    Uj = VTKMultiply(Uj,ME(divz(d,sWr[NewAxis,::]),w=1).astype(float32))
                    Uj = evaluate("Uj*Uj2").astype(float32)
              U[::,::,j] = Uj.astype(U.dtype)
       elif pvar:
          sys.stdout.write("(P) "),;sys.stdout.flush()
          noplot = True
          R = W
#          if not ks:
#             fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,len(R)])
          fstore.writesec(R,[x0-ax0,y0-ay0,0],[x0-ax0+nx-1,y0-ay0+ny-1,len(R)-1])
          writedata = (R,[x0-ax0,y0-ay0,0],[x0-ax0+nx-1,y0-ay0+ny-1,len(R)-1])
       elif not nvar and not tvar:
#          print nvar,tvar,wvar
          sys.stdout.write("(M) "),;sys.stdout.flush()
          noplot = True
          if 0:
             R1 = U*sW[::,NewAxis,NewAxis]
             Wm = divz(add.reduce(R1*W,0),add.reduce(R1,0))
             R = Wm[NewAxis,::,::]*ones(W.shape)
             print sum(U.ravel())
             print sum(R.ravel()**2)
             d = VTKSubtract(W,R)
          else:
             sWn = sW[::,NewAxis,NewAxis]
             R1 = evaluate("U*sWn")
             Wm = divz(add.reduce(evaluate("R1*W"),0),add.reduce(R1,0))
             Wmn = Wm[NewAxis,::,::]
             oW = ones(W.shape)
             R = evaluate("Wmn*oW")
             d = evaluate("W-R")
#          if not ks:
#             fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,1])
          fstore.writesec(R,[x0-ax0,y0-ay0,0],[x0-ax0+nx-1,y0-ay0+ny-1,0])
          writedata = (R,[x0-ax0,y0-ay0,0],[x0-ax0+nx-1,y0-ay0+ny-1,0])
       elif tvar:
          noplot = False
#          if tvar > 0:
#             Nh = int(Hmax/tvar+1)
#          else:
#             nrate = 1*median(diff(Wt))*mloops
##             nrate = 1*mean(diff(Wt))*mloops
##             nrate = 2*mloops*diff(extrema(Wt))[0]/len(Wt)
#             Nh = int(Hmax/ (abs(tvar)*nrate))
          Hr = zeros((2*Nh+1,)+Hx.shape,float64)
          Hr[0] = ones(Hx.shape,float64)
          ih = arange(1,Nh+1,1,int32)
          for ih in range(1,Nh+1):
            Hr[2*ih-1] = evaluate("cos(2*pi*ih*Hx)")
            Hr[2*ih] = evaluate("sin(2*pi*ih*Hx)")
#          if not ks:
#             fstore.newhead("T",-32,3,[ax1-ax0+1,ay1-ay0+1,len(Hr)])
#             fstore.modkey("tmin",Hmin)
#             fstore.modkey("tspan",Hmax)
#             fstore.modkey("Nh",Nh)
          sys.stdout.write("(F %.1f) "%(tvar)),;sys.stdout.flush()
          Pspec = zeros((Hr.shape[0],ny,nx),float64)
          Pspecu = zeros((Nh+1,ny,nx),float64)
          icuts = zeros((ny,nx),int16)
          Srout = zeros((len(Hr),ny,nx),float64)
          for my in range(ny):
             for mx in range(nx):
                 Wr = 1*W[::,my,mx]
                 Un = U[::,my,mx]
                 uW = evaluate("Un*sW")
                 cWr = compress(uW,Wr)
                 mWr = median(cWr)
                 sWr = 1.49*median(abs(cWr-mWr))
                 if 0 and l and wvar:
                   rWr = divz(1,evaluate("sqrt((wvar*sWr)**2+(Wr-mWr)**2)"))
                   rWr = divz(rWr,median(rWr))
                 else:
                   rWr = 1
                 uW = evaluate("Un*sW*rWr")
                 NuW = len(nonzero(uW))
#                 print mx,my,len(Hr),NuW
#                 if NuW > len(Hr):
                 if 1:
                    v1 = rms(compress(uW,Wr))
                    for mp in range(mpi):
#                       print uW
#                       print rWr
                       du,dv,dw = singular_value_decomposition(transpose(Hr)*uW[::,NewAxis])
                       sol1 = transpose(dw)
                       if svar:
                          for icut in arange(Hr.shape[0]):
                             sol2 = divz(1,dv[:icut])
                             sol3 = dot(transpose(du[::,:icut]),Wr*uW)
                             Sr = dot(sol1[::,:icut],(sol2*sol3))
                             Er = dot(Sr,Hr)
                             d = evaluate("Wr-Er")
                             uu,ud = compress(uW,[uW,d],1)
                             if len(uu):
                                uu = uu/max(uu)
                                ud2 = divz(sum(uu*ud**2),(len(ud)-icut))
                             else: ud2 = 0.0
                             Pspec[icut,my,mx] = ud2
                          uPspec = Pspec[::,my,mx]
                          gcut = nonzero(greater(getlog10(uPspec),-90))
                          if len(gcut):
                             icut = gcut[argmin(take(uPspec,gcut))]+1
                          else:
                             icut = 1
                          icuts[my,mx] = icut
                       else:
                          icuts[my,mx] = min([Hr.shape[0],NuW])
                       sol2 = divz(1,dv[:icuts[my,mx]])
                       sol3 = dot(transpose(du[::,:icuts[my,mx]]),Wr*uW)
                       Sr = dot(sol1[::,:icuts[my,mx]],(sol2*sol3))
                       Er = dot(Sr,Hr)
                       d = evaluate("Wr-Er")
                       if ME and mp <mpi-1:
                          uW = evaluate("Un*sW*rWr")
                          uWE=ME(divz(d,sWr),w=1)
                          uW = evaluate("uW*uWE")
                       R[::,my,mx] = Er
                    Srout[::,my,mx] = Sr
                 Rm = R[::,my,mx]
                 d = evaluate("Wr-Rm")
                 Nu = len(d)
                 vu = compress(uW,d)
                 NuW = len(vu)
                 v2 = rms(vu)
                 v3 = 1.49*median(abs(vu))
#                 if verb: print "%3d %3d %5.1f %3d %4d %4d %8.4e %8.4e" % (mx,my,v1,Nh,Nu,NuW,v2,v3)
          fstore.writesec(Srout,[x0-ax0,y0-ay0,0],[x0-ax0+nx-1,y0-ay0+ny-1,len(Srout)-1])
          writedata = (Srout,[x0-ax0,y0-ay0,0],[x0-ax0+nx-1,y0-ay0+ny-1,len(Srout)-1])

       print "write!"
       fstore.close()

       if noplot or noplots: pgdev = None

       if pgdev != None:
           print "plot!",pgdev
           if not ks:
              print "opening pgplot device",pgdev
              opendev(pgdev,nx=px,ny=py,land=0,ask=0,size=3.0*px,asp=1.*py/px)
           xm = [Wt0[0]-0.02*(Wt0[-1]-Wt0[0]),Wt0[-1]+0.02*(Wt0[-1]-Wt0[0])]
           if l: ym = [-Wspan/(max(L)-l+1),+Wspan/(max(L)-l+1)]
           else: ym = [Wmed-Wspan,Wmed+Wspan]
           if inter:
              for mx in range(nx):
                 for my in range(ny):
                    W1 = W[::,my,mx]
                    R1 = R[::,my,mx]
                    U1 = U[::,my,mx]
                    D1 = W1-R1
                    uW1,uR1,uU1,uD1,uWt = compress(U1,[ W1,R1,U1,D1,Wt0],1)
                    newbox(xm,ym,ch=2.0)
                    xlabel("time (min)",ch=2.0)
                    ylabel("W",ch=2.0)
                    subtitle(t,ch=2.0)
                    drawpt(Wt0,W1,ps=1,ci=2)
                    if len(uW1):
                      drawpt(uWt,uW1,ps=1,ci=7)
                    drawpt(Wt0,R1,ps=1,ci=4)
                    newbox(xm,[-Wspan/(max(L)-l+1),Wspan/(max(L)-l+1)],ch=2.0)
                    xlabel("time (min)",ch=2.0)
                    ylabel("\gDW",ch=2.0)
                    subtitle(t,ch=2.0)
                    drawpt(Wt0,D1,ps=1,ci=2)
                    if len(uD1):
                       drawpt(uWt,uD1,ps=1,ci=7)
                    raw_input(" <hit cr> ")
           else:
              newbox(xm,ym,ch=2.0)
              xlabel("time (min)",ch=2.0)
              ylabel("W",ch=2.0)
              subtitle(t,ch=2.0)
              medW = mean(W.ravel())
              rmsW = rms(W.ravel(),medW)
              rmsD = sum([sum(power((W[k]-R[k]).ravel(),2)) for k in Wx])
              rmsD = sqrt(rmsD/multiply.reduce(W.shape))
              for mx in range(nx):
                 for my in range(ny):
                    W1 = W[::,my,mx]
                    R1 = R[::,my,mx]
                    U1 = U[::,my,mx]
                    D1 = W1-R1
                    uW1,uR1,uU1,uD1,uWt = compress(U1,[ W1,R1,U1,D1,Wt0],1)
                    drawpt(Wt0,W1,ps=1,ci=2)
                    if len(uW1):
                       drawpt(uWt,uW1,ps=1,ci=7)
                    drawpt(Wt0,R1,ps=1,ci=4)

              newbox(xm,[-Wspan/(max(L)-l+1),Wspan/(max(L)-l+1)],ch=2.0)
              xlabel("time (min)",ch=2.0)
              ylabel("\gDW",ch=2.0)
              subtitle(t,ch=2.0)
              for mx in range(nx):
                 for my in range(ny):
                    W1 = W[::,my,mx]
                    R1 = R[::,my,mx]
                    U1 = U[::,my,mx]
                    D1 = W1-R1
                    uW1,uR1,uU1,uD1,uWt = compress(U1,[ W1,R1,U1,D1,Wt0],1)
                    drawpt(Wt0,D1,ps=1,ci=2)
                    if len(uD1):
                       drawpt(uWt,uD1,ps=1,ci=7)
              rxa = arange(xm[0]-10,xm[-1]+10,1,float32)
              drawln(rxa,rmsW*ones(rxa.shape),ls=2,ci=2)
              drawln(rxa,-rmsW*ones(rxa.shape),ls=2,ci=2)
              drawln(rxa,rmsD*ones(rxa.shape),ls=2,ci=4)
              drawln(rxa,-rmsD*ones(rxa.shape),ls=2,ci=4)

              if tvar and svar:
                 Px = arange(Hr.shape[0])
                 pxm = [Px[0]-0.01,Px[-1]+0.01]
                 Py = getlog10(Pspec.ravel())
                 Py = compress(greater(Py,-90),Py)
                 pymin,pymax = extrema(Py)
                 pym = [pymin-0.5,pymax+0.5]
                 newbox(pxm,pym,ch=2.0,ylog=1)
                 xlabel("k",ch=2.0)
                 ylabel("Scatter",ch=2.0)
                 subtitle(t,ch=2.0)
                 for mx in range(nx):
                    for my in range(ny):
                       P1 = getlog10(Pspec[::,my,mx])
                       sPx,sP1 = compress(greater(P1,-90),[Px,P1],1)
                       if len(sP1):
                          drawln(sPx,sP1,ls=1,ci=2)
                       icut = icuts[my,mx]
                       uPx,uP1 = Px[:icut],P1[:icut]
                       drawln(uPx,uP1,ls=1,ci=4)
#       if ks == kss[-1]:
#          fstore.close()
       if ks == kss[-1]:
          if pgdev != None:
             print "closing",pgdev
             closedev()
             pstopng(pgdev.replace("/vcps",""))
       return writedata
    [GoThroughOne(ks) for ks in kss]
#    if l and 0:
#       @defer.inlineCallbacks
#       def go():
#           for ks in kss:
#               GoThroughOne(ks)
#               yield
#           telapse = time.time()-tstart
#           print "Time elapsed for construction of %d (%s) was %.2f" % (max(L)-l,"xyr"[s-1],telapse)
#       co = task.cooperate(go())
#    else:
#       [GoThroughOne(ks) for ks in kss]
#    if l:
##        def GoThroughThem():
##           for ks in kss:
##              GoThroughOne(ks)
##              yield
##        co = task.cooperate(GoThroughThem())
##        return co.whenDone()
#        [GoThroughOne(ks) for ks in kss]
#    if not l:
#        GoThroughOne(0)
##        [x for x in GoThroughThem()]
    if not l:
       telapse = time.time()-tstart
       print "Time elapsed for construction of %d (%s) was %.2f" % (max(L)-l,"xyr"[s-1],telapse)
       return Wspans[l],Wmss[l]

def ClearWaves(pset):
    for k in WDICT[pset].keys():
        del WDICT[pset][k]

def ReadWaves(p=1,chip=0,origdir="",nn=4,nt=4,clear=0,first=0,second=1,pset=1):
  if first: ci = 1
  elif second: ci = 2
  if clear: ClearWaves(pset)
  if chip not in WDICT[pset] or WDICT[pset][chip].get("c","") != origdir:
     MakeJXY(nn=nn,nt=nt)
     L = JXY["L"]
     jar = JXY["jar"]
     xyr = JXY["xyr"]
     y,x = indices(jar.shape,int16)
     wpars = origdir + "/wavelets%d.pars" % (p)
     wpars = readtable(wpars,header=0,icols=[0,1,2,3])
     luse = sort(max(L)-compress(wpars["u"],wpars["l"]))
     wdict = {}
     wdict["a"] = {}
     wdict["b"] = {}
     wdict["c"] = origdir
     for l in luse:
        nvar,tvar,wvar,svar = compress(equal(wpars["l"],L[1]-l),[wpars["n"],wpars["t"],wpars["w"],wpars["s"]],1)[::,0]
        pvar = [0,1][not nvar and not tvar and wvar>0]
        u = equal(jar,l).ravel()
        yl,xl,sl = compress(u,[y.ravel(),x.ravel(),xyr.ravel()],1)
        for s in [[3],[1,2,3]][l>0]:
            u = equal(sl,s)
            yu,xu,su = compress(u,[yl,xl,sl],1)
            ay0,ay1 = extrema(yu)
            ax0,ax1 = extrema(xu)
            wdict["a"][(l,s)] = [ay0,ay1],[ax0,ax1]
            print l,s, wdict["a"][(l,s)]
            store = origdir+"/smow%d/wtrendc%d_%d%s.fits" % (p,chip,L[1]-l,"xyr"[s-1])
            print "Reading",store
            fstore = FITS(store)
            if tvar:
               Hmin = fstore["tmin"]
               Hmax = fstore["tspan"]
               Nh = fstore["Nh"]
               wdict["b"][(l,s)] = [Hmin,Hmax,Nh,fstore.data()]
            else:
               wdict["b"][(l,s)] = fstore.data()
            fstore.close()
     WDICT[pset][chip] = wdict

def WaveInvert(E,chip,ii,stage,nn=4,nt=4,origdir=""):
  if stage == "1":
     first = 1
     second = 0
     ci = 1
  elif stage == "2":
     first = 0
     second = 1
     ci = 2
  ReadCalibs(E,chip,nfilt=E.filter,first=first,second=second)
  ci = eval(stage)
  n = eval("E.mfits"+stage)(chip)
  o = eval("E.sfits"+stage)(chip)
  oc = eval("E.cat"+stage)(chip)
  w = eval("E.qfits"+stage)(chip)
  m = eval("E.bfits"+stage)(chip)
  k = eval("E.rfits"+stage)(chip)
  e = eval("E.pers"+str(int(stage)-1))(chip)
  eo = eval("E.mask"+str(int(stage)-1))(chip)
  e3 = eval("E.ofits"+stage)(chip)
  p = int(stage)
  MakeJXY(nn=nn,nt=nt)
  L = JXY["L"]
  jar = JXY["jar"]
  xyr = JXY["xyr"]
  if ci in WDICT and chip in WDICT[E.pset] and origdir != WDICT[E.pset][chip].get("c",""):
     ClearWaves(E.pset)
  ReadWaves(p=p,chip=chip,origdir=origdir,nn=nn,nt=nt,pset=E.pset)
  corners = WDICT[E.pset][chip]["a"]
  wdict = WDICT[E.pset][chip]["b"]

  wpars = "wavelets%d.pars" % (p)
  if origdir:
    wpars = origdir + "/" + wpars
  wpars = readtable(wpars,header=0,icols=[0,1,2,3])
  luse = sort(max(L)-compress(wpars["u"],wpars["l"]))

  print "Reading",k
  F = FITS(k)
  Wt = F["mjd-obs"]
  if F["mmode"] == "N/A": Wms = F["mmedian"]
  else: Wms = F["mmode"]
  We = F["exptime"]*len(E.loop)
  k1 = F.data()
  F.close()
  if Wt == "N/A": Wt = E.mjd
  Wt = Wt*24.0*60.0 + We/60.0/2.
#  F = FITS(w)
#  i1 = F.data()
#  F.close()
  i1 = zeros(k1.shape,float64)
  y,x = indices(jar.shape,int16)

  for l in luse:
     print l,;sys.stdout.flush()
     nvar,tvar,wvar,svar = compress(equal(wpars["l"],L[1]-l),[wpars["n"],wpars["t"],wpars["w"],wpars["s"]],1)[::,0]
     pvar = [0,1][not nvar and not tvar and wvar>0]
     for s in [[3],[1,2,3]][l>0]:
#       u = equal(jar,l)*equal(xyr,s)
#       yu,xu = compress(u.ravel(),[y.ravel(),x.ravel()],1)
#       ay0,ay1 = extrema(yu)
#       ax0,ax1 = extrema(xu)
       [ay0,ay1], [ax0,ax1] = corners[(l,s)]
       if pvar:
          i1[ay0:ay1+1,ax0:ax1+1] = wdict[(l,s)][ii]
       elif not nvar and not tvar:
          i1[ay0:ay1+1,ax0:ax1+1] = wdict[(l,s)]
       elif tvar:
          Hmin,Hmax,Nh,Sr = wdict[(l,s)]
          Hx = (Wt-Hmin)/Hmax
          Hr = zeros((2*Nh+1,),float64)
          Hr[0] = 1.0
          ih = arange(1,Nh+1,1,int32)
          Hr[2*ih-1] = cos(2*pi*ih*Hx)
          Hr[2*ih] = sin(2*pi*ih*Hx)
          Hr = Hr[::,NewAxis,NewAxis]
#          for ih in range(1,Nh+1):
#             Hr[2*ih-1] = evaluate("cos(2*pi*ih*Hx)")
#             Hr[2*ih] = evaluate("sin(2*pi*ih*Hx)")
#          Er = zeros(Sr.shape[1:],float64)
#          [add(Er,Sr[h]*Hr[h],Er) for h in range(len(Hr))]
#          sEr = "+".join(["Sr[%d]*Hr[%d]" %(h,h) for h in range(len(Hr))])
          Er = add.reduce(evaluate("Sr*Hr"),0)
          i1[ay0:ay1+1,ax0:ax1+1] = Er.astype(i1.dtype)
  print
  print "Writing",w
  if FileCheck(w): G = FITS(w,readonly=0)
  else: G = FITS(w,create=1,template=n)
  i1m = VTKMultiply(i1,Wms)
  G.putdata(i1m)
  G.close()
  MakeThumbnail(w,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
  MakeThumbnail(w,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
  print "Reading",n
  F = FITS(n)
  i1 = F.data()
  F.close()
  print "Writing",m
  if FileCheck(m): G = FITS(m,readonly=0)
  else: G = FITS(m,create=1,template=n)
  w = inverse_flwt2d( frmall(i1m,nn,nt),nn,nt).astype(float32)
  m1,m2 = MASKD[E.pset][chip], BADPD[E.pset][chip]
  if m1 == None: m1 = ones(i1.shape,float32)
  if m2 == None: m2 = ones(i1.shape,float32)
  mask = evaluate("m1*m2*(i1!=0)")
#  w = evaluate("w*mask").astype(float32)
  G.putdata(w)
  G.close()
  MakeThumbnail(m,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
  MakeThumbnail(m,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
  i1 = evaluate("i1*mask")
  w = evaluate("w*mask")
#  mim = FITS(origdir+"maskc%d.fits" % (chip))
#  mask = mim.data().astype(float32)
#  mim.close()
#  r0 = VTKMultiply(VTKSubtract(k1,w),mask)
#  r = VTKMultiply(VTKSubtract(i1,w),mask)
  r0 = evaluate("(k1-w)*mask")
  r = evaluate("(i1-w)*mask")
  if p > 1:
     print "Reading",e
     F = FITS(e)
     p1 = F.data()
     F.close()
     print "Reading",eo
     F = FITS(eo)
     po = F.data()
     F.close()
     print "Reading",e3
     F = FITS(e3)
     p3 = F.data()
     F.close()
#     r = VTKMultiply(r, equal(p1,0).astype(float32))
     r = evaluate("r*(p1==0)*(p3==0)").astype(float32)
#  s = evaluate("abs(r)")
#  s = VTKMedianSmooth(s,32,32,numret=1)
#  s = evaluate("1.49*s")
#  ms = median(transpose(divz(r,s)))
##  msr = 1.49*median(abs(ms))
#  msn = ms[::,NewAxis]
#  r = evaluate("r*(msn>-10)")
##  ms = median(transpose(divz(r,s)))
##  msr = 1.49*median(abs(ms))
##  r = r*greater(ms[::,NewAxis],-10)
  r0 = compress(r.ravel(),r0.ravel())
  anoise = 1.49*median(abs(r0))
  r = evaluate("r*(r>(-5*anoise))")

  if E.fclass == "newfirm":
    gain,rn = 8.0,25.0
  elif E.fclass == "fourstar":
    if E.gain[0] == "F": gain,rn = 2.5,20.0
    elif E.gain[0] == "L": gain,rn = 1.3,15.0
    gain = gain*len(E.loop)
    rn = rn/sqrt(len(E.loop))

  expnoise = sqrt(gain*Wms+rn*rn)/gain

#  if Wms < 5*expnoise and not os.path.exists( E.scratch("").replace("obj","sky")):
#     bgfix = lambda a: (a.any() and getpct(a,15) or 0.0)
#     bguse = evaluate("(r!=0) & (p1==0) & (po ==0)")
#     mry = asarray([bgfix(compress(bguse[j],r[j])) for j in range(r.shape[0])])[::,NewAxis]
#     r2 = evaluate("where(r!=0,r-mry,0)")
#     tp1 = transpose(p1)
#     tpo = transpose(po)
#     tr = transpose(r2)
#     tbguse = evaluate("(tr!=0) & (tp1==0) & (tpo==0)")
#     mrx = transpose(asarray([bgfix(compress(tbguse[j],tr[j])) for j in range(r.shape[1])]))[NewAxis,::]
#     r = evaluate("where(r2!=0,r2-mrx,0)")
#     bguse = evaluate("(r!=0) & (p1==0) & (po ==0)")
#     rz = median(compress(bguse.ravel(),r.ravel()))
#     r = evaluate("where(r!=0,r-rz,0)")

  f2 = sum(1.*not_equal(r.ravel(),0)*equal(po.ravel(),0))/(po.shape[0]*po.shape[1])
  if f2 > 0.4:
     if chip in FLATD[E.pset] and FLATD[E.pset][chip] != None:
        Df = FLATD[E.pset][chip]
     else:
        Df = ones(r.shape)
     for mit in [0,1]:
         D2 = r*Df
         if mit == 0:
            M2 = not_equal(D2,0)*equal(po,0)
         else:
            M2 = not_equal(D2,0)*equal(po,0)
            Dt = r - D2y - D2x
            cDt = compress(M2.ravel()*Dt.ravel(),Dt.ravel())
            sDt = 1.49*median(abs(cDt.ravel()))
            M2 = M2*between(Dt,-3*sDt,3*sDt)
         D2y = divz(EasyPatch(array([EasyStat(x,m) for x,m in zip(D2,M2)]))[::,NewAxis],Df)*not_equal(r,0)
         D2 = (r-D2y)*Df
         D2x = divz(EasyPatch(array([EasyStat(x,m) for x,m in zip(transpose(D2),transpose(M2))]))[NewAxis,::],Df)*not_equal(r,0)
     r = r - D2y - D2x

  print "Writing",o
  if FileCheck(o): G = FITS(o,readonly=0)
  else: G = FITS(o,create=1,template=n)
  G.modkey("anoise",anoise)
  G.putdata(r)
  G.close()
  MakeThumbnail(o,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
  MakeThumbnail(o,mag=16,pct=40,s1=-10,s2=10,inv=1,q=85)
  Sextractor(o,oc,scale=E.scale,thresh=5,saturate=50e3)

def FinalizeFlats(targ,nfilt,chips,UseExposures,first=1,second=0,makeflat=None):
   [ReadCalibs(UseExposures[0],chip,nfilt=nfilt,flat=True,first=first,second=second) for chip in chips]
#   os.chdir("..")
   if first: stage = 1
   elif second: stage = 2
   else: stage = 0
   if "Dark" in nfilt:
      obj = UseExposures[0].objname
      exptime = sum([E.exptime for E in UseExposures])
      for chip in chips:
         F = FITS("Darks/%s/sky%d/Darkc%d.fits" % (targ,stage,chip))
         i = F.data()
         F.close()
         i = where(between(i,-1e24,1e24),i,0.0)
#         b,m,s2 = ModalSmooth(i,not_equal(i,0),64,3,cut=0)
#         mask = between(m,-20*s2,20*s2)
#         r0 = getpct(m,50)
#         r2 = getpct(s2,50)
         r0 = getpct(i.ravel(),5)
         m = getpct(i.ravel(),50)
         r1 = getpct(i.ravel(),95)
         nega = less(i,0).astype(Float32)
#         nega = VTKIslandRemoval(nega,1,0,100,1)
         mask = between(i,m-20*(m-r0),m+20*(r1-m)).astype(float32)
#         mask = logical_not(nega)*mask
#         qdump("/tmp/i%d.fits"%(chip),i)
#         qdump("/tmp/mask%d.fits"%(chip),mask*1.)
         back,sub,noise = ModalSmooth(i,mask,64,3,pct=10,cut=0.)
#         qdump("/tmp/back%d.fits"%(chip),back)
#         qdump("/tmp/sub%d.fits"%(chip),sub)
#         qdump("/tmp/noise%d.fits"%(chip),noise)
         bad = greater(abs(sub),20.0).astype(float32)
#         i = where(bad,0.0,i)
#         for s in arange(5):
#             a = pow(2,s)
#             bad = greater(abs(sub),10.0/sqrt(a)).astype(float32)
#             bad = VTKIslandRemoval(bad,1,0,a,1)
#             qdump("/tmp/bad%d_%02d.fits"%(chip,s),bad)
#         i = where(mask,i,0.0)
##         Bi,u1 = MakeWaves(i,sig=3,mask=mask,nowave=1)
##         m = Bi*u1
##         d = i - divz(VTKMeanSmooth(i*m,256,256,1), VTKMeanSmooth(m,256,256,1))
##         r0 = getpct(d.ravel(),5)
##         m = getpct(d.ravel(),50)
##         r1 = getpct(d.ravel(),95)
##         mask = between(i,m-20*(m-r0),m+20*(r1-m)).astype(float32)
#         i = i*mask
#         n,ng = len(i.ravel()),len(compress(i.ravel(),i.ravel()))
#         print chip,r0,r2,1.*ng/n
         name = "Darks/%s/%sc%d.fits" % (targ,obj,chip)
         print name,exptime
         F = FITS(name,create=1,template="Darks/%s/sky%d/Darkc%d.fits" % (targ,stage,chip))
         F.modkey("exptime",1.0)
         F.modkey("mjd", UseExposures[0].mastermjd)
         F.putdata(divz(i,exptime))
         F.close()
         MakeThumbnail(name,mag=1,pct=50,z1=0,z2=0,s1=-10,s2=10,inv=1)
         MakeThumbnail(name,mag=8,pct=50,z1=0,z2=0,s1=-10,s2=10,inv=1)
   if targ.split("_")[0][-1] != "B" and "Dark" not in nfilt:
      if ("flat" not in targ.lower() and "dome" not in targ.lower()): targ,tflat = "flat_"+targ,1
      else: tflat = 0
      print "Finalizing flats..."
      ii = []
      mi = []
      fdir = "Flats"
      for chip in chips:
         F = FITS("%s/%s/sky%d/Flat%sc%d.fits" % (fdir,targ,stage,nfilt,chip))
         i = F.data()
         F.close()
         if targ.split("_")[0][-1] == "A":
           F = FITS("%s/%sB_%s/sky%d/Flat%sc%d.fits" % (fdir,targ.split("_")[0][:-1],targ.split("_")[-1],stage,nfilt,chip))
           i0 = F.data()
           F.close()
           mi0x = median(i0)
           si0x = 1.49*median(abs(i0-mi0x[NewAxis,::]))
           si0x = si0x - VTKMedian(si0x,101,1,1)
           ri0x = 1.49*median(abs(si0x))
           bi0x = less(si0x,10*ri0x).astype(float32)
           mi0y = median(transpose(i0))
           si0y = 1.49*median(abs(transpose(i0)-mi0y[NewAxis,::]))
           si0y = si0y - VTKMedian(si0y,101,1,1)
           ri0y = 1.49*median(abs(si0y))
           bi0y = less(si0y,10*ri0y).astype(float32)
           okay = bi0x[NewAxis,::]*bi0y[::,NewAxis]
           i = where(okay,i - i0,0.0)
#         dp = self.UseExposures[0].scratch("pupil0")
#         p = "%s/pupil%sc%d.fits" % (dp,self.filter,chip)
#         if FileCheck(p):
#            F = FITS(p)
#            pd = F.data()
#            F.close()
#            i = where(i,i-pd,0.0)
         if AREAD[UseExposures[0].pset][chip] != None:
            i = divz(i,AREAD[UseExposures[0].pset][chip])
         m = median(i.ravel())
         ii.append(i)
         mi.append(m)
      norm = mean(mi)
      print "Normalizing with %.3f" % (norm)
      for i,chip in zip(ii,chips):
         i = divz(i,norm).astype(float32)
         fname = fdir+"/"+targ+"/Flat"+nfilt+"c%d.fits" % (chip)
         F = FITS(fdir+"/"+targ+"/sky%d/Flat%sc%d.fits" % (stage,nfilt,chip))
         nc = F["ncombine"]
         F.close()
#         if UseExposures[0].fclass == "fourstar": simo = 20.0
#         elif UseExposures[0].fclass == "newfirm": simo = 5.0
         if UseExposures[0].fclass == "fourstar":
            bcut = 0.5
            back = median(compress(i.ravel(),i.ravel()))
            mask = 1
         elif UseExposures[0].fclass == "newfirm":
            back,sub,noise = ModalSmooth(i,ones(i.shape),64,5,pct=30,cut=0.)
            mask = less(abs(sub),5*noise).astype(float32)
            bcut = 0.2
            back,sub,noise = ModalSmooth(i,ones(i.shape),256,5,pct=10,cut=0.)
         mask = mask*greater(i,bcut*back).astype(float32)
#         mask2 = VTKIslandRemoval(less(i,0.9*back).astype(float32),1.0,0.0,100,numret=1)
#         mask = logical_and(mask,logical_not(mask2)).astype(float32)
         back,sub,noise = ModalSmooth(i,mask,256,3,pct=10,cut=0.)
         if UseExposures[0].fclass == "fourstar": bcut = 0.9
         elif UseExposures[0].fclass == "newfirm": bcut = 0.5
         mask2 = VTKIslandRemoval(less(i,bcut*back).astype(float32),1.0,0.0,100,numret=1)
         mask = logical_and(mask,logical_not(mask2)).astype(float32)
         f90 = 100.*sum(greater(i,0.90*back).ravel())/i.shape[0]/i.shape[1]
         f95 = 100.*sum(greater(i,0.95*back).ravel())/i.shape[0]/i.shape[1]
         f97 = 100.*sum(greater(i,0.97*back).ravel())/i.shape[0]/i.shape[1]
         f98 = 100.*sum(greater(i,0.98*back).ravel())/i.shape[0]/i.shape[1]
         F = FITS(fname,create=1,template=fdir+"/"+targ+"/sky%d/Flat%sc%d.fits" % (stage,nfilt,chip))
         F.modkey("mjd", UseExposures[0].mastermjd)
         F.modkey("f90",f90)
         F.modkey("f95",f95)
         F.modkey("f97",f97)
         F.modkey("f98",f98)
         F.putdata(i)
         F.close()
         if targ.split("_")[0][-1] != "B" and (nc < 3 or f90 < 75.0):
            if makeflat:
               open("%s/%s.err" % (fdir,targ),"w").close()
            else:
               raise ValueError("Problem with flatfield, %s, f90=%f!"%(fname,f90))
#         qdump("/tmp/maskc%d.fits"%(chip),mask)
#         qdump("/tmp/backc%d.fits"%(chip),back)
#         qdump("/tmp/subc%d.fits"%(chip),sub)
#         qdump("/tmp/noisec%d.fits"%(chip),noise)
#         mask = greater(i,0.2*back)*less(abs(sub),20.0*noise).astype(float32)
#         im = VTKMedianSmooth(i,128,2128,numret=1)
##         qdump("%sim0c%d.fits"%(nfilt,chip),i)
##         qdump("%sim1c%d.fits"%(nfilt,chip),im)
##         qdump("%sim2c%d.fits"%(nfilt,chip),divz(i,im))
#         mask = 1.*between(divz(i,im),0.5,1.5)
#         img = divz(VTKMedianSmooth(mask*i,128,128,1), VTKMeanSmooth(mask,128,128,1))
#         imr = i-img
#         ims = 1.49*divz(VTKMedianSmooth(mask*VTKAbs(imr),128,128,1), VTKMeanSmooth(mask,128,128,1))
#         imo = 1*greater(abs(divz(imr,ims)),simo)
#         iml = VTKConvolve(1.*less(i/im,0.2),k=3,numret=1)
#         imb = 1*logical_and(imo,logical_not(iml))
#         imbx = add.reduce(imb,0)
#         imby = add.reduce(imb,1)
#         imbxm = median(imbx)
#         imbxr = 1.49*median(abs(imbx-imbxm))
#         imbym = median(imby)
#         imbyr = 1.49*median(abs(imby-imbym))
#         imu = 1.*logical_not(imo)
#         print chip,imbxm,imbxr,
#         print imbym,imbyr
#         if UseExposures[0].fclass == "newfirm":
#             imu = imu * less_equal(imbx,imbxm+4*simo*imbxr)[NewAxis,::]
#             imu = imu * less_equal(imby,imbym+4*simo*imbyr)[::,NewAxis]
##         qdump(targ+"/imbx%d.fits"%(chip),imbx)
##         qdump(targ+"/imby%d.fits"%(chip),imby)
##         qdump(targ+"/imb%d.fits"%(chip),imb)
##         qdump(targ+"/ims%d.fits"%(chip),ims)
##         qdump(targ+"/imd%d.fits"%(chip),divz(imr,ims))
##         qdump(targ+"/imm%d.fits"%(chip),imu)
#         mask = imu*greater(i,0.2*median(compress(imu.ravel(),i.ravel())))
#         if chip in DARKD[UseExposures[0].pset]:
#            dark = DARKD[UseExposures[0].pset][chip]
#            if (UseExposures[0].noctim, UseExposures[0].ncoadd) in dark:
#               dark = DARKD[UseExposures[0].pset][chip][(UseExposures[0].noctim, UseExposures[0].ncoadd)]
#               print "Using dark to help make the mask...", (UseExposures[0].noctim, UseExposures[0].ncoadd)
#               mask = mask*not_equal(dark,0)
         mout = os.path.dirname(fname)+"/mask"+nfilt+"c%d.fits" % (chip)
         G = FITS(mout,create=1,template=fdir+"/"+targ+"/sky%d/Flat%sc%d.fits" % (stage,nfilt,chip))
         G.modkey("bitpix",-32)
         G.modkey("mjd", UseExposures[0].mastermjd)
         G.modkey("f90",f90)
         G.modkey("f95",f95)
         G.modkey("f97",f97)
         G.modkey("f98",f98)
         G.flush()
         G.close()
         G = FITS(mout,readonly=0)
         G.putdata(mask)
         G.flush()
         G.close()
         MakeThumbnail(fname,mag=1,pct=50,z1=0,z2=0,s1=-10,s2=10,inv=1)
         MakeThumbnail(fname,mag=8,pct=50,z1=0,z2=0,s1=-10,s2=10,inv=1)
         MakeThumbnail(mout,mag=1,pct=50,z1=0,z2=1,inv=1)
         MakeThumbnail(mout,mag=8,pct=50,z1=0,z2=1,inv=1)

def GetUsingTimeStamps(m,fs):
    mjds = []
    for f in fs:
        F = FITS(f)
        t = F["mjd"]
        if t == "N/A":
           t = F["mjd-obs"]
        F.close()
        mjds.append(float(t))
#       d = os.path.basename(os.path.dirname(f))
#       t =  d.split("_")[-1]
#       if t[0] in "FL": t=t[1:]
#       print m,f,d,mjds[-1]
    mjds = asarray(mjds)
    return fs[argmin(abs(m-mjds))]

def ClearCalibs(pset):
    print "ClearCalibs for",pset
    for D in [BADPD,BADPN,MASKD,MASKN,FLATD,FLATN,PUPLD,PUPLN,AREAD,AREAN,DARKD,DARKN,SKYFD,SKYFN]:
        for k in D[pset].keys():
            del D[pset][k]

def ReadCalibs(E,chip,nfilt="J",flat=0,first=1,second=0):
    cwd = os.getcwd()

    if hasattr(E,"mastermjd"): usemjd = E.mastermjd
    else: usemjd = E.mjd

    if E.fclass == "fourstar":  gm = E.gain[0]
    else: ngm,gm = "",""

    badpf = None
    badpfs = glob("Masks/mask_*/maskc%d.fits" % (chip))
    if badpfs:
       badpf = GetUsingTimeStamps(usemjd,badpfs)

    if not flat and badpf:
       if chip not in BADPD[E.pset] or BADPN[E.pset][chip] != os.path.realpath(badpf):
          print "Reading",badpf
          F = FITS(badpf)
          BADPD[E.pset][chip] = logical_not(F.data())
          BADPN[E.pset][chip] = os.path.realpath(badpf)
          F.close()
    else:
       BADPD[E.pset][chip] = None
       BADPN[E.pset][chip] = "None"

    maskf = None
    if E.fclass == "fourstar":
       maskfs = glob("Flats/flat_obj%s_%s*/mask%sc%d.fits" % (nfilt,gm,nfilt,chip))
    elif E.fclass == "newfirm":
       maskfs = glob("Flats/flat%sA_*/mask%sc%d.fits" % (nfilt,nfilt,chip))
    if not maskfs and E.fclass == "fourstar":
       if gm == "L": ngm = "F"
       elif gm == "F": ngm = "L"
       if E.fclass == "fourstar":
          maskfs = glob("Flats/flat_obj%s_%s*/mask%sc%d.fits" % (nfilt,ngm,nfilt,chip))
    maskfs = [maskf for maskf in maskfs if not os.path.exists(os.path.dirname(maskf)+".err")]
    if maskfs:
       maskf = GetUsingTimeStamps(usemjd,maskfs)

    if not flat and maskf and os.path.exists(maskf):
       if chip not in MASKD[E.pset] or MASKN[E.pset][chip] != os.path.realpath(maskf):
          print "Reading",maskf
          F = FITS(maskf)
          MASKD[E.pset][chip] = F.data()
          MASKN[E.pset][chip] = os.path.realpath(maskf)
          F.close()
    else:
       MASKD[E.pset][chip] = None
       MASKN[E.pset][chip] = "None"

    if nfilt != "Dark":
       if chip not in DARKD[E.pset]:
          DARKD[E.pset][chip] = {}
          DARKN[E.pset][chip] = {}
       if not flat or (E.fclass == "fourstar"):
          darks = glob("Darks/dark*_%s*/dark*c%d.fits" % (gm,chip))
          if darks:
             darkc = [os.path.basename(dark).split("_")[0].replace("dark","") for dark in darks]
             darkt = array([float(dark.split("x")[0]) for dark in darkc])
             darkn = array([int(dark.split("x")[1].split("c")[0]) for dark in darkc])
#             print darkc, "%fx%d" % (E.noctim,E.ncoadd)
#             exit()
             dt = abs(darkt-E.noctim)
             if E.fclass == "fourstar":
                mdnt = 0
                dnt = dt**2
                duse = equal(dnt,0)
                if duse.any():
                   juse = nonzero(duse)
                   darksj = [darks[j] for j in juse]
                   darksf = GetUsingTimeStamps(usemjd,darksj)
                   k = darks.index(darksf)
#                   k = juse[argmax(compress(duse,darkn))]
                   duse = True
                else:
                   duse = False
             else:
                dn = abs(darkn-E.ncoadd)
                mdnt = 0
                dnt = (dt**2+dn**2)
                duse = min(dnt) == mdnt
                k = argmin(dt**2+dn**2)

             if duse:
                darkf = darks[k]
                if os.path.exists(darkf):
                   if DARKD[E.pset][chip].get((E.noctim,E.ncoadd),None) == None or \
                           DARKN[E.pset][chip].get((E.noctim,E.ncoadd),None) != os.path.realpath(darkf):
                      print "Reading",darkf
                      F = FITS(darkf)
                      dd = F.data()
                      DARKD[E.pset][chip][E.noctim,E.ncoadd] = where(between(dd,-1e24,1e24), dd, 0)
                      DARKN[E.pset][chip][E.noctim,E.ncoadd] = os.path.realpath(darkf)
                      F.close()
             else:
                DARKN[E.pset][chip][E.noctim,E.ncoadd] = "None"

    flatf = None
    flatfs = []
    ugm = gm
#    ugm = "F"
    if not flat:
       if E.fclass == "fourstar":
          flatfs = glob("Flats/flat_obj%s_%s*/pupil%sc%d.fits" % (nfilt,ugm,nfilt,chip))
#          flatfs = []
       elif E.fclass == "newfirm":
          flatfs = glob("Flats/flat_obj%s_%s*/pupil%sc%d.fits" % (nfilt,ugm,nfilt,chip))
          if not flatfs:
             flatfs = glob("Flats/flat%sA_*/pupil%sc%d.fits" % (nfilt,nfilt,chip))
       if flatfs:
          flatfs = [flatf for flatf in flatfs if not os.path.exists(os.path.dirname(flatf)+".err")]
          flatfs = ["%s/Flat%sc%d.fits" % (os.path.dirname(flatf),nfilt,chip) for flatf in flatfs]
       if not flatfs and E.fclass == "fourstar":
          flatfs = glob("Flats/flat_obj%s_%s*/Flat%sc%d.fits" % (nfilt,ugm,nfilt,chip))
       elif not flatfs and E.fclass == "newfirm":
          flatfs = glob("Flats/flat_obj%s_%s*/Flat%sc%d.fits" % (nfilt,ugm,nfilt,chip))
          if not flatfs:
             flatfs = glob("Flats/flat%sA_*/Flat%sc%d.fits" % (nfilt,nfilt,chip))
       flatfs = [flatf for flatf in flatfs if not os.path.exists(os.path.dirname(flatf)+".err")]
    ngm = ugm
    if not flatfs and E.fclass == "fourstar":
       if ngm == "L": ngm = "F"
       elif ngm == "F": ngm = "L"
       flatfs = glob("Flats/flat_obj%s_%s*/Flat%sc%d.fits" % (nfilt,ngm,nfilt,chip))
       flatfs = [flatf for flatf in flatfs if not os.path.exists(os.path.dirname(flatf)+".err")]
    if flatfs:
       flatf = GetUsingTimeStamps(usemjd,flatfs)
    if (not flat and flatf and os.path.exists(flatf)) and (first or second):
       if chip not in FLATD[E.pset] or FLATN[E.pset][chip] != os.path.realpath(flatf):
          print "Reading",flatf
          F = FITS(flatf)
          Fd = F.data()
          if E.fclass == "fourstar" and gm != ngm:
             Fdm = median(compress(Fd.ravel(),Fd.ravel()))
             if gm == "F":
                gfix = (FSFullWellGains[chip-1] / FSLowNoiseGains[chip-1]) * (mean(FSLowNoiseGains) / mean(FSFullWellGains))
                gfix1 = FSLowNoiseGains[chip-1] / mean(FSLowNoiseGains)
                gfix2 = FSFullWellGains[chip-1] / mean(FSFullWellGains)
             elif gm == "L":                                             
                gfix = (FSLowNoiseGains[chip-1] / FSFullWellGains[chip-1]) * (mean(FSFullWellGains) / mean(FSLowNoiseGains))
                gfix1 = FSFullWellGains[chip-1] / mean(FSFullWellGains)
                gfix2 = FSLowNoiseGains[chip-1] / mean(FSLowNoiseGains)
             Fd = gfix * (Fd-Fdm/gfix1) + gfix2
          FLATD[E.pset][chip] = where(between(Fd,-1e24,1e24), Fd, 0)
          FLATN[E.pset][chip] = os.path.realpath(flatf)
          F.close()
          if 1 or E.fclass != "fourstar":
             pupil = "%s/pupil%sc%d.fits" % (os.path.realpath(os.path.dirname(flatf)),nfilt,chip)
             if FileCheck(pupil):
                F = FITS(pupil)
                Fd = F.data()
                F.close()
                PUPLD[E.pset][chip] = where(between(Fd,-1e24,1e24), Fd, 0)
                PUPLN[E.pset][chip] = os.path.realpath(pupil)
          illumf = E.scratch("Flats/Illum%sc%d.fits" % (nfilt,chip))
          if os.path.exists(illumf):
             print "Reading",illumf
             F = FITS(illumf)
             FLATD[E.pset][chip] = FLATD[E.pset][chip] * F.data()
             F.close()

    else:
       FLATD[E.pset][chip] = None
       FLATN[E.pset][chip] = "None"


    areaf = None
    ugm = gm
#    ugm = "F"
    areafs = glob("Areas/areas*/*c%darea.fits" % (chip))
    ngm = ugm
    print areafs
    if areafs:
       areaf = GetUsingTimeStamps(usemjd,areafs)
    print areaf
    print os.path.exists(areaf)
    if not flat and areaf and os.path.exists(areaf):
       if chip not in AREAD[E.pset] or AREAN[E.pset][chip] != os.path.realpath(areaf):
          print "Reading",areaf
          F = FITS(areaf)
          Fd = F.data()
          F.close()
          AREAD[E.pset][chip] = where(between(Fd,-1e24,1e24), Fd, 0)
          AREAN[E.pset][chip] = os.path.realpath(areaf)

    else:
       print "Setting area map to None."
       AREAD[E.pset][chip] = None
       AREAN[E.pset][chip] = "None"

class FourCLiftRun:
   def __init__(self,ddir,nfilt,targ,chips,fclass,NP=0,HUB=None,ssh=0,\
                first=0,second=0,verb=0,inter=0,\
                mag=5,histo=0,msh=0,nume=3,nmax=60,nf=10,nn=4,nt=4,check=0,\
                flat=0,lift=0,freeze=0,calib=0,show=0,noshift=0,\
                start=0,end=0,sigclip=5.0,yskip=16,skyskip=32,st=0.05):
        twisted_import("FourCLiftProcess","*")
        self.fclass = fclass
        self.paused = True
        self.runner = None
        self.manhole = None
        self.tstart = 0
        self.tfinish = -99
        self.pset = -1
        self.hport = 0
        self.success = 0
        self.ongoing = False
        self.progress = 0
        self.current = 0
        self.NP=NP
        self.HUB=HUB
        self.ssh=ssh
        self.basedir = os.getcwd()
        self.nfilt = nfilt
        self.targ = targ
        zdir = ddir.replace("/"," ").strip().split(" ")[-1]
        self.zdir = zdir
        self.zodb = "zodb/%sinfo.fs" % (zdir)
        if not os.path.exists(os.path.dirname(self.zodb)):
           print "Making",os.path.dirname(self.zodb)
           os.mkdir(os.path.dirname(self.zodb))
        self.chips=chips
        self.first=first
        self.second=second
        self.verb=verb
        self.inter=inter
        self.mag=mag
        self.histo=histo
        self.nume = nume
        self.msh=msh
        self.nmax=nmax
        self.nf=nf
        self.nn=nn
        self.nt=nt
        self.check=check
        self.flat=flat
        self.lift=lift
        self.makeflat=None
        self.makepupil=None
        self.freeze=freeze
        self.calib=calib
        self.newstacks=False
        self.show=show
        self.noshift=noshift
        self.start=start
        self.end=end
        self.sigclip=sigclip
        self.yskip=yskip
        self.skyskip=skyskip
        self.st=st
        self.dark = False
        self.donefirst = False
        self.donesecond = False
        self.errfirst = False
        self.errsecond = False
        self.currenttasks = {}
        if "flat" in self.targ:
           self.flat = True
           self.sigclip = 2.5
        if "Dark" in self.nfilt:
           self.flat = True
           self.dark = True
           self.sigclip = 2.5
        if self.first:
           self.stage = "1"
        if self.second:
           self.stage = "2"
        if "dark" in self.targ:
           self.scratchspace = os.environ.get("SCRATCHSPACE",os.getcwd()+"/Darks/"+self.targ)
        elif "flat" in self.targ:
           self.scratchspace = os.environ.get("SCRATCHSPACE",os.getcwd()+"/Flats/"+self.targ)
        else:
           self.scratchspace = os.environ.get("SCRATCHSPACE",os.getcwd()+"/Science/"+self.zdir+"/"+self.targ)

   def ErrorFile(self):
      return self.scratchspace+".err"

   def Already(self,verb=0,first=-1,second=-1,targ=""):
#       cwd = os.getcwd()
#       os.chdir(self.basedir)
       if not targ: targ = self.targ
       if verb:
          print "Already?",self.targ
       retval = 0

       if first: stage = "1"
       elif second: stage = "2"
       if self.errfirst and not os.path.exists(self.ErrorFile()):
          self.errfirst = False
          self.donefirst = False
          self.FirstPass()
       if self.errsecond and not os.path.exists(self.ErrorFile()):
          self.errsecond = False
          self.donesecond = False
          self.SecondPass()
#       if os.path.exists("bad_%s" % (targ)):
#          if first: self.errfirst = True
#          elif second: self.errsecond = True
#          retval = True
       if os.path.exists(self.ErrorFile()):
          if first: self.errfirst = True
          elif second: self.errsecond = True
          retval = True
#       if (first and self.donefirst) or (second and self.donesecond): retval = True
#       if first and self.targ == "obj143824+085400_J1_F55640_3212_tmp0519":
#          print "Aready?", self.errfirst, os.path.exists(self.ErrorFile()), self.donefirst, self.donesecond

       if not retval:
          if self.flat:
             if "dark" in targ:
                t = [c for c in self.chips if \
                   FileCheck(self.basedir+"/Darks/"+targ+"/"+targ+"c%d.fits" % (c)) \
                   ] == self.chips
             elif "flat%sB" % (self.nfilt) in targ:
                t = [c for c in self.chips if \
                   FileCheck(self.basedir+"/Flats/"+targ+"/sky1/Flat"+self.nfilt+"c%d.fits" % (c)) \
                   ] == self.chips
             elif "flat%sA" % (self.nfilt) in targ or  "flat_obj%s" % (self.nfilt) in targ:
                t = [c for c in self.chips if \
                   (FileCheck(self.basedir+"/Flats/"+targ+"/mask"+self.nfilt+"c%d.fits" % (c)) and \
                   FileCheck(self.basedir+"/Flats/"+targ+"/Flat"+self.nfilt+"c%d.fits" % (c))) \
                   ] == self.chips
             elif "sky" in targ:
                t = [c for c in self.chips if \
                   FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Stack%sc%dmag01.jpg" % (stage,c)) \
                   ] == self.chips
             else:
                t = [c for c in self.chips if \
                   (FileCheck(self.basedir+"/Flats/"+"flat_"+targ+"/mask"+self.nfilt+"c%d.fits" % (c)) and \
                   FileCheck(self.basedir+"/Flats/"+"flat_"+targ+"/Flat"+self.nfilt+"c%d.fits" % (c))) \
                   ] == self.chips
          else:
             if first:
                if "_tmp" in targ:
                   nframes = len([g for g in glob(self.basedir+"/Science/"+self.zdir+"/"+targ+"/mode1/*.fits") if not os.path.exists(g+".bad")])
                   ncats = len(glob(self.basedir+"/Science/"+self.zdir+"/"+targ+"/cat1/*.cat"))
                   t = ncats and (ncats >= nframes) and FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Shifts1_1.png")
#                   nstacks = [c for c in self.chips if FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Stack"+stage+"c%d.cat"%(c))]
#                   t = (nstacks == self.chips)
                else:
#                   if len(glob(self.basedir+"/Science/"+self.zdir+"/"+targ+"_tmp*")):
#                   ssub = 5
#                   nsub = int(len(list(Set([i.jno for i in self.groups])))/ssub)
                   nsub = getattr(self.groups[0],"subgroups",0)
                   if 0 and nsub:
                       bt = map(os.path.basename,glob(self.basedir+"/Science/"+self.zdir+"/"+targ+"_tmp*"))
                       abt = [bt1 for bt1 in bt if self.Already(first=first,second=second,targ=bt1)]
                       t = nsub == len(bt) and len(abt) == len(bt)
                       nstacks = [c for c in self.chips if FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Stack"+stage+"c%d.cat"%(c))]
                       t = FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Mosaic"+stage+".png")
                   else:
                       nstacks = [c for c in self.chips if FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Stack"+stage+"c%d.cat"%(c))]
                       t = (nstacks == self.chips)
                       t = FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Mosaic"+stage+".png")
                       if self.makeflat and t and self.makepupil:
                          ftarg = self.makeflat
                          tm = len([c for c in self.chips if FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/mask%sc%dmag08.jpg"%(self.nfilt,c))]) == len(self.chips)
                          tp = len([c for c in self.chips if FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Flat%sc%dmag08.jpg"%(self.nfilt,c))]) == len(self.chips)
                          t = tm and tp
             elif second:
                if len(glob(self.basedir+"/Science/"+self.zdir+"/"+targ+"_tmp*")):
                   t = FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Mosaic"+stage+".png")
                else:
                   nstacks = [c for c in self.chips if FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Stack"+stage+"c%d.cat"%(c))]
                   t = (nstacks == self.chips) \
                        and FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Mosaic"+stage+".png")
          if t and first: self.donefirst = True
          elif t and second: self.donesecond = True
          retval = t
#          if self.makeflat:
#             raw_input("WAIT!")
       if retval:
          if (first and self.first) or (second and self.second):
             self.current = 100
             self.success = 1
       return retval

   def Ready(self):
#       os.chdir(self.basedir)
       if self.flat:  targ = "flat_"+self.targ
       else: targ = self.targ
       if self.second and not FileCheck(self.basedir+"/Science/"+self.zdir+"/"+targ+"/Mosaic1.cat"):
          print "Not ready yet!",os.getcwd()
          raise IOError("File not found: "+self.basedir+"/Science/"+self.zdir+"/"+targ+"/Mosaic1.cat")

   @defer.inlineCallbacks
   def Execute(self,ttasks,items,serial=False):
       if serial:
           if isinstance(ttasks,ListType):
              for ttask in ttasks:
                 ttasks1 = [ttask]
                 d = defer.Deferred()
                 d.addCallback(lambda x: self.RealExecute(ttasks1,items))
                 reactor.callLater(0.1,d.callback,True)
####              bd = threads.deferToThread(d.callback,True)
                 print "output from realexecute"
                 yield d
           else:
              d = defer.Deferred()
              d.addCallback(lambda x: self.RealExecute(ttasks,items,serial=True))
              reactor.callLater(0.1,d.callback,True)
              yield d
       else:
           d = defer.Deferred()
           d.addCallback(lambda x: self.RealExecute(ttasks,items))
           reactor.callLater(0.1,d.callback,True)
#           bd = threads.deferToThread(d.callback,True)
           yield d

   @defer.inlineCallbacks
   def RealExecute(self,ttasks,items,serial=False):
       paus = 0
       while self.paused:
           paus += 1
           if paus and not (paus % 100):
              print "Waiting to be unpaused"
           time.sleep(1)
           yield
#       if self.HUB and ("," in self.HUB or int(self.HUB.split(":")[-1])<1024) and isinstance(ttasks,ListType):
#          machines = [(":" not in machine and [machine,"1"] or machine.split(":")) for machine in self.HUB.split(",")]
#          machines = [machine[0] for machine in machines for j in range(int(machine[1]))]
#          print "Using nodes"
#          print machines
#          [item.setFromModules(["FourCLiftProcess"]) for item in ttasks]
#          nin = len(ttasks)
#          namespace = globals()
#          self.dispatch = TwistedHub(ttasks,quiet=0,verb=0,clean=0,wait=1,norun=0,stayalive=1,user=getpass.getuser(),\
#                listen=0,sshport=self.ssh+self.second,modules=[],fmodules=[],machines=machines,nice=10,\
#                sleeptime=0.001,namespace=namespace,auth=0)
#          nout = len([t for t in self.dispatch.completed if t.result[5]])
#          fails = [t.result[3] for t in self.dispatch.completed if not t.result[5]]
#          assert fails == [], fails[0]
       if isinstance(self.HUB,TwistedHub) and isinstance(ttasks,ListType):
          ctasks = []
          for otask in ttasks:
              if hasattr(otask,"all") and otask.all:
                  for h in self.HUB.TASKS:
                     ctask = CopyTask()
                     [setattr(ctask,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
                     ctask.station = h.conn.uuid
                     ctasks.append(ctask)
          if ctasks: ttasks = ctasks
          [item.setFromModules(["FourCLiftProcess"]) for item in ttasks]
          [item.setPath(os.getcwd()) for item in ttasks]
          nin = len(ttasks)
          self.currenttasks = {}
          [self.currenttasks.setdefault(t) for t in ttasks]
          self.HUB.tasks.extend(ttasks)
          print "Now have to wait for %d tasks." % (len(self.HUB.tasks))
          twait = 0.0
          while len([t for t in ttasks if hasattr(t,"done") and t.done and hasattr(t,"result")]) < nin:
             time.sleep(1.0)
             twait += 1.0
             if twait and not (twait % 10):
                results = [t.result for t in ttasks if hasattr(t,"result")]
                fails = [t.result[3] for t in ttasks if hasattr(t,"result") and not t.result[5]]
                assert fails == [], fails[0]
                print "Wait time=",twait, len(ttasks), len(results)
          nout = len([t for t in ttasks if hasattr(t,"result") and t.result[5]])
          fails = [t.result[3] for t in ttasks if hasattr(t,"result") and not t.result[5]]
          assert fails == [], fails[0]
          [self.currenttasks.pop(t) for t in self.currenttasks.keys()]

##          self.HUB.WatchSpawn()
#          print "Now have to wait for %d tasks out of %d+%d tasks in the HUB." % (len(ttasks),len(self.HUB.tasks),len(self.HUB.adding))
##          OldCheck()
##          d = defer.Deferred()
##          d = defer.addCallback(lambda : BatchWait())
#          defer.waitForDeferred( self.ExecuteWait(ttasks))
#          nout = len([t for t in ttasks if hasattr(t,"result") and t.result[5]])
#          fails = [t.result[3] for t in ttasks if hasattr(t,"result") and not t.result[5]]
#          assert fails == [], fails[0]
       elif self.HUB and isinstance(ttasks,ListType):
          print "Have hub"
          mhost,mport = self.HUB.split(":")
          mport = int(mport)
          print "hub host is %s, port %d" % (mhost,mport)
          [item.setFromModules(["FourCLiftProcess"]) for item in ttasks]
#          func,arg = "time.sleep",1
#          ttasks = [TwistedTask(-1,func,arg) for j in range(len(ttasks))]
          nin = len(ttasks)
          if self.runner:
             namespace = self.runner.namespace
             namespace["run"+str(self.hport)] = self
          else:
             namespace = globals()
             namespace["self"] = self
          [setattr(ttask,"path",self.basedir) for ttask in ttasks]
          self.currenttasks = {}
          [self.currenttasks.setdefault(t) for t in ttasks]
          if serial:
             print "Evaluating in serial"
             for ttask in ttasks:
                 print "Dispatching item to the hub"
                 ttasks1 = [ttask]
                 self.dispatch = \
                         HubDispatch(ttasks1,(mhost,mport),stayalive=True,\
                       mport=self.hport,namespace=namespace,verb=self.verb,sleeptime=0.01)
                 print "Start watching Hub"
                 yield WatchDispatcher(self.dispatch)
                 print "Done watching Hub"
                 nout = len([t for t in self.dispatch.completed if t.result[5]])
                 fails = [t.result[3] for t in self.dispatch.completed if not t.result[5]]
                 assert fails == [], fails[0]
                 print "Completed",ttask
#             results = [EvalTask(ttask) for ttask in ttasks]
#             [reactor.callInThread(EvalTask,ttask) for ttask in ttasks]
#             while len([ttask for ttask in ttasks if hasattr(ttask,"result")]) < len(ttasks):
#                   time.sleep(0.1)
          else:
             print "Dispatching them to the hub"
             self.dispatch = \
                     HubDispatch(ttasks,(mhost,mport),stayalive=True,\
                   mport=self.hport,namespace=namespace,verb=self.verb,sleeptime=0.01)
             print "Start watching Hub"
             yield WatchDispatcher(self.dispatch)
             print "Done watching Hub"
             nout = len([t for t in self.dispatch.completed if t.result[5]])
             fails = [t.result[3] for t in self.dispatch.completed if not t.result[5]]
             assert fails == [], fails[0]
#             print "Completed!"
#             print [t.result for t in self.dispatch.completed]
          [self.currenttasks.pop(t) for t in self.currenttasks.keys()]
       elif self.NP and not serial:
#          if not self.HUB: [ReadCalibs(self.UseExposures[0],chip,nfilt=self.nfilt,flat=self.flat,first=self.first,second=self.second) for chip in self.chips]
          if isinstance(ttasks,ListType):
             [item.setFromModules(["FourCLiftProcess"]) for item in ttasks]
             RunForkedQueue(EvalTask,ttasks,MaxThreads=self.NP,monitor=0,sleeptime=self.st,ThreadOutput=True)
          else:
             RunForkedQueue(ttasks,items,MaxThreads=self.NP,monitor=0,sleeptime=self.st,ThreadOutput=True)
       else:
          print "Not using hub"
#          if not self.HUB: [ReadCalibs(self.UseExposures[0],chip,nfilt=self.nfilt,flat=self.flat,first=self.first,second=self.second) for chip in self.chips]
          if isinstance(ttasks,ListType) and isinstance(ttasks[0],TwistedTask):
#             [item.setFromModules(["FourCLiftProcess"]) for item in ttasks]
             results = []
             for ttask in ttasks:
                 t0 = time.time()
                 yield EvalTask(ttask)
                 te = time.time()-t0
          else:
             map(ttasks,items)

   def Error(self,result):
       logging.err(result)
       e = open(self.ErrorFile(),"w")
       result.printTraceback(e)
       e.close()
       return self.ShutUp(result)

   def ShutUp(self,result=None):
       self.ongoing = False
       ClearCalibs(self.pset)
       ClearWaves(self.pset)
       [E.Clear(self.chips) for E in self.AllExposures]
       print "Turn off the manhole?"
       if self.ssh and self.manhole and hasattr(self.manhole,"stopListening"):
          print "Turn off the manhole!"
          stop = self.manhole.stopListening()
          return stop
       else:
          return True

   def WhatUp(self,*args):
       print args

   def Manhole(self):
       print "Turn on the manhole?"
       if self.ssh:
          namespace = globals()
          namespace["FourCLiftRun"] = self
          print "Turn on the manhole!"
          self.manhole = AddManhole(getpass.getuser(),"",namespace,self.ssh)
          return self.manhole
       else:
          return True

   def FirstPass(self,d=None):
       self.progress = 1
       self.current = 0
       if d==None: self.chain1 = defer.Deferred()
       else: self.chain1 = d
#       print "Already?",self.Already(first=self.first,second=self.second)
       if self.Already(first=self.first,second=self.second):
          self.donefirst = True
       else:
          self.chain1.addCallback(lambda result: setattr(self,"tstart",time.time()))
          self.chain1.addCallback(lambda result: self.GetExposures(consolidate=True))
          if self.flat or not len(glob(self.basedir+"/Science/"+self.zdir+"/"+self.targ+"_tmp*")):
#          if self.flat:
             self.chain1.addCallback(lambda result: self.Stage0())
             self.chain1.addCallback(lambda result: self.Stage1())
             if not self.flat:
                self.chain1.addCallback(lambda result: self.Stage2())
             if self.flat:
                self.chain1.addCallback(lambda result: self.Stage9())
                self.chain1.addCallback(lambda result: self.StageA())
             else:
                self.chain1.addCallback(lambda result: self.Stage3())
#                self.chain1.addCallback(lambda result: self.Stage4())
#                self.chain1.addCallback(lambda result: self.Stage5())
#                self.chain1.addCallback(lambda result: self.Stage6())
#                self.chain1.addCallback(lambda result: self.Stage7())
          if not self.flat and "_tmp" not in self.targ:
             if len(glob(self.basedir+"/Science/"+self.zdir+"/"+self.targ+"_tmp*")):
                if not len(glob(self.basedir+"/Science/"+self.zdir+"/"+self.targ+"/Shift*png")):
                   self.chain1.addCallback(lambda result: self.Stage0())
                   self.chain1.addCallback(lambda result: self.Stage2tmp())
             else:
                self.chain1.addCallback(lambda result: self.Stage1())
                self.chain1.addCallback(lambda result: self.Stage2())
             self.chain1.addCallback(lambda result: self.Stage3())
             self.chain1.addCallback(lambda result: self.Stage4())
             self.chain1.addCallback(lambda result: self.Stage5())
             self.chain1.addCallback(lambda result: self.Stage6())
             self.chain1.addCallback(lambda result: self.Stage7())
             if self.makeflat:
                self.chain1.addCallback(lambda result: self.Stage8())
                if self.makepupil:
                   self.chain1.addCallback(lambda result: self.Stage9())
                   self.chain1.addCallback(lambda result: self.StageA())
          self.chain1.addCallback(lambda result: self.Stage0())
          self.chain1.addCallback(lambda result: self.ShutUp())
          self.chain1.addCallback(lambda result: setattr(self,"tfinish",time.time()))
          self.chain1.addErrback(self.Error)
       return self.chain1

   def SecondPass(self,d=None):
       self.progress = 2
       self.current = 0
       if d==None: self.chain2 = defer.Deferred()
       else: self.chain2 = d
       if self.Already(first=self.first,second=self.second):
          self.donesecond = True
       else:
          self.chain2.addCallback(lambda result: setattr(self,"tstart",time.time()))
          self.chain2.addCallback(lambda result: self.GetExposures(consolidate=True))
          self.chain2.addCallback(lambda result: self.Ready())
          self.chain2.addCallback(lambda result: self.Stage0())
          self.chain2.addCallback(lambda result: self.Stage1())
          self.chain2.addCallback(lambda result: self.Stage2())
          if not self.flat:
             self.chain2.addCallback(lambda result: self.Stage3())
             self.chain2.addCallback(lambda result: self.Stage4())
             self.chain2.addCallback(lambda result: self.Stage5())
             if 1 or not "sky" in self.targ:
                self.chain2.addCallback(lambda result: self.Stage6())
                self.chain2.addCallback(lambda result: self.Stage7())
          self.chain2.addCallback(lambda result: self.Stage0())
          self.chain2.addCallback(lambda result: self.ShutUp())
          self.chain2.addCallback(lambda result: setattr(self,"tfinish",time.time()))
          self.chain2.addErrback(self.Error)
       return self.chain2

   @defer.inlineCallbacks
   def GetExposures(self,consolidate=True):
       self.ongoing = True
       print "RESETTING DIRECTORY TO",self.basedir
       storage = ZODB.FileStorage.FileStorage(self.basedir+"/"+self.zodb,read_only=True)
       zdb = ZODB.DB( storage)
       conn = zdb.open()
       dbroot = conn.root()

       self.FourCLiftDataset = []
       yield IRSetup(dbroot,self.targ,self.nfilt,flat=self.flat,\
          nume=self.nume,FourCLiftDataset=self.FourCLiftDataset)
       if not self.FourCLiftDataset:
          raise NameError("Target %s not found" % (self.targ))

       self.AllExposures = []
       def GetE():
           for N in self.FourCLiftDataset:
              self.AllExposures.append( Exposure(N))
              yield
       co = task.cooperate(GetE())
       yield co.whenDone()

       transaction.abort()
       conn.close()
       zdb.close()
       storage.close()

       mjds = array([E.mjd for E in self.AllExposures])
       mastermjd = median(mjds)

       for E in self.AllExposures:
           E.pset = self.pset
           E.mastermjd = mastermjd

       if self.flat and "flat" not in self.targ and "Dark" not in self.nfilt:
         for E in self.AllExposures:
            E.objname = "flat_"+E.objname

       if self.end > self.start:
          self.AllExposures = [E for E in self.AllExposures if (self.start <= E.expno <= self.end)]

#       [E.Bad() for E in self.AllExposures]
#       self.AllExposures = [E for E in self.AllExposures if not E.bad]

       if self.show: os._exit(0)

       if self.freeze:
          self.AllExposures = [E for E in self.AllExposures if os.path.exists(E.mfits1(self.chips[0]))]

#       print self.AllExposures
#       self.Cull()
       print

       seqs = {}
       [seqs.__setitem__(E.seq,seqs.get(E.seq,[])+[E]) for E in self.AllExposures]
       [[setattr(seq1,"oloop",seq) for seq1 in seq] for seq in seqs.values()]
       if "flat" not in self.targ and "Dark" not in self.nfilt:
          if consolidate:
             [setattr(seq[0],"loop",seq) for seq in seqs.values()]
             AllExposures = [seq[0] for seq in seqs.values() if seq[0].loopno==1]
             mjds = [E.mjd for E in AllExposures]
             self.AllExposures = [AllExposures[j] for j in argsort(mjds)]
             asl = Set([(E.seq,1) for E in self.AllExposures])
             self.FourCLiftDataset = [N  for N in self.FourCLiftDataset if (N.seq,1) in asl]
          else:
             for E in self.AllExposures:
                 E.bad = sum([FileCheck(E.oloop[0].sfits1(c)) for c in [1,2,3,4]]) < 4

       [E.Bad() for E in self.AllExposures]

       self.AllExposures = [E for E in self.AllExposures if not E.bad]
       print self.AllExposures,
       print len(self.AllExposures)
       self.Cull()
       asl = Set([(E.seq,1) for E in self.AllExposures])
       self.FourCLiftDataset = [N  for N in self.FourCLiftDataset if (N.seq,1) in asl]

       self.UseExposures = self.AllExposures
       print self.UseExposures,
       print len(self.UseExposures)
       self.Check()
#       os._exit(1)

   def Clear(self):
       [[E.data.pop(chip) for chip in E.data.keys()] for E in self.UseExposures]
       [[E.sdata.pop(chip) for chip in E.data.keys()] for E in self.UseExposures]
       [[E.masks.pop(chip) for chip in E.masks.keys()] for E in self.UseExposures]

   def Cull(self):
       [E.Bad() for E in self.AllExposures]
       self.UseExposures = [E for E in self.AllExposures if not E.bad]

   def Check(self):
       if self.HUB or self.NP:
         self.caching = False
       else:
         self.caching = len(self.UseExposures) < self.nmax
       print "Caching",self.caching
       [setattr(E,"cache",self.caching) for E in self.UseExposures]
       setattr(self,"cats",{})

   @defer.inlineCallbacks
   def Stage0(self):
       self.current = 0
       ttasks1,ttasks2 = self.Stage0Tasks()
       print "Before ttasks1"
       yield self.Execute(ttasks1,[False])
       print "After ttasks1"
       print "Before ttasks2"
       yield self.Execute(ttasks2,[])
       print "After ttasks2"

   def Stage0Tasks(self):
        ttasks1 = [TwistedTask(-1,"ClearCalibs",self.pset)]
        ttasks1[0].setFromModules(["FourCLiftProcess"])
        ttasks1[0].all = True
        ttasks1[0].now = True
        ttasks2 = [TwistedTask(-1,"ClearWaves",self.pset)]
        ttasks2[0].setFromModules(["FourCLiftProcess"])
        ttasks2[0].all = True
        ttasks2[0].now = True
        return ttasks1,ttasks2

   @defer.inlineCallbacks
   def Stage1(self):
       self.current = 1
       [self.cats.setdefault(chip,None) for chip in self.chips]
       ttasks,items = self.Stage1Tasks()
       if ttasks:
          yield self.Execute(ttasks,items)
#          os._exit(1)
          self.newmode = True

       if "Dark" not in self.nfilt:
          if len(self.chips) == 1: skyplot = self.UseExposures[0].scratch("skyplot%sc%d.png" % (self.stage,self.chips[0]))
          else: skyplot = self.UseExposures[0].scratch("skyplot%s.png" % (self.stage))
          if self.newmode or not FileCheck(skyplot):
             print "Check consistency of the medians..."
             t = TwistedTask(-1,"PlotModes",self.UseExposures,self.chips,first=self.first,second=self.second,flat=self.flat)
#             t.local = True
             print "Have PlotModes task",t
             yield self.Execute([t],[])
          [E.Bad() for E in self.UseExposures]

   def Stage1Tasks(self):
       print "Pulling the individual frames out, doing quick stats..."
       Exposures = self.UseExposures
#       print Exposures
#       reactor.callFromThread(reactor.stop)
#       raise IOError( "TEST!")
       easydir(Exposures[0].scratch("mode"+self.stage))
       fsky = array([e.sky for e in Exposures])
       bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
       if Exposures[0].sky:
          bab = 0
          fsky = zeros(fsky.shape)
       if not self.first:
          easydir(Exposures[0].scratch("mask"+str(int(self.stage)-1)))
          easydir(Exposures[0].scratch("pers"+str(int(self.stage)-1)))

       self.newmode = False
       items = []
       coll0 = {}
       coll = {}
       for chip in self.chips:
          if chip not in coll:
             coll0[chip] = []
             coll[chip] = []
          for j,E in enumerate(self.UseExposures):
              coll0[chip].append(E)
#              print E,bab,E.sky,FileCheck(eval("E.mfits"+self.stage)(chip))
              if (not bab or bab and not E.sky) and not FileCheck(eval("E.mfits"+self.stage)(chip)):
                 item = [E,chip]
                 loopno = E.loopno
                 coll[chip].append(E)
                 if j>=loopno and not self.flat and not self.dark:
                     item.append(self.UseExposures[(j-loopno)])
                 elif j<(len(self.UseExposures)-loopno) and not self.flat and not self.dark:
                     item.append(self.UseExposures[(j+loopno)])
                 else:
                     item.append(None)
                 items.append(item)
                 if self.second and not self.cats.get(chip,None):
                    self.GetStackCat(chip)

       if items:
#          print items
#          os._exit(1)
          if self.HUB:
             ttasks=[TwistedTask(-1,"lambda *args,**kw: args[0].Mode(*args[1:],**kw)",\
                Echip[0],Echip[1],other=Echip[2],first=self.first,second=self.second,msh=self.msh,\
                cat=self.cats[Echip[1]],histo=self.histo,mag=self.mag,\
                flat=self.flat,verb=self.verb) \
                for j,Echip in enumerate(items)]
          else:
             ttasks=lambda Echip: Echip[0].Mode(Echip[1],other=Echip[2],\
                first=self.first,second=self.second,msh=self.msh,\
                cat=self.cats[Echip[1]],histo=self.histo,mag=self.mag,\
                flat=self.flat,verb=self.verb)
       else:
          ttasks=None

       return ttasks,items

   def GetStackCat(self,chip):
       print "Getting catalog for the mask making..."
       solnfits=self.UseExposures[0].scratch("Stack1c%d.fits"%(chip))
       solnfile=self.UseExposures[0].scratch("Stack1c%d.soln"%(chip))
       solndat = None
       if FileCheck(solnfits) and FileCheck(solnfile):
          solndat = readsoln(solnfile)
          F = FITS(solnfits)
          solndat["naxes"] = F.naxes()
          F.close()
       catfile=self.UseExposures[0].scratch("Mosaic1.cat")
       catsoln = readsoln(solnfile)
       catpa = (atan2(catsoln["c"][3],catsoln["c"][2]) + pi) % (2*pi)
       catfits = FITS(catfile.replace(".cat",".fits"))
       catnaxes = catfits.naxes()
       catfits.close()
       isoln = invsoln(solndat,catnaxes[0],catnaxes[1],verb=1)
       Xz,Yz,Xs,Ys = Offsets(self.UseExposures,chip)
       self.cats[chip] = {"Xz":Xz,"Yz":Yz,"Xs":Xs,"Ys":Ys,"cat":catfile,"isoln":isoln,"soln":solndat,"exp":self.UseExposures,"naxes":catnaxes,"pa":catpa}

   @defer.inlineCallbacks
   def Stage2(self):
       self.current = 2
#       self.Cull()
       if self.lift:
#          ttasks0 = [TwistedTask(-1,"ClearWaves",self.pset)]
#          ttasks0[0].all = True
#          ttasks0[0].now = True
#          yield self.Execute(ttasks0,[])
          ttasks,items = self.Stage2TasksWaveletTransforms()
          yield self.Execute(ttasks,items)
          self.Clear()
#          os._exit(1)
       else:
          ttasks1,ttasks1b,items1,ttasks2,items2 = self.Stage2TasksRunning()
          if items1 or items2:
             if not self.HUB:
                yield self.Execute(ttasks1,items1,serial=1)
             else:
                if 0 and self.HUB:
                   yield self.Execute(ttasks1b,items1)
                elif 0 and self.NP:
                   yield self.Execute(ttasks1,items1)
                else:
                   items1 = map(ttasks1,items1)
                   ttasks1 = []
                   [[ttasks1.append(i) for i in item[0]] for item in items1 if item]
                   N = len(ttasks1)
                   Nd = numpy.random.permutation(N)
#                   Nd = []
#                   while len(Nd) < N: [Nd.append(k) for k in randint(0,N,N) if k not in Nd]
                   print Nd
                   ttasks1 = [ttasks1[j] for j in Nd]
                   yield self.Execute(ttasks1,items1)
                   tempframes = [item[1] for item in items1 if item]
                   skyframes = [item[2] for item in items1 if item]
                   print tempframes
                   print skyframes
                   print tempframes
                   ttasks1a = [TwistedTask(-1,"Assemble",t1) for t1 in tempframes]
                   yield self.Execute(ttasks1a,tempframes,serial=not self.HUB)
                   ttasks1b = [TwistedTask(-1,"os.rename",item[1],item[2]) for item in items1 if item]
                   yield self.Execute(ttasks1b,items1,serial=not self.HUB)
                   ttasks1c = [TwistedTask(-1,"MakeThumbnail",item[2],mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
                   yield self.Execute(ttasks1c,items1,serial=not self.HUB)
                   ttasks1d = [TwistedTask(-1,"MakeThumbnail",item[2],mag=16,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
                   yield self.Execute(ttasks1d,items1,serial=not self.HUB)
#                   raw_input()
#                   reactor.callFromThread(reactor.stop)
             if ttasks2:
                yield self.Execute(ttasks2,items2)
             self.Clear()
#             os._exit(1)

       if self.lift:
#          ttasks0 = [TwistedTask(-1,"ClearWaves",self.pset)]
#          ttasks0[0].all = True
#          ttasks0[0].now = True
#          yield self.Execute(ttasks0,[])
          ttasks2,items2 = self.Stage2TasksWaveletAnalysisSetup()
#          ttasks2,items2 = [],[]
#          yield self.Stage2TasksWaveletAnalysis(ttasks2,items2)
#          if ttasks2 and isinstance(ttasks2[0],FunctionType): ttasks2 = ttasks2[0]
          if ttasks2:
             if isinstance(ttasks2,ListType):
                atasks2 = [ttask for ttask,item in zip(ttasks2,items2) if item[1] == 0]
                aitems2 = [item for ttask,item in zip(ttasks2,items2) if item[1] == 0]
                btasks2 = [ttask for ttask,item in zip(ttasks2,items2) if item[1] != 0]
                bitems2 = [item for ttask,item in zip(ttasks2,items2) if item[1] != 0]
             else:
                atasks2 = ttasks2
                aitems2 = [item for item in items2 if item[1] == 0]
                btasks2 = ttasks2
                bitems2 = [item for item in items2 if item[1] != 0]
             if aitems2:
#                print atasks2
#                print aitems2
                yield self.Execute(atasks2,aitems2)
#                raw_input("WAITING!")
             if bitems2:
                yield self.Execute(btasks2,bitems2)
#          ttasks0 = [TwistedTask(-1,"ClearWaves",self.pset)]
#          ttasks0[0].all = True
#          ttasks0[0].now = True
#          yield self.Execute(ttasks0,[])
#          print "ttasks2!"
#          for ttask in ttasks2:
#              print ttask
#              print ttask.result
#          raw_input("WAITING AGAIN!")
          ttasks2b,items2b = [],[]
          if ttasks2:
             yield self.Stage2TasksWaveletAnalysis(ttasks2,items2,ttasks2b,items2b)
          print len(ttasks2b)
          if ttasks2b:
             yield self.Execute(ttasks2b,items2b)
#          os._exit(1)
          ttasks3,items3 = self.Stage2TasksWaveletInvert()
          if ttasks3:
             yield self.Execute(ttasks3,items3)
#       else:
#          if ttasks2:
#             yield self.Execute(ttasks2,items2)

       if self.flat and ((self.targ[:8] == "flat_obj" and self.first) or ("flat" in self.targ and self.first) or \
                       self.nfilt == "Dark"):
          if self.flat and "dark" in self.targ: kind = self.targ
          else: kind = "Flat"
          if [chip for chip in self.chips if \
               ((kind == "Flat" and not FileCheck("mask"+self.nfilt+"c%d.fits" % (chip))) \
               or not FileCheck("%s%sc%d.fits" % (kind,self.nfilt,chip)))]:
             ttask = TwistedTask(-1,"FinalizeFlats",self.targ,self.nfilt,self.chips,self.UseExposures,first=self.first,second=self.second)
             yield self.Execute([ttask],[])
#          os._exit(0)

   def Stage2TasksRunning(self):
       items = []
       awaits = []
       skyframes = []
       nes = []
       ne30s = []
       Exposures = self.UseExposures
       fsky = array([e.sky for e in Exposures])
       bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
       if Exposures[0].sky:
          bab = 0
          fsky = zeros(fsky.shape)
       print sum(fsky),len(fsky),bab
       for chip in self.chips:
           for E in self.UseExposures:
               if self.flat and "dark" in self.targ: kind = self.targ
               else: kind = "Flat"
               if (self.first and not os.path.exists(eval("E.sfits"+self.stage)(chip))) \
                       or (self.second and E == self.UseExposures[0] and \
                        not FileCheck("sky%s/%s%sc%d.fits" % (self.nfilt,kind,self.stage,chip))):
                   if not bab or not E.sky:
                      items.append((E,chip))
                      await,skyframe,ne,ne30 = E.SkySubtract(chip,self.UseExposures,\
                        first=self.first,second=self.second,sigclip=self.sigclip,\
                         flat=self.flat,nf=self.nf,test=1)
                      awaits.append(await)
                      skyframes.append(skyframe)
                      nes.append(ne)
                      ne30s.append(ne30)

#       print items
#       print nes
#       print ne30s
#       print [os.path.basename(s) for s in skyframes]
#       print set([os.path.basename(s) for s in skyframes])
#       print awaits
#       print [os.path.basename(s) for a,s in zip(awaits,skyframes) if a]
#       print [os.path.basename(s) for a,s in zip(awaits,skyframes) if not a]
#       print
#       os._exit(1)

       sitem = [s for a,s in zip(awaits,items) if not a]
       frame = [s for a,s in zip(awaits,skyframes) if not a]
       s = {}
       for j in range(len(awaits)):
          if not awaits[j]:
             if skyframes[j] in s: awaits[j] = True
             else: s.setdefault(skyframes[j])

#       print sitem
#       print skyframes
#       print awaits
#       print items
#       print s
       if items:
          bigsky = logical_not(awaits)
          items1 = [items[j] for j in nonzero(bigsky)]
#          print
#          print items1
#          print
#          os._exit(1)

          if self.HUB:
             print "sigclip=",self.sigclip
#             os._exit(1)
             ttasks1 = lambda Echip: Echip[0].SkySubtract(Echip[1],self.UseExposures,\
                first=self.first,second=self.second,flat=self.flat,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,\
                Hub=self.HUB,bigsky=1,NP=0)
             ttasks1b = [TwistedTask(-1,"lambda *args,**kw: args[0].SkySubtract(*args[1:],**kw)",Echip[0],Echip[1],self.UseExposures,\
                first=self.first,second=self.second,flat=self.flat,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,\
                Hub=self.HUB,bigsky=1,NP=0) for Echip in items1]
             [setattr(t,"local",True) for t in ttasks1b]

          else:
             ttasks1 = lambda Echip: Echip[0].SkySubtract(Echip[1],self.UseExposures,\
                first=self.first,second=self.second,flat=self.flat,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,\
                Hub=None,bigsky=1,NP=self.NP)
             ttasks1b = None

          if self.flat and "dark" in self.targ: items2 = []
          elif self.flat and "flat" in self.targ: items2 = []
          else: items2 = items
#          print items1
#          print
#          print items2
#          print
#          raw_input("<< PAUSED >> ")

          if self.HUB:
             ttasks2=[TwistedTask(-1,"lambda *args,**kw: args[0].SkySubtract(*args[1:],**kw)",\
                Echip[0],Echip[1],self.UseExposures,already=1,\
                first=self.first,second=self.second,flat=self.flat,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,NP=0) \
                for j,Echip in enumerate(items2)]
          else:
             ttasks2=lambda Echip: Echip[0].SkySubtract(Echip[1],self.UseExposures,\
                already=1,first=self.first,second=self.second,flat=self.flat,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip)
       else:
          ttasks1=None
          ttasks1b=None
          ttasks2=None
          items1=None
          items2=None

       return ttasks1,ttasks1b,items1,ttasks2,items2

   @defer.inlineCallbacks
   def Stage2tmp(self):
      ttasks1 = self.Stage2tmpBase("mode")
      ttasks2 = self.Stage2tmpBase("sky")
      ttasks3 = self.Stage2tmpBase("cat")
      ttasks = ttasks1 + ttasks2 + ttasks3
      items = len(ttasks)*[]
      if ttasks: yield self.Execute(ttasks,items)
      ttasks = self.Stage2tmpMod("sky")
      if ttasks: yield self.Execute(ttasks,[])

      if len(self.chips) == 1: skyplot = self.UseExposures[0].scratch("skyplot%sc%d.png" % (self.stage,self.chips[0]))
      else: skyplot = self.UseExposures[0].scratch("skyplot%s.png" % (self.stage))
      if ttasks1 or not FileCheck(skyplot):
         print "Check consistency of the medians..."
#         PlotModes(self.UseExposures,self.chips,first=self.first,second=self.second,flat=self.flat)
         t = TwistedTask(-1,"PlotModes",self.UseExposures,self.chips,first=self.first,second=self.second,flat=self.flat)
         yield self.Execute([t],[])
      [E.Bad() for E in self.UseExposures]


   def Stage2tmpBase(self,base):
       self.tmpds = glob(self.basedir+"/Science/"+self.zdir+"/"+self.targ+"_tmp*")
       self.tmpds.sort()
       easydir(self.UseExposures[0].scratch(base+self.stage))
       ttasks = []
       [ttasks.extend(self.Stage2tmpCopy(d,base+self.stage)) for d in self.tmpds]
       return ttasks

   def Stage2tmpCopy(self,tmpd,base):
       d1 = tmpd + "/" + base
       d2 = self.UseExposures[0].scratch(base)
       d1 = d1.replace(" ","\\ ")
       d2 = d2.replace(" ","\\ ")
       if self.UseExposures[0].fclass == "fourstar":
          command = "cd %s; ln -fs %s/fsr* ." % (d2,d1)
       elif self.UseExposures[0].fclass == "newfirm":
          command = "cd %s; ln -fs %s/image* ." % (d2,d1)
       ttasks = [TwistedTask(-1,"verbex",command)]
       return ttasks

   def Stage2tmpMod(self,base):
       ttasks = []
       d2 = self.UseExposures[0].scratch(base)
#       if "sky" in base:
#          for chip in self.chips:
#             command = "addkeys %s/fsr\*c%d.fits xdiff1,ydiff1,mdiff1 N/A,N/A,N/A" % (d2,chip)
#             ttasks += [TwistedTask(-1,"verbex",command)]
       return ttasks

#       print "Copying from",tmpd
#       self.tmpfs = os.listdir(d1)
#       ttasks = []
#       [ttasks.extend(self.Stage2tmpCopyOne(f,tmpd,base)) for f in self.tmpfs \
#            if "FirstSky" not in f]
#       return ttasks

   def Stage2tmpCopyOne(self,tmpf,tmpd,base):
       n1 = "%s/%s" % (tmpd,tmpf)
       n2 = "%s/%s" % (self.UseExposures[0].scratch(base),tmpf)
       if os.path.exists(n2):
          ttask = []
       else:
          if "sky" in base:
            ttask = [TwistedTask(-1,"CopyFile",n1,n2,sky=1)]
          else:
            ttask = [TwistedTask(-1,"CopyFile",n1,n2)]
       return ttask

   def Stage2TasksWaveletTransforms(self):
       self.newwaves = False
       items = []
       Exposures = [E for E in self.UseExposures if not E.bad]
       Epck = Exposures[0].scratch("Exposures.pck")
       fEpck = open(Epck,"wb")
       cPickle.dump(Exposures,fEpck)
       fEpck.close()
       for chip in self.chips:
           for E in self.UseExposures:
             if not FileCheck(eval("E.wfits"+self.stage)(chip)) \
                    and (not self.flat or (self.flat and E == self.UseExposures[0])):
                   items.append((E,chip))
                   self.newwaves = True

       if items:
          MakeJXY(nn=self.nn,nt=self.nt)
          if self.HUB:
             ttasks=[TwistedTask(-1,"lambda *args,**kw: args[0].flwt2d(*args[1:],**kw)",\
                Echip[0],Echip[1],Epck,first=self.first,second=self.second,verb=self.verb) \
                for j,Echip in enumerate(items)]
          else:
             ttasks = lambda Echip: Echip[0].flwt2d(Echip[1],Epck,\
                first=self.first,second=self.second,verb=self.verb)
       else:
          ttasks=None

       return ttasks,items

#   @defer.inlineCallbacks
#   def Stage2TasksWaveletAnalysis(self,ttasks,items):
   def blahStage2TasksWaveletAnalysis(self):
       Exposures = [E for E in self.UseExposures if not E.bad]
       MakeJXY(nn=self.nn,nt=self.nt)
       L = JXY["L"]
       jar = JXY["jar"]
       xyr = JXY["xyr"]
       wpars = "wavelets%s.pars" % (self.stage)
       wpars = readtable(wpars,header=0,icols=[0,1,2,3])
#       nvar,tvar,wvar,svar = compress(equal(wpars["l"],L[1]-l),[wpars["n"],wpars["t"],wpars["w"],wpars["s"]],1)[::,0]
#       pvar = [0,1][not nvar and not tvar and wvar>0]
#       y,x = indices(jar.shape,int16)
       nw = 3*(sum(greater(wpars["u"],0))-1)+1
       self.newcons = False
       items = []
       for chip in self.chips:
           if self.newwaves or len([g for g in glob(Exposures[0].scratch("smow"+self.stage+"/wtrendc"+str(chip)+"*.fits")) if FileCheck(g)]) < nw:
              self.newcons = True
              L = JXY["L"]
              luse = sort(max(L)-compress(wpars["u"],wpars["l"]))

              if not self.inter:
                 luse = luse[::-1]

              wxy = [(l,s) for l in luse for s in [[3],[1,2,3]][l>0]]
              print "Full set:"
              print wxy
              wxy = [(l,s) for (l,s) in wxy if not FileCheck(Exposures[0].scratch("smow%s/wtrendc%d_%d%s.fits" % (self.stage,chip,L[1]-l,"xyr"[s-1])))]
              print "Left to do:"
              print wxy

              if wxy:
                 items.extend([(chip,)+ls for ls in wxy])
#                 yield

       if items:
          if self.HUB:
             ttasks = []
             Wt = array([f.mjd for f in Exposures])
             We = array([E.exptime*len(E.loop) for E in Exposures])
             Wt = Wt*24.0*60.0 + We/60.0/2.
             for j,lsc in enumerate(items):
                 chip,l,s = lsc
#                 u = equal(jar,l)*equal(xyr,s)
#                 yu,xu = compress(u.ravel(),[y.ravel(),x.ravel()],1)
#                 ay0,ay1 = extrema(yu)
#                 ax0,ax1 = extrema(xu)
#                 ns = (ay1-ay0)/ys + 1
#                 kss = range(ns)
#                 for ks in kss:
                 if 1:
                     ttask = TwistedTask(-1,"WaveAnalyze",Exposures,chip,self.first,self.second,l,s,\
                          inter=self.inter,nn=self.nn,nt=self.nt,origdir=self.basedir,verb=1,noplots=1) #,ys=ys,kss=[ks])
                     ttasks.append(ttask)
#                     yield

          else:
             ttasks = lambda lsc: WaveAnalyze(Exposures,lsc[0],self.first,self.second,lsc[1],lsc[2],\
                      inter=self.inter,nn=self.nn,nt=self.nt,origdir=self.basedir,verb=1,noplots=1)
       else:
          ttasks = None
          items = []
       return ttasks,items

   def Stage2TasksWaveletAnalysisSetup(self):
       Exposures = [E for E in self.UseExposures if not E.bad]
       Epck = Exposures[0].scratch("Exposures.pck")
       MakeJXY(nn=self.nn,nt=self.nt)
       wpars = "wavelets%s.pars" % (self.stage)
       wpars = readtable(wpars,header=0,icols=[0,1,2,3])
       nw = 3*(sum(greater(wpars["u"],0))-1)+1
       self.newcons = False
       items = []
       for chip in self.chips:
           if self.newwaves or len([g for g in glob(Exposures[0].scratch("smow"+self.stage+"/wtrendc"+str(chip)+"*.fits")) if FileCheck(g)]) < nw:
              self.newcons = True
              L = JXY["L"]
              luse = sort(max(L)-compress(wpars["u"],wpars["l"]))

              if not self.inter:
                 luse = luse[::-1]

              wxy = [(l,s) for l in luse for s in [[3],[1,2,3]][l>0]]
              print "Full set:"
              print wxy
              wxy = [(l,s) for (l,s) in wxy if not FileCheck(Exposures[0].scratch("smow%s/wtrendc%d_%d%s.fits" % (self.stage,chip,L[1]-l,"xyr"[s-1])))]
              print "Left to do:"
              print wxy

              if wxy:
                 items = items + [(chip,)+ls for ls in wxy]

       if items:
          if self.HUB:
             ttasks=[TwistedTask(-1,"WaveAnalyze",\
                     Epck,lsc[0],self.first,self.second,lsc[1],lsc[2],\
                      inter=self.inter,nn=self.nn,nt=self.nt,origdir=self.basedir,verb=1,noplots=(lsc[1]>0)) \
                      for j,lsc in enumerate(items)]
          else:
             ttasks = lambda lsc: WaveAnalyze(Epck,lsc[0],self.first,self.second,lsc[1],lsc[2],\
                      inter=self.inter,nn=self.nn,nt=self.nt,origdir=self.basedir,verb=1,noplots=(lsc[1]>0))
       else:
          ttasks = None
          items = []
       return ttasks,items

   @defer.inlineCallbacks
   def Stage2TasksWaveletAnalysis(self,ttasks2,items2,ttasks,items):
       Exposures = [E for E in self.UseExposures if not E.bad]
       Epck = Exposures[0].scratch("Exposures.pck")

       def Go():
          def GetE():
              for ttask2,item2 in zip(ttasks2,items2):
                 kss = ttask2.result[3]
                 lsc = item2
                 if lsc[1] != 0:
                    print lsc,len(kss)
                    for ks in kss:
                       ttask = TwistedTask(-1,"WaveAnalyze",\
                               Epck,lsc[0],self.first,self.second,lsc[1],lsc[2],\
                                inter=self.inter,nn=self.nn,nt=self.nt,origdir=self.basedir,kss=[ks],\
                                verb=1,noplots=(lsc[1]>0))
                       ttasks.append(ttask)
                    yield
          return task.cooperate(GetE())
       co = Go()
       yield co.whenDone()

   def Stage2TasksWaveletInvert(self):

       [E.Bad() for E in self.UseExposures]
       Exposures = [E for E in self.UseExposures if not E.bad]
       Epck = Exposures[0].scratch("Exposures.pck")
       items = []
       self.newinv = False
       for chip in self.chips:
           for j,E in enumerate(Exposures):
               if self.newcons or not FileCheck(eval("E.sfits"+self.stage)(chip)):
                  self.newinv = True
                  MakeJXY(nn=self.nn,nt=self.nt)
                  items.append((E,chip,j))

       if items:
          if self.HUB:
             ttasks=[TwistedTask(-1,"WaveInvert",\
                Echip[0],Echip[1],Echip[2],self.stage,nn=self.nn,nt=self.nt,origdir=Echip[0].scratchspace) \
                for j,Echip in enumerate(items)]
          else:
             Echip = items[0]
             for chip in self.chips:
                 ReadWaves(p=2,chip=chip,nn=self.nn,nt=self.nt,origdir=self.UseExposures[0].scratchspace,pset=Echip[0].pset)
             ttasks = lambda Echip: WaveInvert(Echip[0],Echip[1],Echip[2],self.stage,nn=self.nn,nt=self.nt,origdir=Echip[0].scratchspace)
       else:
          ttasks = None
       return ttasks,items

   @defer.inlineCallbacks
   def Stage3(self):
       self.current = 3
       go = 1
       force = 0
       p = 0
       bad = 0
       while go and p < 10:
         p += 1
         [E.Bad() for E in self.UseExposures]
         Exposures = [E for E in self.UseExposures if not E.bad]
         Epck = Exposures[0].scratch("Exposures.pck")
         fEpck = open(Epck,"wb")
         cPickle.dump(Exposures,fEpck)
         fEpck.close()
         nE = len(Exposures)
         ttasks,items = [],[]
         yield self.Stage3Tasks(ttasks,items,force=force)
         anyway = False
         if not os.path.exists(Exposures[0].scratch("Shifts%s_%d.png"%(self.stage,1))): anyway = True
         if not FileCheck(Exposures[0].scratch("Shifts%s.dat"%(self.stage))): anyway = True
         if ttasks or bad or anyway:
            if ttasks:
               if self.HUB:
                  yield self.Execute(ttasks,items)
               else:
                  yield self.Execute(ttasks,items,serial=True)
               print "Done executing!"
#            command = "getkeys sky1/fsr_07\*c\?.fits xdiff1,xscat1,ydiff1,yscat1,mdiff1,mscat1,lmatch1 >> Shifts1.dat"
#            bad = ShiftsCheck(Exposures,self.chips,self.stage,self.flat,p)
            task = TwistedTask(-1,"ShiftsTable",Epck,self.chips,self.stage)
            yield self.Execute([task],[])
            task = TwistedTask(-1,"ShiftsCheck",Epck,self.chips,self.stage,self.flat,p)
            yield self.Execute([task],[])
            self.Cull()
            [E.Bad() for E in self.UseExposures]
            nExposures = [E for E in self.UseExposures if not E.bad]
            nE2 = len(nExposures)
            bad = nE-nE2
         if self.flat:
            go = 0
         else:
            if bad: force = 1
            else: go = 0
#         go = 0
#         raw_input("<cr> ")

   @defer.inlineCallbacks
   def Stage3Tasks(self,ttasks0,items0,force=0):
       print "Make frame catalogs and compute the shifts..."
       self.doshifts = False
       Epck = self.UseExposures[0].scratch("Exposures.pck")
       fEpck = open(Epck,"wb")
       cPickle.dump(self.UseExposures,fEpck)
       fEpck.close()
       Exposures = [E for E in self.UseExposures if not E.bad]
       sky = array([E.sky for E in Exposures])
       bab = (sum(sky) and (sum(sky) < len(sky)))
       if bab and Exposures[0].sky:
          bab = 0
          sky = zeros(sky.shape)
       if bab:
          Exposures = [E for E in Exposures if not E.sky]

       if not os.path.exists(Exposures[0].scratch("Shifts%s_%d.png"%(self.stage,1))): self.doshifts = True
       if not FileCheck(Exposures[0].scratch("Shifts%s.dat"%(self.stage))): self.doshifts = True
       else:
           stbl = readtable(Exposures[0].scratch("Shifts%s.dat"%(self.stage)),header="# frame",tcols=["frame"])
           if len(stbl["frame"]) != (len(Exposures)*len(self.chips)): self.doshifts=True
       if not self.doshifts:
#          ShiftCheck(self.FourCLiftDataset,self.chips,self.stage)
#          raw_input("<ShiftCheck> ")
#          yield
          ttask = TwistedTask(-1,"ShiftCheck",Epck,self.chips,self.stage)
          yield self.Execute([ttask],[])
          print ttask.result
          if self.HUB: self.doshifts = ttask.result[3]
          else: self.doshifts = ttask.result
       if self.doshifts or force:
          easydir(Exposures[0].scratch("shift"+self.stage))
          items = Exposures
          if self.HUB or 1:
             ttasks=[TwistedTask(-1,"lambda *args,**kw: args[0].Shift(*args[1:],**kw)",\
                E,Epck,chips=self.chips,first=self.first,second=self.second,verb=1,mport=-1) \
                for j,E in enumerate(items)]
          else:
             # THIS WONT WORK RIGHT
             ttasks = lambda E: E.Shift(Exposures,chips=self.chips,first=self.first,second=self.second,verb=1,mport=-1)
          ttasks0.extend(ttasks)
          items0.extend(items)
       else:
          ttasks = None
          items = []

   @defer.inlineCallbacks
   def Stage4(self):
       self.current = 4
       self.Stage4a()
       ttasks,items = [],[]
       self.Stage4Tasks(ttasks,items)
#       d = defer.Deferred()
#       d.addCallback(lambda result: self.Stage4Tasks(ttasks,items))
#       bd = threads.deferToThread(d.callback,True)
#       yield d
#       print "I HAVE THE TASKS!", len(ttasks)
       if ttasks:
          if isinstance(ttasks,ListType):
             if self.HUB:
                for ttask in ttasks:
                   yield self.Execute([ttask],items)
                ttasks20,ttasks2,items = self.Stage4bTasks()
                yield self.Execute(ttasks20,[])
                yield self.Execute(ttasks2,items)
             elif not self.HUB and self.NP:
                yield self.Execute(ttasks,items,serial=1)
             elif self.HUB:
                N = len(ttasks)
                if N:
#                   Nd = []
#                   while len(Nd) < N: [Nd.append(k) for k in randint(0,N,N) if k not in Nd]
                   Nd = numpy.random.permutation(N)
                   ttasks = [ttasks[j] for j in Nd]
                   yield self.Execute(ttasks,items)
#                   if self.HUB: yield self.Execute(ttasks,items)
#                   else: yield self.Execute(ttasks,items,serial=1)
                   self.Clear()
                   ttasks20,ttasks2,items = self.Stage4bTasks()
                   yield self.Execute(ttasks20,[])
                   yield self.Execute(ttasks2,items)
#                   if self.HUB: yield self.Execute(ttasks2,items)
#                   else: yield self.Execute(ttasks2,items)
       ttasks3 = self.Stage4c()
       if ttasks3:
          yield self.Execute(ttasks3,[])
#          os._exit(1)

   def Stage4bTasks(self):
       ttasks0 = []
       ttasks = []
       items = []
       if 1 or self.newstacks:
          Exposures = self.UseExposures
          Exposures = [E for E in Exposures if not E.bad]
          fsky = array([e.sky for e in Exposures])
          bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
          if Exposures[0].sky:
             bab = 0
             fsky = zeros(fsky.shape)
          if bab:
             Exposures = [E for E in Exposures if not E.sky]
          ttasks0 = []
          items0 = []
          for chip in self.chips:
             cnames = [Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip)) for no1,no2 in zip(self.no1s,self.no2s)]
             snames = [Exposures[0].scratch("Stack%s_%d_%dc%dsig.fits" % (self.stage,no1,no2,chip)) for no1,no2 in zip(self.no1s,self.no2s)]
             enames = [Exposures[0].scratch("Stack%s_%d_%dc%dmap.fits" % (self.stage,no1,no2,chip)) for no1,no2 in zip(self.no1s,self.no2s)]
             items0 += cnames
             scale = Exposures[0].scale
             catalog = lambda cname: cname.replace(".fits",".cat")
             saturates = []
             for cname,sname,ename,no1,no2 in zip(cnames,snames,enames,self.no1s,self.no2s):
                ttasks0 += [TwistedTask(-1,"Assemble",t1) for t1 in [cname,sname,ename]]
                F = [FITS(eval("E.sfits%s"%(self.stage))(chip)) for E in Exposures if no1 <= E.expno <= no2]
                exptimes = [f["exptime"] for f in F]
                [f.close() for f in F]
                saturates.append( 50e3 * len(exptimes) / sum(exptimes))
             ttasks += [TwistedTask(-1,"Sextractor",cname,catalog(cname),scale=scale,saturate=saturate,thresh=2.0,seeing=3*scale,segm=1) for cname,saturate in zip(cnames,saturates)]
             ttasks += [TwistedTask(-1,"MakeThumbnail",cname,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for cname in cnames]
             ttasks += [TwistedTask(-1,"MakeThumbnail",sname,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for sname in snames]
             ttasks += [TwistedTask(-1,"MakeThumbnail",ename,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for ename in enames]
             ttasks += [TwistedTask(-1,"MakeThumbnail",cname,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for cname in cnames]
             ttasks += [TwistedTask(-1,"MakeThumbnail",sname,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for sname in snames]
             ttasks += [TwistedTask(-1,"MakeThumbnail",ename,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for ename in enames]
             items += cnames
#          if ttasks0: yield self.Execute(ttasks0,items0,serial=not self.HUB)
       return ttasks0,ttasks,items

   def Stage4c(self):
       Exposures = self.UseExposures
       Exposures = [E for E in Exposures if not E.bad]
       fsky = array([e.sky for e in Exposures])
       bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
       if Exposures[0].sky:
          bab = 0
          fsky = zeros(fsky.shape)
       if bab:
          Exposures = [E for E in Exposures if not E.sky]
       ttasks = []
       for chip in self.chips:
          name = Exposures[0].scratch("Stack%sc%d.fits" % (self.stage,chip))
          name2 = Exposures[0].scratch("Stack%sc%dsig.fits" % (self.stage,chip))
          catalog = Exposures[0].scratch("Stack%sc%d.cat" % (self.stage,chip))
          if self.newstacks or not FileCheck(name) or not FileCheck(name2) or not FileCheck(catalog):
             names = [Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip)) for no1,no2 in zip(self.no1s,self.no2s)]
             names2 = [Exposures[0].scratch("Stack%s_%d_%dc%dsig.fits" % (self.stage,no1,no2,chip)) for no1,no2 in zip(self.no1s,self.no2s)]
             exptime = sum([E.exptime for E in Exposures])
             saturate = divz(50e3*len(Exposures),exptime)
             scale = Exposures[0].scale
             ttasks.append( TwistedTask(-1,"StackStacks",name,name2,catalog,names,names2,exptime,saturate,scale))
       return ttasks

   def Stage4a(self):
       if self.end > self.start:
         no1 = self.start
         no2 = self.end
       else:
         Exposures = self.UseExposures
         sky = array([E.sky for E in Exposures])
         if sum(sky) < len(sky):
            Exposures = [E for E in Exposures if not E.sky]
         no1 = Exposures[0].expno
         no2 = Exposures[-1].expno
       self.no1s = [no1]
       self.no2s = [no2]

#       if (no2-no1-1) > self.nmax:
#         nch = int((no2-no1-1)/(0.75*self.nmax) + 1)
#         print "Number of chunks=",nch
#         sch = int(1.*(no2-no1)/nch+1)
#         print "Size of chunks=",sch
#         self.no1s = arange(no1,no2,sch,int32)
#         self.no2s = self.no1s+(sch-1)
#       else:
#         self.no1s = [no1]
#         self.no2s = [no2]

   @defer.inlineCallbacks
   def Stage4Tasks(self,ttasks0,items0):
       if self.caching:
         print "Cache the images and make stacks..."
       else:
         print "Make stacks..."

       Exposures = self.UseExposures
       Exposures = [E for E in Exposures if not E.bad]
       sky = array([E.sky for E in Exposures])
       if sum(sky) < len(sky):
          Exposures = [E for E in Exposures if not E.sky]
       superNDS = [n1 for E in Exposures for n1 in self.FourCLiftDataset if E.N == n1]

       superEpck = self.UseExposures[0].scratch("superExposures.pck")
       fEpck = open(superEpck,"wb")
       cPickle.dump(Exposures,fEpck)
       fEpck.close()

       items = []
       for chip in self.chips:
           for no1,no2 in zip(self.no1s,self.no2s):
              name = Exposures[0].scratch("Stack%s_%d_%dcD.fits" % (self.stage,no1,no2))
              SubExposures = [E for E in Exposures if no1 <= E.expno <= no2]
              subNDS = [n1 for E in SubExposures for n1 in self.FourCLiftDataset if E.namec == n1.name]
              if len(subNDS) == len(superNDS): superNDS = []

              subEpck = self.UseExposures[0].scratch("subExposures%d_%d.pck"%(no1,no2))
              fEpck = open(subEpck,"wb")
              cPickle.dump(SubExposures,fEpck)
              fEpck.close()

              self.newstacks = False
              if self.doshifts or not (FileCheck(name.replace("cD.fits","c%d.fits" % (chip))) \
                and FileCheck(name.replace("cD.fits","c%d.cat" % (chip)))):
                 self.newstacks = True
#                 item = chip,subNDS,name
                 item = chip,subEpck,name
                 items.append(item)

       if items:
          if 0 and self.HUB:
#              ttasks = [TwistedTask(-1,"FourCLiftStack",item[0],item[1],name=item[2],first=self.first,second=self.second,\
#                    usemed=True,justsex=False,yskip=self.yskip/(len(item[1])/80+1),sigclip=self.sigclip,\
#                    SuperExposures=superNDS,Hub=(None,self.ssh)) for item in items]
              print "GOING TO REALLY MAKE LIST OF TASKS!"
              ttasks = []
              for j,item in enumerate(items):
                  print j
                  print item
                  print j
                  doj = []
                  yield FourCLiftStack(item[0],item[1],name=item[2],first=self.first,second=self.second,
                    usemed=True,justsex=False,yskip=self.yskip/(len(item[1])/80+1),sigclip=self.sigclip,
                    SuperExposures=superEpck,Hub=(1,self.ssh),create=1,doj=doj)
                  ttasks += doj
              print "DID WE REALLY MAKE LIST OF TASKS?",len(ttasks)
              print "go!"
#                  print asizeof(ttasks[-1])
#                  raw_input()
          elif self.HUB:
              ne = len(Exposures)
              ttasks = [TwistedTask(-1,"FourCLiftStack",item[0],item[1],name=item[2],first=self.first,second=self.second,
                    usemed=True,justsex=False,yskip=self.yskip/(len(item[1])/80+1),sigclip=self.sigclip,
                    SuperExposures=superEpck,Hub=(self.HUB,self.ssh),NP=0) for item in items]
#              EvalTask(ttasks[0])
              for t in ttasks: t.local = True
          elif self.HUB and self.NP:
              ne = len(Exposures)
              uNP = min([int(self.NP*(80.0/ne)+0.5),self.NP/2])
              ttasks = [TwistedTask(-1,"FourCLiftStack",item[0],item[1],name=item[2],first=self.first,second=self.second,
                    usemed=True,justsex=False,yskip=self.yskip/(len(item[1])/80+1),sigclip=self.sigclip,
                    SuperExposures=superEpck,Hub=None,NP=uNP) for item in items]
          else:
              ttasks = lambda item: FourCLiftStack(item[0],item[1],name=item[2],first=self.first,second=self.second,
                    usemed=True,justsex=False,yskip=self.yskip/(len(item[1])/80+1),sigclip=self.sigclip,
                    SuperExposures=superEpck,Hub=(self.HUB,self.ssh))
       else:
          ttasks = None
          items = []

       if ttasks: [ttasks0.append(t) for t in ttasks]
       if items: [items0.append(i) for i in items]
       return
#       return ttasks,items

   @defer.inlineCallbacks
   def Stage5(self):
       self.current = 5
       d = defer.Deferred()
       d.addCallback(lambda result: self.Stage5Tasks())
       bd = threads.deferToThread(d.callback,True)
       yield d

   @defer.inlineCallbacks
   def Stage5Tasks(self):
       Exposures = self.UseExposures
       Exposures = [E for E in Exposures if not E.bad]
       fsky = array([e.sky for e in Exposures])
       bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
       if Exposures[0].sky:
          bab = 0
          fsky = zeros(fsky.shape)
       if bab:
          Exposures = [E for E in Exposures if not E.sky]

       nastro = sum([len(glob(Exposures[0].scratch("Stack%s_%d_%dc?.soln" % (self.stage,no1,no2)))) for no1,no2 in zip(self.no1s,self.no2s)])
       self.calib = nastro < (len(self.no1s)*len(self.chips))
       F = [FITS(Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,c))) for no1,no2 in zip(self.no1s,self.no2s) for c in self.chips]
       astrom = [f["astrom"]=="T" for f in F if f["astrom"] != "T"]
       if self.nfilt[0] in ["J","H","K"]:
          zpts = [f["photzpt"]!="N/A" for f in F if f["photzpt"] == "N/A"]
       else:
          zpts = []
       [f.close() for f in F]
       self.calib = self.calib or (len(astrom) < len(F)) or len(zpts)

       print "Patch up the astrometry, get the calibration, and make mosaics..."
       if self.calib or self.newstacks:
          dat = Exposures[0].scratch("psc.dat")
          sim = Exposures[0].scratch("psc.sim")
          pho = Exposures[0].scratch("psc.pho")
          
          if not FileCheck(Exposures[0].scratch("multiastro%s.out" % (self.stage))) or not FileCheck(sim):

             name = Exposures[0].scratch("Stack%sc?.fits" % (self.stage)).replace(" ","\\ ")
             commands = []
             if self.fclass == "newfirm":
                command = "newfirm2soln %s" % (name)
             elif self.fclass == "fourstar":
                command = "fourstar2soln %s" % (name)
             commands.append(command)
             ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

             print "number of soln files=",len(glob(Exposures[0].scratch("Stack%sc?.soln" % (self.stage))))

             @defer.inlineCallbacks
             def go():
                def go0(x=1):
                    while x==1:
                       x=0
                       time.sleep(0.2)
                       yield self.Execute(ttasks,[])
                co = task.cooperate(go0())
                yield co.whenDone()
             yield go()

             print "number of soln files=",len(glob(Exposures[0].scratch("Stack%sc?.soln" % (self.stage))))

             if not os.path.exists(sim):
                command = "get2mass %s -o %s" % (name,dat.replace(" ","\\ "))
                ttasks = [TwistedTask(-1,"verbex",command)]

                @defer.inlineCallbacks
                def go():
                   def go0(x=1):
                       while x==1:
                          x=0
                          time.sleep(0.2)
                          yield self.Execute(ttasks,[])
                   co = task.cooperate(go0())
                   yield co.whenDone()
                yield go()

             print "number of soln files=",len(glob(Exposures[0].scratch("Stack%sc?.soln" % (self.stage))))

             pgdev = (Exposures[0].scratch("multiastro%s.ps" % (self.stage))+"/vcps").replace(" ","\\ ")
             os.environ["PGPLOT_DEV"] = pgdev
             name = Exposures[0].scratch("Stack%sc\\?.fits" % (self.stage)).replace(" ","\\ ")
             command = "MultiSetup -v -pgdev %s -pgsize 6.5 -n 20  %s -s cat -astro %s -nosex -mtol 1.0 -stol 1.0 -atol 1.0 > " % (os.environ["PGPLOT_DEV"],name,sim.replace(" ","\\ "))
             command += Exposures[0].scratch("multiastro%s.out" % (self.stage)).replace(" ","\\ ")

             ttasks = [TwistedTask(-1,"verbex",command)]

             @defer.inlineCallbacks
             def go():
                def go0(x=1):
                    while x==1:
                       x=0
                       time.sleep(0.2)
                       yield self.Execute(ttasks,[])
                co = task.cooperate(go0())
                yield co.whenDone()
             yield go()
             pstopng(pgdev.replace("/vcps",""))

             commands = []
             for chip in self.chips:
               name = Exposures[0].scratch("Stack%sc%d.fits" % (self.stage,chip)).replace(" ","\\ ")
               sname = Exposures[0].scratch("Stack%sc%d.soln" % (self.stage,chip)).replace(" ","\\ ")
               command = "soln2sip %s %s" % (name,sname)
               commands.append(command)
             ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

             @defer.inlineCallbacks
             def go():
                def go0(x=1):
                    while x==1:
                       x=0
                       time.sleep(0.2)
                       yield self.Execute(ttasks,[])
                co = task.cooperate(go0())
                yield co.whenDone()
             yield go()

             for chip in self.chips:
               name = Exposures[0].scratch("Stack%sc%d.fits" % (self.stage,chip))
               F = FITS(name,readonly=0)
               F["astrom"] = "T"
               F.close()

          for no1,no2 in zip(self.no1s,self.no2s):

              F = [FITS(Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip)),readonly=0) for chip in self.chips]
              photzpts = [f.name() for f in F if f["photzpt"] == "N/A"]
              [f.close() for f in F]
              if len(photzpts) or not FileCheck(Exposures[0].scratch("multiastro%s_%d_%d.out" % (self.stage,no1,no2))):
                 SubExposures = [E for E in Exposures if no1 <= E.expno <= no2]

                 name = Exposures[0].scratch("Stack%s_%d_%dc?.fits" % (self.stage,no1,no2)).replace(" ","\\ ")
                 commands = []
                 if self.fclass == "newfirm":
                    command = "newfirm2soln %s" % (name)
                 elif self.fclass == "fourstar":
                    command = "fourstar2soln %s" % (name)
                 commands.append(command)
                 ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

                 print "number of soln files=",len(glob(Exposures[0].scratch("Stack%s_%d_%dc?.soln" % (self.stage,no1,no2))))

                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()

                 print "number of soln files=",len(glob(Exposures[0].scratch("Stack%s_%d_%dc?.soln" % (self.stage,no1,no2))))

                 pgdev = (Exposures[0].scratch("multiastro%s_%d_%d.ps" % (self.stage,no1,no2))+"/vcps").replace(" ","\\ ")
                 os.environ["PGPLOT_DEV"] = pgdev
                 name = Exposures[0].scratch("Stack%s_%d_%dc\\?.fits" % (self.stage,no1,no2)).replace(" ","\\ ")
                 command = "MultiSetup -v -pgdev %s -pgsize 6.5 -n 20 %s -s cat -astro %s -nosex -mtol 1.0 -stol 1.0 -atol 1.0 >" % (os.environ["PGPLOT_DEV"],name,sim.replace(" ","\\ "))
                 command += Exposures[0].scratch("multiastro%s_%d_%d.out" % (self.stage,no1,no2)).replace(" ","\\ ")
                 ttasks = [TwistedTask(-1,"verbex",command)]

                 print "number of soln files=",len(glob(Exposures[0].scratch("Stack%s_%d_%dc?.soln" % (self.stage,no1,no2))))
                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()
                 pstopng(pgdev.replace("/vcps",""))

                 print "number of soln files=",len(glob(Exposures[0].scratch("Stack%s_%d_%dc?.soln" % (self.stage,no1,no2))))

                 commands = []
                 for chip in self.chips:
                   name = Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip)).replace(" ","\\ ")
                   sname = Exposures[0].scratch("Stack%s_%d_%dc%d.soln" % (self.stage,no1,no2,chip)).replace(" ","\\ ")
                   command = "soln2sip %s %s" % (name,sname)
                   commands.append(command)
                 ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()

                 for chip in self.chips:
                   name = Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip))
                   F = FITS(name,readonly=0)
                   F["astrom"] = "T"
                   F.close()

                 commands = []
                 for chip in self.chips:
                   name = Exposures[0].scratch("Stack%s_%d_%dc%d.cat" % (self.stage,no1,no2,chip)).replace(" ","\\ ")
                   command = "sex2sim -a %s" % (name)
                   commands.append(command)
                 ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()

                 commands = []
                 for chip in self.chips:
                   name = Exposures[0].scratch("Stack%s_%d_%dc%d.cat" % (self.stage,no1,no2,chip)).replace(" ","\\ ")
                   command ="Assign -tol 1.5 -sky %s %s" % (sim.replace(" ","\\ "),name)
                   commands.append(command)
                 ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()

                 exptime = sum([E.exptime for E in SubExposures])
                 if self.fclass == "newfirm":
                    gain = 8*exptime*len(SubExposures)
                    hi = 1e3
                 elif self.fclass == "fourstar":
                    if SubExposures[0].gain[0] == "F":
                       gain = 2.5*exptime*len(SubExposures)*len(SubExposures[0].loop)
                    elif SubExposures[0].gain[0] == "L":
                       gain = 1.3*exptime*len(SubExposures)*len(SubExposures[0].loop)
                    hi = divz(50e3*len(SubExposures),exptime)

                 commands = []
                 for chip in self.chips:
                     name = Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip)).replace(" ","\\ ")
                     command = "apphot %s -catsuf std -sig sig -hi %f -lo -5e5 -g %.3f -ap apertures.dat" % (name,hi,gain)
                     commands.append(command)
                 ttasks = [TwistedTask(-1,"verbex",command) for command in commands]

                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()

#                 pgdev = Exposures[0].scratch("gcurve%s_%d_%d.ps" % (self.stage,no1,no2))+"/vcps"
#                 os.environ["PGPLOT_DEV"] = pgdev
                 name = Exposures[0].scratch("Stack%s_%d_%dc?.mag" % (self.stage,no1,no2)).replace(" ","\\ ")
                 pgdev = Exposures[0].scratch("Stack%s_%d_%dc?_cur.ps" % (self.stage,no1,no2)).replace(" ","\\ ")
                 command = "gcurve -q %s -e 0.10 -p 2 -c 3 -v -ext 2 -lo 13 -hi 23 -pgdev %s" % (name,os.environ["PGPLOT_DEV"])
                 ttasks = [TwistedTask(-1,"verbex",command)]

                 @defer.inlineCallbacks
                 def go():
                    def go0(x=1):
                        while x==1:
                           x=0
                           time.sleep(0.2)
                           yield self.Execute(ttasks,[])
                    co = task.cooperate(go0())
                    yield co.whenDone()
                 yield go()
#                 pstopng(pgdev.replace("/vcps",""))

                 if self.nfilt[0] in ["J","H","K"] or 1:
                    pgdev = (Exposures[0].scratch("calphot%s_%d_%d.ps" % (self.stage,no1,no2))+"/vcps").replace(" ","\\ ")
                    os.environ["PGPLOT_DEV"] = pgdev
                    os.environ["PGPLOT_SIZE"] = "11"
                    name = Exposures[0].scratch("Stack%s_%d_%dc?.cor" % (self.stage,no1,no2)).replace(" ","\\ ")
                    cal = Exposures[0].scratch("psc%s_%d_%d.cal" % (self.stage,no1,no2)).replace(" ","\\ ")
                    calout = Exposures[0].scratch("calphot%s_%d_%d.out" % (self.stage,no1,no2)).replace(" ","\\ ")
                    if self.nfilt[0] == "K" or self.nfilt == "NB-2.09":
                       bright = 13.0
                       faint = 16.0
                       ufilt = "K"
                       ccolor = "J,K"
                    else:
                       if self.fclass == "newfirm":
                          bright = 13.0
                          faint = 16.0
                       elif self.fclass == "fourstar":
                          bright = 13.0
                          faint = 16.0
                       if self.nfilt[0] == "J" or self.nfilt == "NB-1.18": ufilt = "J"
                       elif self.nfilt[0] == "H": ufilt = "H"
                       ccolor = "%s,K" % (ufilt)
                    command="calphot %s -pho %s -n 1 -N 1 -min 4 -filtkey None -bright %f -faint %f -filter %s -nocolor -color %s -mcolor 0.9 -chi 5e3 -err 0.15 -nox -o %s -d %s -s %s > %s" % (name,pho,bright,faint,ufilt,ccolor,cal,os.environ["PGPLOT_DEV"],os.environ["PGPLOT_SIZE"],calout)
                    ttasks = [TwistedTask(-1,"verbex",command)]

                    @defer.inlineCallbacks
                    def go():
                       def go0(x=1):
                           while x==1:
                              x=0
                              time.sleep(0.2)
                              yield self.Execute(ttasks,[])
                       co = task.cooperate(go0())
                       yield co.whenDone()
                    yield go()
                    pstopng(pgdev.replace("/vcps",""))

                    if os.path.exists(cal) and os.stat(cal)[6]:
                       cal = readtable(cal)
                       F = [FITS(Exposures[0].scratch("Stack%s_%d_%dc%d.fits" % (self.stage,no1,no2,chip)),readonly=0) for chip in self.chips]
                       [f.modkey("photzpt",cal[2][0]) for f in F]
                       [f.close() for f in F]

   @defer.inlineCallbacks
   def Stage6(self):
       self.current = 6
       if self.fclass == "newfirm": scale = 0.4
       elif self.fclass == "fourstar": scale = 0.16

       Exposures = self.UseExposures
       Exposures = [E for E in Exposures if not E.bad]
       sky = array([E.sky for E in Exposures])
       if sum(sky) < len(sky):
          Exposures = [E for E in Exposures if not E.sky]

       if len(self.no1s) > 1:
          for no1,no2 in zip(self.no1s,self.no2s):

              SubExposures = [E for E in Exposures if no1 <= E.expno <= no2]

              name = Exposures[0].scratch("Stack%s_%d_%dc?.fits" % (self.stage,no1,no2))
              name2 = Exposures[0].scratch("Mosaic%s_%d_%d.fits" % (self.stage,no1,no2))
              print "Make the Mosaic",name
              if len(self.chips) > 1 and not FileCheck(name2.replace(".fits",".cat")):
                 if 0 and self.nfilt in ["J","H","Ks"]: photoff = "-photoff photzpt"
                 else: photoff = ""
                 if self.HUB:
                    LHUB = getattr(self,"LHUB",self.HUB)
                    command="ImageRect %s -o %s -HUB %s -mport %d -scale %f -step 512 -nointerp -v %s" % (name.replace(" ","\\ "),name2.replace(" ","\\ "),LHUB,self.pset+6022,scale,photoff)
                 else:
                    command="ImageRect %s -o %s -fork %d -scale %f -step 512 -nointerp -v %s" % (name.replace(" ","\\ "),name2.replace(" ","\\ "),self.NP,scale,photoff)
                 task = TwistedTask(-1,"verbex",command)
                 if self.HUB: task.local = True
                 yield self.Execute([task],[])

                 exptime = sum([E.exptime for E in SubExposures])
                 if self.fclass == "newfirm":
                    saturate = divz(50e3*len(SubExposures),exptime)
                 elif self.fclass == "fourstar":
                    saturate = divz(60e3*len(SubExposures),exptime)
                 task = TwistedTask(-1,"Sextractor",name2,name2.replace(".fits",".cat"),scale=scale,saturate=saturate,thresh=2.0,seeing=3*scale,segm=1)
                 yield self.Execute([task],[])


       names = Exposures[0].scratch(" ".join(["Stack%s_%d_%dc?.fits" % (self.stage,no1,no2) for no1,no2 in zip(self.no1s,self.no2s)]))
       name = Exposures[0].scratch("Mosaic%s.fits" % (self.stage))
       png = Exposures[0].scratch("Mosaic%s.png" % (self.stage))
       print "Make the Mosaic",name
       if len(self.chips) > 1 and not (FileCheck(name) \
               and FileCheck(name.replace(".fits",".cat")) \
               and FileCheck(name.replace(".fits",".png"))) \
               or self.calib or self.newstacks:
          if 0 and self.nfilt in ["J","H","Ks"]: photoff = "-photoff photzpt"
          else: photoff = ""
          if self.HUB:
             LHUB = getattr(self,"LHUB",self.HUB)
             command="ImageRect %s -o %s -HUB %s -mport %d -scale %f -step 512 -nointerp -v %s" % (names.replace(" ","\\ "),name.replace(" ","\\ "),LHUB,self.pset+6022,scale,photoff)
          else:
             command="ImageRect %s -o %s -fork %d -scale %f -step 512 -nointerp -v %s" % (names.replace(" ","\\ "),name.replace(" ","\\ "),self.NP,scale,photoff)
          task = TwistedTask(-1,"verbex",command)
          if self.HUB: task.local = True
          yield self.Execute([task],[])

          exptime = sum([E.exptime for E in Exposures])
          if self.fclass == "newfirm":
             saturate = divz(50e3*len(Exposures),exptime)
          elif self.fclass == "fourstar":
             saturate = divz(60e3*len(Exposures),exptime)
          tasks = [ TwistedTask(-1,"Sextractor",name,name.replace(".fits",".cat"),scale=scale,saturate=saturate,thresh=2.0,seeing=3*scale,segm=1)]
          tasks += [TwistedTask(-1,"MakeThumbnail",name,mag=1,pct=40,z1=0,z2=0,s1=-10,s2=10,inv=1)]
          tasks += [TwistedTask(-1,"MakeThumbnail",name,mag=8,pct=40,z1=0,z2=0,s1=-10,s2=10,inv=1)]
          yield self.Execute(tasks,[])

   @defer.inlineCallbacks
   def Stage6tmp(self):
       self.current = 6
       if self.fclass == "newfirm": scale = 0.4
       elif self.fclass == "fourstar": scale = 0.16

       Exposures = self.UseExposures
       Exposures = [E for E in Exposures if not E.bad]

       names = glob(self.basedir+"/Science/"+self.zdir+"/"+self.targ+"_tmp*/Stack%s_*_*c[1,2,3,4].fits" % (self.stage))
       names.sort()
       print "Constructing mosaic with stuff from the tmp targets:"
       print names
       names = " ".join(names)
       name = Exposures[0].scratch("Mosaic%s.fits" % (self.stage))
       if len(self.chips) > 1 and not (FileCheck(name) \
               and FileCheck(name.replace(".fits",".cat"))) \
               or self.calib or self.newstacks:
          if 0 and self.nfilt in ["J","H","Ks"]: photoff = "-photoff photzpt"
          else: photoff = ""
          if self.HUB:
             LHUB = getattr(self,"LHUB",self.HUB)
             command="ImageRect %s -o %s -HUB %s -mport %d -scale %f -step 512 -nointerp -v %s" % (names.replace(" ","\\ "),name.replace(" ","\\ "),LHUB,self.pset+6022,scale,photoff)
          else:
             command="ImageRect %s -o %s -fork %d -scale %f -step 512 -nointerp -v %s" % (names.replace(" ","\\ "),name.replace(" ","\\ "),self.NP,scale,photoff)
          task = TwistedTask(-1,"verbex",command)
          if self.HUB: task.local = True
          yield self.Execute([task],[])

          exptime = sum([E.exptime for E in Exposures])
          if self.fclass == "newfirm":
             saturate = divz(50e3*len(Exposures),exptime)
          elif self.fclass == "fourstar":
             saturate = divz(60e3*len(Exposures),exptime)
          tasks = [ TwistedTask(-1,"Sextractor",name,name.replace(".fits",".cat"),scale=scale,saturate=saturate,thresh=2.0,seeing=3*scale,segm=1)]
          tasks += [TwistedTask(-1,"MakeThumbnail",name,mag=1,pct=40,z1=0,z2=0,s1=-10,s2=10,inv=1)]
          tasks += [TwistedTask(-1,"MakeThumbnail",name,mag=8,pct=40,z1=0,z2=0,s1=-10,s2=10,inv=1)]
          yield self.Execute(tasks,[])


   def Stage7(self):
       self.current = 7
       name = self.UseExposures[0].scratch("Mosaic%s.fits" % (self.stage))
       catalog = name.replace(".fits",".cat")
       pgdev = name.replace(".fits",".ps/vcps")
       if not FileCheck(name.replace(".fits",".png")):
          d = readsex(catalog)
          mag = d["MAG_APER"]
          opendev(pgdev,nx=2,ny=2,land=0,asp=1,size=6.5)
          mm = [median(mag)-7,median(mag)+2]

          newbox(mm,[0.0,10.0],ch=2)
          xlabel("MAG_APER",ch=2)
          ylabel("FWHM (pixels)",ch=2)
          drawpt(d["MAG_APER"],d["FWHM_IMAGE"],ps=17,ch=2,ci=1)

          newbox(mm,[0.0,1.0],ch=2)
          xlabel("MAG_APER",ch=2)
          ylabel("MAGERR_APER",ch=2)
          drawpt(d["MAG_APER"],d["MAGERR_APER"],ps=17,ch=2,ci=1)
          closedev()
          pstopng(pgdev.replace("/vcps",""))

       if not self.makeflat:
          self.success = 1
          self.current = 8

   @defer.inlineCallbacks
   def Stage8(self):
       self.current = 8
       [self.cats.setdefault(chip,None) for chip in self.chips]
       ttasks,items = self.Stage8Tasks()
       newmode = False
       if ttasks:
          yield self.Execute(ttasks,items)
          newmode = True

       if len(self.chips) == 1: skyplot = self.UseExposures[0].scratch("skyplot0c%d.png" % (self.chips[0]))
       else: skyplot = self.UseExposures[0].scratch("skyplot0.png")
       if newmode or not FileCheck(skyplot):
          print "Check consistency of the medians..."
          t = TwistedTask(-1,"PlotModes",self.UseExposures,self.chips,first=0,second=0,flat=self.flat)
#          t.local = True
          print "Have PlotModes task",t
          yield self.Execute([t],[])
       [E.Bad() for E in self.UseExposures]


   def Stage8Tasks(self):
       print "Pulling the individual frames out, doing quick stats..."
       Exposures = self.UseExposures
#       print Exposures
#       reactor.callFromThread(reactor.stop)
#       raise IOError( "TEST!")
       easydir(Exposures[0].scratch("mode0"))
       fsky = array([e.sky for e in Exposures])
       bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
       if Exposures[0].sky:
          bab = 0
          fsky = zeros(fsky.shape)
       if not self.first:
          easydir(Exposures[0].scratch("mask"+str(int(self.stage))))
          easydir(Exposures[0].scratch("pers"+str(int(self.stage))))

       self.newmode = False
       items = []
       coll0 = {}
       coll = {}
       for chip in self.chips:
          if chip not in coll:
             coll0[chip] = []
             coll[chip] = []
          for j,E in enumerate(self.UseExposures):
              coll0[chip].append(E)
              if (not bab or bab and not E.sky) and not FileCheck(eval("E.mfits0")(chip)):
                 item = [E,chip]
                 loopno = E.loopno
                 coll[chip].append(E)
                 if j>=loopno and not self.flat and not self.dark:
                     item.append(self.UseExposures[(j-loopno)])
                 elif j<(len(self.UseExposures)-loopno) and not self.flat and not self.dark:
                     item.append(self.UseExposures[(j+loopno)])
                 else:
                     item.append(None)
                 items.append(item)
                 if not self.cats.get(chip,None):
                    self.GetStackCat(chip)

       if items:
          if self.HUB:
             ttasks=[TwistedTask(-1,"lambda *args,**kw: args[0].Mode(*args[1:],**kw)",\
                Echip[0],Echip[1],other=Echip[2],first=0,second=0,msh=self.msh,\
                cat=self.cats[Echip[1]],histo=self.histo,mag=self.mag,\
                flat=self.flat,verb=self.verb) \
                for j,Echip in enumerate(items)]
          else:
             ttasks=lambda Echip: Echip[0].Mode(Echip[1],other=Echip[2],\
                first=0,second=0,msh=self.msh,\
                cat=self.cats[Echip[1]],histo=self.histo,mag=self.mag,\
                flat=self.flat,verb=self.verb)
       else:
          ttasks=None

       return ttasks,items

   @defer.inlineCallbacks
   def Stage9(self):
       self.current = 9
       if self.makepupil or self.flat:
          print "Get tasks to make pupil ghost images!"
          if self.flat:
             ttasks1,items1 = self.Stage9TasksRunning(s=1)
          else:
             ttasks1,items1 = self.Stage9TasksRunning()
          print "Execute tasks to make pupil ghost images!"
          if len(ttasks1):
             yield self.Execute(ttasks1,[],serial=getattr(ttasks1[0],"local",False))
          n = multiply.reduce([FileCheck(f) for f in items1])
          print "Are the pupil ghost images here?"
          print items1
          print [FileCheck(f) for f in items1]
          print "Make jpegs of the pupil ghost images!"
          ttasks1b = [TwistedTask(-1,"MakeThumbnail",item,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
          yield self.Execute(ttasks1b,[],serial=not self.HUB)
          ttasks1c = [TwistedTask(-1,"MakeThumbnail",item,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
          yield self.Execute(ttasks1c,[],serial=not self.HUB)

   def Stage9TasksRunning(self,s=0):
       d = self.UseExposures[0].scratch("mode%d"%(s)).replace(" ","\\ ")
       dp = self.UseExposures[0].scratch("")
       p = lambda c: "%s/pupil%sc%d.fits" % (dp.replace(" ","\\ "),self.nfilt,c)
       LHUB = getattr(self,"LHUB",self.HUB)
#       command = lambda chip: "pupilfit -HUB %s %s %d %s"%(LHUB,d,chip,p(chip))
       command = lambda chip: "pupilfit %s -chip %d -o %s -NP %d"%(d,chip,p(chip),self.NP)
#       command = lambda chip: "pupil %s %d %s"%(d,chip,p(chip))
       ttasks1 = [TwistedTask(-1,"verbex",command(chip)) for chip in self.chips if not FileCheck(p(chip))]
       if "HUB" in command(1):
          [setattr(t,"local",True) for t in ttasks1]
       items1 = [p(chip) for chip in self.chips]
       return ttasks1,items1

   @defer.inlineCallbacks
   def StageA(self):
       self.current = 10
       if self.flat:
          newflat = False
          sdir = "%s/Flats/%s" % (self.basedir,self.targ)
          easydir(sdir)
          ttasks = []
          items1 = []
          for chip in self.chips:
              o = "%s/pupil%sc%dflat.fits" % (sdir,self.nfilt,chip)
              c = "%s/sky1/Flat%sc%d.fits" % (sdir,self.nfilt,chip)
              if not FileCheck(c): newflat = True
              if (newflat or (FileCheck(c) != FileCheck(o))) and FileCheck(o):
                 ttask = TwistedTask(-1,"shutil.copyfile",o,c)
                 ttask.setModules(["shutil"])
                 ttasks.append(ttask)
                 items1.append(c)
          yield self.Execute(ttasks,[])
          if items1:
             ttasks1c = [TwistedTask(-1,"MakeThumbnail",item,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
             yield self.Execute(ttasks1c,items1,serial=not self.HUB)
             ttasks1d = [TwistedTask(-1,"MakeThumbnail",item,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
             yield self.Execute(ttasks1d,items1,serial=not self.HUB)

       elif self.makepupil:
          newflat = False
          fdir0 = "%s/Flats/%s" % (self.basedir,self.makeflat)
          easydir(fdir0)
          fdir = "%s/Flats/%s/sky1" % (self.basedir,self.makeflat)
          easydir(fdir)
          sdir = "%s/Science/%s/%s" % (self.basedir,self.zdir,self.targ)
          sdir2 = "%s/Science/%s/%s/sky0" % (self.basedir,self.zdir,self.targ)
          easydir(sdir2)
          pdir = "%s/Science/%s/%s" % (self.basedir,self.zdir,self.targ)
          qdir = "%s/Flats/%s" % (self.basedir,self.makeflat)
          ttasks = []
          items1 = []
          for chip in self.chips:
              o = "%s/pupil%sc%dflat.fits" % (sdir,self.nfilt,chip)
              c = "%s/Flat%sc%d.fits" % (sdir,self.nfilt,chip)
              if FileCheck(o): newflat = True
              if (newflat or (FileCheck(c) != FileCheck(o))) and FileCheck(o):
                 ttask = TwistedTask(-1,"shutil.copyfile",o,c)
                 ttask.setModules(["shutil"])
                 ttasks.append(ttask)
              o = "%s/pupil%sc%dflat.fits" % (sdir,self.nfilt,chip)
              c = "%s/Flat%sc%d.fits" % (fdir,self.nfilt,chip)
              if FileCheck(o): newflat = True
              if (newflat or (FileCheck(c) != FileCheck(o))) and FileCheck(o):
                 ttask = TwistedTask(-1,"shutil.copyfile",o,c)
                 ttask.setModules(["shutil"])
                 ttasks.append(ttask)
              c = "%s/Flat%sc%d.fits" % (sdir2,self.nfilt,chip)
              if (newflat or (FileCheck(c) != FileCheck(o))) and FileCheck(o):
                 ttask = TwistedTask(-1,"shutil.copyfile",o,c)
                 ttask.setModules(["shutil"])
                 ttasks.append(ttask)
                 items1.append(c)
          yield self.Execute(ttasks,[])
          if items1:
             ttasks1c = [TwistedTask(-1,"MakeThumbnail",item,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
             yield self.Execute(ttasks1c,items1,serial=not self.HUB)
             ttasks1d = [TwistedTask(-1,"MakeThumbnail",item,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
             yield self.Execute(ttasks1d,items1,serial=not self.HUB)
#          ttasks = []
#          for chip in self.chips:
#              o = "%s/pupil%sc%dmask.fits" % (sdir,self.nfilt,chip)
#              c = "%s/mask%sc%d.fits" % (sdir,self.nfilt,chip)
#              if FileCheck(o): newflat = True
#              if (newflat or (FileCheck(c) != FileCheck(o))) and FileCheck(o):
#                 ttask = TwistedTask(-1,"shutil.copyfile",o,c)
#                 ttask.setModules(["shutil"])
#                 ttasks.append(ttask)
##              c = "%s/Flat%sc%d.fits" % (fdir0,self.nfilt,chip)
##              if newflat and FileCheck(c):
##                 ttask = TwistedTask(-1,"os.remove",c)
##                 ttask.setModules(["shutil"])
##                 ttasks.append(ttask)
##              c = "%s/mask%sc%d.fits" % (fdir0,self.nfilt,chip)
##              if newflat and FileCheck(c):
##                 ttask = TwistedTask(-1,"os.remove",c)
##                 ttask.setModules(["shutil"])
##                 ttasks.append(ttask)
#          yield self.Execute(ttasks,[])
          ttasks = []
          for chip in self.chips:
              for suf in [".fits","mag01.jpg","mag08.jpg"]:
                 p = "%s/pupil%sc%d%s" % (pdir,self.nfilt,chip,suf)
                 q = "%s/pupil%sc%d%s" % (qdir,self.nfilt,chip,suf)
                 print p,FileCheck(p),q,FileCheck(q)
                 if (newflat or (FileCheck(p) != FileCheck(q))) and FileCheck(p):
                    ttask = TwistedTask(-1,"shutil.copyfile",p,q)
                    ttask.setModules(["shutil"])
                    ttasks.append(ttask)
          yield self.Execute(ttasks,[])

       elif self.makeflat:
           ttasks1,ttasks1b,items1 = self.StageATasksRunning()
           newflat = False
           if items1:
              newflat = True
              if not self.HUB:
                 yield self.Execute(ttasks1,items1,serial=1)
              else:
                 if 0 and self.HUB:
                    yield self.Execute(ttasks1b,items1)
                 elif 0 and self.NP:
                    yield self.Execute(ttasks1,items1)
                 else:
                    items1 = map(ttasks1,items1)
                    ttasks1 = []
                    [[ttasks1.append(i) for i in item[0]] for item in items1 if item]
                    N = len(ttasks1)
                    Nd = numpy.random.permutation(N)
                    ttasks1 = [ttasks1[j] for j in Nd]
                    yield self.Execute(ttasks1,items1)
                    tempframes = [item[1] for item in items1 if item]
                    skyframes = [item[2] for item in items1 if item]
                    ttasks1a = [TwistedTask(-1,"Assemble",t1) for t1 in tempframes]
                    yield self.Execute(ttasks1a,tempframes,serial=not self.HUB)
                    ttasks1b = [TwistedTask(-1,"os.rename",item[1],item[2]) for item in items1 if item]
                    yield self.Execute(ttasks1b,items1,serial=not self.HUB)
                    ttasks1c = [TwistedTask(-1,"MakeThumbnail",item[2],mag=1,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
                    yield self.Execute(ttasks1c,items1,serial=not self.HUB)
                    ttasks1d = [TwistedTask(-1,"MakeThumbnail",item[2],mag=8,pct=40,s1=-10,s2=10,inv=1,q=85) for item in items1 if item]
                    yield self.Execute(ttasks1d,items1,serial=not self.HUB)

              fdir0 = "%s/Flats/%s" % (self.basedir,self.makeflat)
              easydir(fdir0)
              fdir = "%s/Flats/%s/sky1" % (self.basedir,self.makeflat)
              easydir(fdir)
              sdir = "%s/Science/%s/%s/sky0" % (self.basedir,self.zdir,self.targ)
              pdir = "%s/Science/%s/%s" % (self.basedir,self.zdir,self.targ)
              qdir = "%s/Flats/%s" % (self.basedir,self.makeflat)
              ttasks = []
              for chip in self.chips:
                  o = "%s/Flat%sc%d.fits" % (sdir,self.nfilt,chip)
                  c = "%s/Flat%sc%d.fits" % (fdir,self.nfilt,chip)
                  print o,FileCheck(o),c,FileCheck(c)
                  if (newflat or (FileCheck(c) != FileCheck(o))) and FileCheck(o):
                     ttask = TwistedTask(-1,"shutil.copyfile",o,c)
                     ttask.setModules(["shutil"])
                     ttasks.append(ttask)
#                  c = "%s/Flat%sc%d.fits" % (fdir0,self.nfilt,chip)
#                  if newflat and FileCheck(c):
#                     ttask = TwistedTask(-1,"os.remove",c)
#                     ttask.setModules(["shutil"])
#                     ttasks.append(ttask)
#                     items1.append(c)
#                  c = "%s/mask%sc%d.fits" % (fdir0,self.nfilt,chip)
#                  if newflat and FileCheck(c):
#                     ttask = TwistedTask(-1,"os.remove",c)
#                     ttask.setModules(["shutil"])
#                     ttasks.append(ttask)
#                     items1.append(c)

              yield self.Execute(ttasks,[])

       if self.flat:
          fdir = "%s/Flats/%s" % (self.basedir,self.targ)
          nameflat = self.targ
       else:
          fdir = "%s/Flats/%s" % (self.basedir,self.makeflat)
          nameflat = self.makeflat
       if newflat or [chip for chip in self.chips if \
            (not FileCheck(fdir+"/mask"+self.nfilt+"c%dmag08.jpg" % (chip)) \
            or not FileCheck(fdir+"/Flat%sc%dmag08.jpg" % (self.nfilt,chip)))]:
          ttask = TwistedTask(-1,"FinalizeFlats",nameflat,self.nfilt,self.chips,self.UseExposures,first=1,second=0,makeflat=True)
          yield self.Execute([ttask],[])

       if self.makeflat:
          fdir = "%s/Flats/%s" % (self.basedir,self.makeflat)
          sdir = "%s/Science/%s/%s" % (self.basedir,self.zdir,self.targ)
          ttasks = []
          for chip in self.chips:
              for pre in ["Flat","mask"]:
                  for suf in [".fits","mag01.jpg","mag08.jpg"]:
                      o = "%s/%s%sc%d%s" % (sdir,pre,self.nfilt,chip,suf)
                      c = "%s/%s%sc%d%s" % (fdir,pre,self.nfilt,chip,suf)
                      print o,FileCheck(o),c,FileCheck(c)
                      if newflat or (FileCheck(c) != FileCheck(o)) and FileCheck(c):
                         ttask = TwistedTask(-1,"shutil.copyfile",c,o)
                         ttask.setModules(["shutil"])
                         ttasks.append(ttask)
          yield self.Execute(ttasks,[])

       self.success = 1
       self.current = 10

   def StageATasksRunning(self):
       items = []
       awaits = []
       skyframes = []
       nes = []
       ne30s = []
       Exposures = self.UseExposures
       fsky = array([e.sky for e in Exposures])
       bab = not self.flat and (sum(fsky) and (sum(fsky) < len(fsky)))
       if Exposures[0].sky:
          bab = 0
          fsky = zeros(fsky.shape)
       print sum(fsky),len(fsky),bab
       for chip in self.chips:
           for E in self.UseExposures:
               if (self.first and not os.path.exists(eval("E.sfits0")(chip))):
                   if not bab or not E.sky:
                      items.append((E,chip))
                      await,skyframe,ne,ne30 = E.SkySubtract(chip,self.UseExposures,\
                        first=0,second=0,sigclip=self.sigclip,flat=1,nf=self.nf,test=1)
                      awaits.append(await)
                      skyframes.append(skyframe)
                      nes.append(ne)
                      ne30s.append(ne30)

#       print items
#       print nes
#       print ne30s
#       print [os.path.basename(s) for s in skyframes]
#       print set([os.path.basename(s) for s in skyframes])
#       print awaits
#       print [os.path.basename(s) for a,s in zip(awaits,skyframes) if a]
#       print [os.path.basename(s) for a,s in zip(awaits,skyframes) if not a]
#       print
#       os._exit(1)

       sitem = [s for a,s in zip(awaits,items) if not a]
       frame = [s for a,s in zip(awaits,skyframes) if not a]
       s = {}
       for j in range(len(awaits)):
          if not awaits[j]:
             if skyframes[j] in s: awaits[j] = True
             else: s.setdefault(skyframes[j])

#       print sitem
#       print skyframes
#       print awaits
#       print items
#       print s
       if items:
          bigsky = logical_not(awaits)
          items1 = [items[j] for j in nonzero(bigsky)]
#          print
#          print items1
#          print
#          os._exit(1)

          if self.HUB:
             print "sigclip=",self.sigclip
#             os._exit(1)
             ttasks1 = lambda Echip: Echip[0].SkySubtract(Echip[1],self.UseExposures,\
                first=0,second=0,flat=1,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,\
                Hub=self.HUB,bigsky=1,NP=0)
             ttasks1b = [TwistedTask(-1,"lambda *args,**kw: args[0].SkySubtract(*args[1:],**kw)",Echip[0],Echip[1],self.UseExposures,\
                first=0,second=0,flat=1,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,\
                Hub=self.HUB,bigsky=1,NP=0) for Echip in items1]
             [setattr(t,"local",True) for t in ttasks1b]

          else:
             ttasks1 = lambda Echip: Echip[0].SkySubtract(Echip[1],self.UseExposures,\
                first=0,second=0,flat=1,nf=self.nf,verb=1,\
                yskip=self.skyskip/(len(self.UseExposures)/80+1),sigclip=self.sigclip,\
                Hub=None,bigsky=1,NP=self.NP)
             ttasks1b = None

#          if self.flat and "dark" in self.targ: items2 = []
#          elif self.flat and "flat" in self.targ: items2 = []
#          else: items2 = items
          items2 = items
#          print items1
#          print
#          print items2
#          print
#          raw_input("<< PAUSED >> ")

       else:
          ttasks1=None
          ttasks1b=None
          items1=None

       return ttasks1,ttasks1b,items1




def Die(x):
   logging.err(x)
   print "WTF?"
   reactor.callFromThread(reactor.stop)
   return failure.Failure

def Assemble(gname):
    if os.path.basename(gname)[0] == ".":
       gname1 = glob(os.path.dirname(gname)+"/"+os.path.basename(gname).replace(".fits","_????.fits"))
    else:
       gname1 = glob(os.path.dirname(gname)+"/."+os.path.basename(gname).replace(".fits","_????.fits"))
    if gname1:
       gname1.sort()
       D = []
       for gn in gname1:
          f = FITS(gn)
          D.append( f.data())
          f.close()
          os.remove(gn)
       D = concatenate(D,0)
       F = FITS(gname,readonly=0)
       F.putdata(D)
       F.close()

@defer.inlineCallbacks
def yieldAssemble(gname):
    if os.path.basename(gname)[0] == ".":
       gname1 = glob(os.path.dirname(gname)+"/"+os.path.basename(gname).replace(".fits","_????.fits"))
    else:
       gname1 = glob(os.path.dirname(gname)+"/."+os.path.basename(gname).replace(".fits","_????.fits"))
    if gname1:
       gname1.sort()
       D = []
       @defer.inlineCallbacks
       def assD():
           def getD():
               for gn in gname1:
                  f = FITS(gn)
                  D.append( f.data())
                  f.close()
                  os.remove(gn)
                  yield
           co = task.cooperate(getD())
           yield co.whenDone()
       d = defer.Deferred()
       d.addCallback(lambda x: assD())
       bd = threads.deferToThread(d.callback,True)
       yield d
       D = concatenate(D,0)
       F = FITS(gname,readonly=0)
       F.putdata(D)
       F.close()


def StackStacks(name,name2,catalog,names,names2,exptime,saturate,scale):
      print "Making",name
      F = FITS(name,create=1,template=names[0])
      F2 = FITS(name2,create=1,template=names[0])
      F.modkey("exptime",1.0)
      F2.modkey("exptime",1.0)
      G = [FITS(i) for i in names]
      G2 = [FITS(i) for i in names2]
      naxis1,naxis2 = F.naxes()
      numer = zeros((naxis2,naxis1),float64)
      denom = zeros((naxis2,naxis1),float64)
      for g1,g2 in zip(G,G2):
         d1 = g1.data()
         d2 = VTKInvert(power(g2.data(),2))
         add(numer,d1*d2,numer)
         add(denom,d2,denom)
      [g.close() for g in G]
      result = VTKDivide(numer,denom)
      result2 = VTKInvert(VTKSqrt(denom))
      F.putdata(result)
      F2.putdata(result2)
      F.close()
      F2.close()

      MakeThumbnail(name,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
      MakeThumbnail(name,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85)
      MakeThumbnail(name2,mag=1,pct=40,s1=-10,s2=10,inv=1,q=85)
      MakeThumbnail(name2,mag=8,pct=40,s1=-10,s2=10,inv=1,q=85)
      Sextractor(name,catalog,scale=scale,saturate=saturate,thresh=2.0,seeing=3*scale,segm=1)

def LoadWatcher():
    twisted_import("FourCLiftWatcher",comps=None,IMPORTS=IMPORTS,verb=1)
    pn = imp.find_module("FourCLiftWatcher")[1]
    modobj = IMPORTS[pn][0]
    for obj in dir(modobj):
        globals()[obj] = getattr(modobj,obj)

@defer.inlineCallbacks
def WatchDispatcher(dispatch):
    def loopTest():
        def taskIterate():
            while 1:
#               if dispatch.reallydone and hasattr(dispatch,"spin") and getattr(dispatch.spin.whenDone(),"result",False): break
#               else: time.sleep(0.1); yield
               if dispatch.reallydone: # and hasattr(dispatch,"kill"):
                  break
               else:
                  time.sleep(0.1)
                  yield
        return task.cooperate(taskIterate())
    co = loopTest()
    yield co.whenDone()

